#pragma GCC optimize("Ofast")
#define ON_START ios_base::sync_with_stdio(false); cin.tie(nullptr);

#include <bits/stdc++.h>

//#define int long long
#define double long double
#define endl "\n"

using namespace std;

inline int calc(int b, vector<int> a[], int j, int n) {
    int res = 0;

    for (int i = 0; i < n; ++i) {
        if(b >= a[i][j]) {
            res++;
        }
    }

    return res;
}

vector<vector<pair<int, int>>> getPairs(int n, bool can[]) {
    vector<vector<pair<int, int>>> res;
    for (int i = 0; i < n; ++i) {
        if(can[i]) {
            can[i] = false;
            for (int j = i + 1; j < n; ++j) {
                if(can[j]) {
                    can[j] = false;

                    auto _ = getPairs(n, can);

                    for (const auto &v : _) {
                        vector<pair<int, int>> add;
                        add.emplace_back(i, j);
                        for (auto val : v) {
                            add.push_back(val);
                        }
                        res.push_back(add);
                    }

                    can[j] = true;
                }
            }
            can[i] = true;
        }
    }

    if(res.empty()) {
        res.emplace_back();
    }

    return res;
}

inline bool checkRasb(const vector<pair<int, int>> &rasb, int k, vector<int> a[]) {
    for (int i = 0; i < k; ++i) {
        int b = INT32_MIN;
        for (auto &p : rasb) {
            b = max(b, min(a[p.first][i], a[p.second][i]));
        }

        for (const auto p : rasb) {
            if(!(min(a[p.first][i], a[p.second][i]) <= b && max(a[p.first][i], a[p.second][i]) >= b)) {
                return false;
            }
        }
    }

    return true;
}

int32_t main() {
    ON_START

    int n, k;
    cin >> n >> k;

    vector<int> a[n];
    for (int i = 0; i < n; ++i) {
        a[i].resize(static_cast<unsigned int>(k));
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
        }
    }

    if(k == 1) {
        int l, r;
        l = INT32_MIN / 2 + 1, r = INT32_MAX / 2 - 1;
        while(r != l + 1) {
            int m = (l + r) / 2;

            if(calc(m, a, 0, n) <= n / 2) {
                l = m;
            } else {
                r = m;
            }
        }

        if(calc(l, a, 0, n) == n / 2) {
            vector<int> f;
            vector<int> s;

            for (int i = 0; i < n; ++i) {
                if(a[i][0] < l) {
                    f.push_back(i);
                } else {
                    s.push_back(i);
                }
            }

            cout << "YES\n";
            for (int i = 0; i < f.size(); ++i) {
                cout << f[i] + 1 << " " << s[i] + 1 << endl;
            }
        } else {
            cout << "NO\n";
        }
    } else {
        bool can[n];
        for (int i = 0; i < n; ++i) {
            can[i] = true;
        }
        vector<vector<pair<int, int>>> pairs = getPairs(n, can);

        for (const auto &rasb : pairs) {
            if(checkRasb(rasb, k, a)) {
                cout << "YES\n";
                for (auto p : rasb) {
                    cout << p.first + 1 << " " << p.second + 1 << endl;
                }
                return 0;
            }
        }

        cout << "NO\n";
    }

    return 0;
}