#include <bits/stdc++.h>

using namespace std;

#define ALL(x) (x).begin(), (x).end()
#define BALL(x) (x).rbegin(), (x).rend()
#define LAST(x) (x)[(x).size() - 1]

//#define DEBUG
#ifdef DEBUG
ifstream _in("debug.in");
#define cin _in
#endif

#define int long long
//#define endl '\n'
#define INF 1e15+7
const int MOD = 1e9+7;

void next_entry(vector<int>& entry) {
	int i = entry.size() - 1;
	vector<int> stack;
	while (i > 0 && entry[i] < entry[i - 1]) {
		stack.push_back(entry[i]);
		--i;
	}
	if (i == 0) {
		entry.clear();
		return;
	}
	stack.push_back(entry[i]);
	sort(ALL(stack));
	for (int j = 0; j < stack.size(); ++j) {
		if (stack[j] > entry[i - 1]) {
			stack.push_back(entry[i - 1]);
			entry[i - 1] = stack[j];
			break;
		}
	}
	int k = 0;
	for (auto e : stack) {
		if (e != entry[i - 1]) {
			entry[i + k] = e;
			++k;
		}
	}
}

vector<vector<int>> generate_poses(int n) {
	int k = 0;
	vector<vector<int>> res;
	vector<int> entry;
	for (int i = 0; i < n; ++i)
		entry.push_back(i);
	while (entry.size() > 0) {
		res.push_back(entry);
		next_entry(entry);
		++k;
		if (k == 1000) break;
	}
	return res;
}

signed main() {
	ios_base::sync_with_stdio(false);
	
	int n, k;
	cin >> n >> k;
	vector<vector<int>> a(n, vector<int>(k + 1));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
		}
		a[i][k] = i + 1;
	}
	sort(ALL(a));
	/*for (auto e : a) {
		for (auto j : e) {
			cout << j << ' ';
		} cout << endl;
	}*/
	int half = n / 2;
	if (k == 1) {
		cout << "YES" << endl;
		for (int i = 0; i < half; ++i) {
			cout << a[i][k] << ' ' << a[i + half][k] << endl;
		}
	}
	else {
		vector<vector<int>> halfs(n, vector<int>(k));
		for (int i = 0; i < half; ++i) {
			halfs[a[i][k] - 1][0] = 0;
			halfs[a[i + half][k] - 1][0] = 1;
		}
		for (int ik = 1; ik < k; ++ik) {
			for (int i = 0; i < n; ++i) {
				swap(a[i][0], a[i][ik]);
			}
			sort(ALL(a));
			for (int i = 0; i < half; ++i) {
				halfs[a[i][k] - 1][ik] = 0;
				halfs[a[i + half][k] - 1][ik] = 1;
			}
		}
		for (int i = 0; i < n; ++i) {
			swap(a[i][0], a[i][1]); // The original row
		}
		sort(ALL(a));
		/*for (auto e : a) {
			for (auto e2 : e) {
				cout << e2 << ' ';
			} cout << endl;
		}
		for (auto e : halfs) {
			for (auto e2 : e) {
				cout << e2 << ' ';
			} cout << endl;
		}*/
		if (k == 2) {
			cout << "YES" << endl;
			int cur_take = n;
			for (int i = 0; i < n; ++i) {
				if (halfs[a[i][k] - 1][1] == 0)
					continue;
				do {
					--cur_take;
				} while (halfs[a[cur_take][k] - 1][1] == 1);
					
				cout << a[i][k] << ' ' << a[cur_take][k] << endl;
			}
		} else {
			vector<vector<int>> poses = generate_poses(half);
			for (auto e : poses) {
				bool possib = true;
				for (int i = 0; i < half; ++i) {
					for (int ik = 0; ik < k; ++ik) {
						if (halfs[a[i][k] - 1][ik] + halfs[a[e[i] + half][k] - 1][ik] != 1) {
							possib = false;
							break;
						}
					}
					if (!possib)
						break;
				}
				if (possib) {
					cout << "YES" << endl;
					for (int i = 0; i < half; ++i) {
						cout << a[i][k] << ' ' << a[e[i] + half][k] << endl;
					}
				}
			}
			cout << "NO" << endl;
		}
	}
}