#include <bits/stdc++.h>

using namespace std;

const int limit = 2001;

void first_solution(int n){
    cout << n << "\n";
    for (int i = 0; i < n; i++)
        cout << n << " ";
}

void second_solution(int n){
    cout << 2 * n - 1 << "\n";
    for (int i = n; i > 1; i--)
        cout << i << " ";
    for (int i = 0; i < n; i++)
        cout << n << " ";
}

int find_max(int &curr, int el, vector<int> &goods, vector<int> &place){
    if (goods[curr] == el)
        curr++;
    int mx = -1;
    int i;
    for (i = curr; i < (int)goods.size() && goods[i] != el; i++)
        mx = max(mx, place[goods[i]]);
    if (mx != -1)
        return mx;
    if (i == (int)goods.size())
        return (int)place.size() - 1;
    return 0;
}

void move(vector<int> &place, int pos, int el){
    for (int i = 0; i < (int)place.size(); i++){
        if (i != el){
            if (place[i] <= pos)
                place[i]--;
        }
    }
    place[el] = pos;
}

void third_solution(int n, int m, vector<int> &goods, vector<int> &order){
    int curr = 0;
    vector<int> place(n);
    vector<int> ans;
    for (int i = 0; i < n; i++)
        place[order[i]] = i;
    while (curr != m){
        int el = min_element(place.begin(), place.end()) - place.begin();
        int pos = find_max(curr, el, goods, place);
        ans.push_back(pos);
        move(place, pos, el);
    }
    cout << ans.size() << "\n";
    for (int el : ans)
        cout << el + 1 << " ";
}

void fourth_solution(int n, int m, vector<int> &goods, vector<int> &order){
    int curr = 0;
    vector<int> place(n);
    set<pair<pair<int, int>, int>> heap;
    for (int i = 0; i < n; i++){
        place[order[i]] = i;
        heap.insert(make_pair(make_pair(i, 1), order[i]));
    }
    vector<int> next(n, m);
    for (int i = 0; i < m; i++)
        next[goods[i]] = i;
    vector<int> ans;
    while (curr != m){
        //int el = min_element(place.begin(), place.end()) - place.begin();
        int el = heap.begin()->second;
        int pos = find_max(curr, el, goods, place);
        ans.push_back(pos);
        //move(place, pos, el);
        place[el] = pos;
        heap.erase(heap.begin());
        heap.insert(make_pair(make_pair(pos, 2), el));
    }
    cout << ans.size() << "\n";
    for (int el : ans)
        cout << el + 1 << " ";
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    vector<int> goods(m);
    vector<int> order(n);
    for (int i = 0; i < m; i++){
        cin >> goods[i];
        goods[i]--;
    }
    for (int i = 0; i < n; i++){
        cin >> order[i];
        order[i]--;
    }
    if (n < limit && m < limit){
        third_solution(n, m, goods, order);
        return 0;
    }
    bool ok = true;
    for (int i = 0; i < min(n, m); i++)
        if (goods[i] != order[i])
            ok = false;
    if (n == m && ok) {
        first_solution(n);
        return 0;
    }
    ok = true;
    for (int i = 0; i < min(n, m); i++)
        if (goods[i] != order[min(n , m) - i - 1])
            ok = false;
    if (n == m && ok){
        second_solution(n);
        return 0;
    }
    fourth_solution(n, m, goods, order);
    return 0;
}