#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9 + 1;

void first_solution(int n, vector<vector<int>> &input){
    cout << "YES\n";
    vector<pair<int, int>> lst(n);
    for (int i = 0; i < n; i++)
        lst[i] = make_pair(input[i][0], i + 1);
    sort(lst.begin(), lst.end());
    for (int i = 0; i < n / 2; i++)
        cout << lst[i].second << " " << lst[n - i - 1].second << "\n";
}

bool check(vector<vector<int>> &lst, vector<int> &order){
    int n = lst.size(), k = lst[0].size();
    for (int j = 0; j < k; j++){
        int down = -INF, up = INF;
        for (int i = 0; i < n; i += 2){
            down = max(down, min(lst[order[i]][j], lst[order[i + 1]][j]));
            up = min(up, max(lst[order[i]][j], lst[order[i + 1]][j]));
        }
        if (down > up)
            return false;
    }
    return true;
}

void out(vector<int> &order){
    cout << "YES\n";
    int n = order.size();
    for (int i = 0; i < n; i += 2){
        cout << order[i] + 1 << " " << order[i + 1] + 1 << "\n";
    }
}

void second_solution(int n, vector<vector<int>> &input){
   vector<int> order(n);
   for (int i = 0; i < n; i++)
       order[i] = i;
   if (check(input, order)){
       out(order);
       return;
   }
   while(next_permutation(order.begin(), order.end()))
       if (check(input, order)){
           out(order);
           return;
       }
   cout << "NO";
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    vector<vector<int>> lst(n, vector<int> (k));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < k; j++)
            cin >> lst[i][j];
    if (k == 1){
        first_solution(n, lst);
        return 0;
    }
    if (n <= 10){
        second_solution(n, lst);
        return 0;
    }
    return 0;
}