#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <cstring>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <fstream>
#include <queue>

using namespace std;
typedef long long ll;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 7;
#else 
	const int MAXN = 3e5 + 100;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
#endif
#define fixed fix

int n, m;
int a[MAXN];
int b[MAXN];
queue<int> nxt[MAXN];
int res[2 * MAXN];

struct treap {
	treap *l = nullptr, *r = nullptr;
	int x, y;
	int val;
	int mn;
	int sz = 1;
	treap() {
		y = rand();
	}
	treap(int _x, int _val) {
		y = (rand() << 15) | rand();
		x = _x;
		val = _val;
	}
};

inline int get_sz(treap *t) {
	if (t == nullptr) {
		return 0;
	}
	return t->sz;
}

inline int get_mn(treap *t) {
	if (t == nullptr) {
		return 1e9;
	}
	return t->mn;
}

inline void upd(treap *t) {
	if (t == nullptr) {
		return;
	}
	t->sz = 1 + get_sz(t->l) + get_sz(t->r);
	t->mn = min(t->val, min(get_mn(t->l), get_mn(t->r)));
}

inline void split(treap *t, treap *&l, treap *&r, int x) {
	if (t == nullptr) {
		l = t;
		r = t;
		upd(l);
		upd(r);
		return;
	}
	int vl = get_sz(t->l) + 1;
	if (vl <= x) {
		split(t->r, t->r, r, x - vl);
		l = t;
	}
	else {
		split(t->l, l, t->l, x);
		r = t;
	}
	upd(l);
	upd(r);
}

inline void merge(treap *&t, treap *l, treap *r) {
	if (l == nullptr) {
		t = r;
		upd(t);
		return;
	}
	if (r == nullptr) {
		t = l;
		upd(t);
		return;
	}
	if (l->y > r->y) {
		merge(l->r, l->r, r);
		t = l;
	}
	else {
		merge(r->l, l, r->l);
		t = r;
	}
	upd(t);
}

treap *root;

void print(treap *t) {
	if (t == nullptr) {
		return;
	}
	print(t->l);
	cerr << t->x << ' ';
	print(t->r);
}

inline int down(treap *t, int x) {
	if (t == nullptr) {
		return 0;
	}
	if (get_mn(t->r) < x) {
		return down(t->r, x) + get_sz(t->l) + 1;
	}
	if (t->val < x) {
		return get_sz(t->l) + 1;
	}
	return down(t->l, x);
}

inline void init() {
	root = nullptr;
}

inline void solve() {
	init();
	for (int i = 0; i < m; i++) {
		cin >> a[i];
		nxt[a[i]].push(i);
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		nxt[b[i]].push(MAXN - 1);
	}
	for (int i = 0; i < n; i++) {
		merge(root, root, new treap(b[i], nxt[b[i]].front()));
	}
	int ans = 0;
	int pnt = 0;
	while (pnt < m) {
		ans++;
		treap *L = nullptr, *R = nullptr;
		split(root, L, R, 1);
		int x = L->x;
		if (a[pnt] == x) {
			pnt++;
			nxt[x].pop();
			L->val = nxt[x].front();
			L->mn = L->val;
		}
		int r = down(R, get_mn(L));
		treap *M = nullptr, *E = nullptr;
		split(R, M, E, r);
		merge(R, M, L);
		merge(root, R, E);
		res[ans - 1] = r; 
	}
	cout << ans << '\n';
	for (int i = 0; i < ans; i++) {
		cout << res[i] + 1 << ' ';
	}
	cout << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("C.in", "r", stdin);
		freopen("C.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> m) {
		solve();
	}
}