#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <cstring>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <fstream>
#include <queue>

using namespace std;
typedef long long ll;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 7;
#else 
	const int MAXN = 3e5 + 100;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
#endif
#define fixed fix

int n, m;
int a[MAXN];
int b[MAXN];
int fixed[MAXN];
queue<int> nxt[MAXN];
int res[2 * MAXN];
int last_pos[MAXN];

struct treap {
	int l = -1;
	int r = -1;
	int x, y;
	int val;
	int mn;
	int sz = 1;
	treap() {
		y = rand();
	}
	treap(int _x, int _val) {
		y = (rand() << 15) | rand();
		x = _x;
		val = _val;
	}
};

treap G[MAXN * 20];

int ptr = 0;

int make_v(int a, int b) {
	G[ptr] = treap(a, b);
	return ptr++;
}

inline int get_sz(int t) {
	if (t == -1) {
		return 0;
	}
	return G[t].sz;
}

inline int get_mn(int t) {
	if (t == -1) {
		return 1e9;
	}
	return G[t].mn;
}

inline void upd(int t) {
	if (t == -1) {
		return;
	}
	G[t].sz = 1 + get_sz(G[t].l) + get_sz(G[t].r);
	G[t].mn = min(G[t].val, min(get_mn(G[t].l), get_mn(G[t].r)));
}

inline void split(int t, int &l, int &r, int x) {
	if (t == -1) {
		l = t;
		r = t;
		upd(l);
		upd(r);
		return;
	}
	int vl = get_sz(G[t].l) + 1;
	if (vl <= x) {
		split(G[t].r, G[t].r, r, x - vl);
		l = t;
	}
	else {
		split(G[t].l, l, G[t].l, x);
		r = t;
	}
	upd(l);
	upd(r);
}

inline void merge(int &t, int l, int r) {
	if (l == -1) {
		t = r;
		upd(t);
		return;
	}
	if (r == -1) {
		t = l;
		upd(t);
		return;
	}
	if (G[t].y > G[r].y) {
		merge(G[l].r, G[l].r, r);
		t = l;
	}
	else {
		merge(G[r].l, l, G[r].l);
		t = r;
	}
	upd(t);
}

int root;

inline int down(int t, int x) {
	int res = 0;
	while (t != -1) {
		if (get_mn(G[t].r) < x) {
			res += get_sz(G[t].l) + 1;
			t = G[t].r;
			continue;
		}
		if (G[t].val < x) {
			res += get_sz(G[t].l) + 1;
			break;
		}
		t = G[t].l;
	}
	return res;
}

inline void init() {
	root = -1;
	// memset(fixed, 0, sizeof(fixed));
	// for (int i = 0; i < MAXN; i++) {
	// 	last_pos[i] = MAXN - 1;
	// }
}

inline void solve() {
	init();
	for (int i = 0; i < m; i++) {
		cin >> a[i];
		nxt[a[i]].push(i);
	}
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		nxt[b[i]].push(MAXN - 1);
	}
	for (int i = 0; i < n; i++) {
		merge(root, root, make_v(b[i], nxt[b[i]].front()));
	}
	int ans = 0;
	int pnt = 0;
	int M = -1, R = -1, L = -1, E = -1;
	// int cnt = n;
	while (pnt < m) {
		ans++;
		split(root, L, R, 1);
		int x = G[L].x;
		// if (fixed[x] == 0) {
		// 	fixed[x] = 1;
		// 	cnt--;
		// }
		if (a[pnt] == x) {
			pnt++;
			nxt[x].pop();
			G[L].val = nxt[x].front();
			G[L].mn = G[L].val;
		}
		int r = -1;
		if (get_mn(L) == pnt) {
			r = 0;
		}
		else if (nxt[x].size() == 1) {
			r = n - 1;
		}
		else {
			r = down(R, get_mn(L));
		}
		split(R, M, E, r);
		merge(R, M, L);
		merge(root, R, E);
		res[ans - 1] = r; 
	}
	cout << ans << '\n';
	for (int i = 0; i < ans; i++) {
		cout << res[i] + 1 << ' ';
	}
	cout << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("C.in", "r", stdin);
		freopen("C.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> m) {
		solve();
	}
}