#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <cstring>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <fstream>

using namespace std;
typedef long long ll;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 7;
#else 
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
#endif
#define int ll
int n, m, k;
const int MOD = 1e9 + 7;

int dp[MAXN][MAXN][100];
int R[MAXN];
int binom[100][100];
int fact[100];

int bp(int a, int N) {
	if (!N) {
		return 1;
	}
	if (N & 1) {
		return (a * bp(a, N - 1)) % MOD;
	}
	return bp((a * a) % MOD, N >> 1);
}



void init() {
	fact[0] = 1;
	for (int i = 0; i < 100; i++) {
		binom[0][i] = 0;
	}
	for (int i = 1; i < 100; i++) {
		fact[i] = i * fact[i - 1];
		fact[i] %= MOD;
	}
	for (int i = 0; i < 100; i++) {
		binom[i][0] = 1;
	}
	for (int i = 1; i < 100; i++) {
		for (int j = 1; j < 100; j++) {
			binom[i][j] = (binom[i - 1][j] + binom[i - 1][j - 1]) % MOD;
		}
	}
	memset(R, -1, sizeof(R));
}

int mult[100];
int dp1[MAXN];

void solve() {
	init();
	vector<pair<int, int>> seg;
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		seg.emplace_back(l, r);
	}
	sort(seg.begin(), seg.end());
	int pref = 0;
	for (int bt = 63; bt >= 0; bt--) {
		if (k & ((int)1 << bt)) {
			for (int j = 0; j <= bt; j++) {
				mult[__builtin_popcountll(pref) + j] += binom[bt][j];
			}
			pref += ((int)1 << bt);
		}
	}
	mult[__builtin_popcountll(pref)]++;
	dp[0][0][0] = 1;
	int cur = 0;
	for (int i = 1; i <= n; i++) {
		while (cur < m && seg[cur].first == i) {
			cur++;
		}
		for (int j = 0; j <= m; j++) {
			for (int bt = 0; bt < 64; bt++) {
				dp[i][j][bt] += dp[i - 1][j][bt];
				dp[i][j][bt] %= MOD;
				dp[i][cur][bt + 1] += dp[i - 1][j][bt];
				dp[i][cur][bt + 1] %= MOD;	
			}
		}
	}
	for (int q = 0; q < 3; q++) {
		for (int i = 0; i <= n; i++) {
			for (int j = 0; j <= m; j++) {
				cerr << dp[i][j][q] << ' ';
			}
			cerr << '\n';
		}
		cerr << '\n';
	}
	int ans = 0;
	for (int bt = 0; bt < 64; bt++) {
		ans += mult[bt] * dp[n][m][bt] * fact[bt];
		ans %= MOD;
	}
	cout << ans << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("D.in", "r", stdin);
		freopen("D.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> m >> k) {
		solve();
	}
}