#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <cstring>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <fstream>

using namespace std;
typedef long long ll;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 7;
#else 
	const int MAXN = 5e3 + 1;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
#endif

int n, k;
int dp[MAXN][MAXN][2];
int add[MAXN];
int mod = (1e9 + 7);

int get(int n, int k, int x) {
	if (dp[n][k][x] != -1) {
		return dp[n][k][x];
	}
	if (n == 0) {
		return dp[n][k][x] = 1;
	}
	int cur = 0;
	if (x == 0) {
		for (int j = k + 1; j <= n; j++) {
			cur += get(n - j, j, 1);
			cur %= mod;
		}
	}
	else {
		for (int j = 1; j < min(n + 1, k); j++) {
			cur += get(n - j, j, 0);
			cur %= mod;
		}
	}
	return dp[n][k][x] = cur;
}

void init() {
	memset(dp, 0, sizeof(dp));
}

void solve() {
	init();
	if (n == k) {
		cout << 1 << '\n';
		return;
	}
	for (int i = 1; i < MAXN; i++) {
		dp[0][i][0] = dp[0][i][1] = 1;
	}
	for (int sum = 1; sum <= n; sum++) {
		for (int last = 1; last <= n; last++) {
			// if ()
			for (int mid = 1; mid < min(sum + 1, last); mid++) {
				dp[sum][last][1] += dp[sum - mid][mid][0];
				dp[sum][last][1] %= mod;
			}
			for (int mid = last + 1; mid <= sum; mid++) {
				dp[sum][last][0] += dp[sum - mid][mid][1];
				dp[sum][last][0] %= mod;
			}
			// add[sum + last][0] += dp[sum][last][0];
			// add[sum + last][0] %= mod;
			// add[sum + last][1] += dp[sum][last][1];
			// add[sum + last][1] %= mod;
		}
	}
	cout << (dp[n - k][k][0] + dp[n - k][k][1]) % mod << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("B.in", "r", stdin);
		freopen("B.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> k) {
		solve();
	}
}