#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <set>
#include <cstring>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <fstream>

using namespace std;
typedef long long ll;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 7;
#else 
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
#endif

const int MAXK = 10;

set<int> uniq[MAXK];

int n, k;
int val[MAXN][MAXK];
int color[MAXN][MAXK];
int border[MAXK];
int mask[MAXN];
vector<int> g[MAXN];
int mt[MAXN];
int used[MAXN];
vector<int> total[1 << MAXK];

int dfs(int v) {
	if (used[v]) {
		return 0;
	}
	used[v] = 1;
	for (auto to : g[v]) {
		if (mt[to] == -1 || dfs(mt[to])) {
			mt[to] = v;
			return 1;
		}
	}
	return 0;
}


void init() {
	memset(mt, -1, sizeof(mt));
}

void solve() {
	init();
	bool stupid = n <= 10;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			cin >> val[i][j];
			// if (uniq[j].count(val[i][j])) {
			// 	stupid = 1;
			// }
			// uniq[j].insert(val[i][j]);
		}
	}
	for (int i = 0; i < k; i++) {
		vector<pair<int, int>> clr(n);
		for (int j = 0; j < n; j++) {
			clr[j] = make_pair(val[j][i], j);
		}
		sort(clr.begin(), clr.end());
		border[i] = (clr[n / 2 - 1].first + clr[n / 2].first) / 2;
		for (int j = 0; j < n; j++) {
			if (val[j][i] < border[i]) {
				color[j][i] = 1;
			}
			else if (val[j][i] > border[i]) {
				color[j][i] = 0;
			}
			else {
				color[j][i] = 0 - stupid;
			}
		}
	}
	if (stupid) {
		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				bool ok = 1;
				for (int x = 0; x < k; x++) {
					bool l = (val[j][x] <= border[x] || val[i][x] <= border[x]);
					bool r = (val[j][x] >= border[x] || val[i][x] >= border[x]);
					ok &= (l & r);
				}
				if (ok) {
					g[i].push_back(j);
					g[j].push_back(i);
				}
			}
		}
		int ans = 0;
		for (int i = 0; i < n; i++) {
			memset(used, 0, sizeof(int) * 500);
			ans += dfs(i);
		}
		if (ans == n) {
			cout << "YES\n";
			set<int> u;
			for (int i = 0; i < n; i++) {
				if (!u.count(i)) {
					cout << i + 1 << ' ' << mt[i] + 1 << '\n';
					u.insert(i);
					u.insert(mt[i]);
				}
			}
		}
		else {
			cout << "NO\n";
		}
		return;
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			mask[i] += color[i][j] * (1 << j);
		}
		total[mask[i]].push_back(i);
	}
	int all_mask = (1 << k) - 1;
	for (int i = 0; i < (1 << k); i++) {
		if (total[i].size() != total[all_mask ^ i].size()) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
	for (int i = 0; i < (1 << (k - 1)); i++) {
		while (total[i].size()) {
			cout << total[i].back() + 1 << ' ';
			cout << total[i ^ all_mask].back() + 1 << '\n';
			total[i].pop_back();
			total[i ^ all_mask].pop_back();
		}
	}
}

signed main() {
	#ifdef DEBUG
		freopen("D.in", "r", stdin);
		freopen("D.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	while (cin >> n >> k) {
		solve();
	}
}