#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#include <set>
#include <map>
#include <algorithm>

#define int long long

using namespace std;

vector<bool> used(0);
vector<int> dp0(0);
vector<int> dp1(0);

void dfs(int vertex, vector<vector<int>> & G) {
    used[vertex] = true;
    for(auto u : G[vertex]) {
        if(!used[u]) {
            dfs(u, G);
            dp0[vertex] += max(dp1[u], dp0[u]);
            dp1[vertex] += dp0[u];
        }
    }
}

int32_t main() {
    int n;
    cin >> n;
    vector<int> in(n);
    vector<vector<int>> G(n, vector<int> (0));
    for(int i = 0; i < n; i ++) {
        cin >> in[i];
        if(in[i] != -1) {
            in[i] --;
            G[in[i]].emplace_back(i);
        }
    }
    if(n <= 20) {
        int ans = 0;
        for(int i = 0; i < (1 << n); i ++) {
            int _i = i;
            int k = 0;
            int num = 0;
            vector<bool> a(n, false);
            while (_i > 0) {
                if(_i % 2 == 1) {
                    a[num] = true;
                    k ++;
                }
                _i /= 2;
                num ++;
            }
            bool flag = false;
            for(int i = 0; i < n; i ++) {
                if(a[i] && in[i] != -1 && a[in[i]]) {
                    flag = true;
                    break;
                }
            }
            if(!flag) {
                ans = max(ans, k);
            }
        }
        cout << ans << endl;
    }
    else {
        int ans = 0;
        used.resize(n, false);
        dp0.resize(n, 0);
        dp1.resize(n, 1);
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i, G);
            }
            if (in[i] == -1) {
                ans += max(dp0[i], dp1[i]);
            }
        }
        cout << ans << endl;
    }
    return 0;
}