#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

using ll = long long;

int main() {
    int num_tests = 1;
    if (DEV) {
        freopen("input.txt", "r", stdin);
        scanf("%d", &num_tests);
    }
    for (int i = 0; i < num_tests; ++i) {
        $ printf("---TEST %d---\n", i);
        entry(i);
    }
}

#define all(x) x.begin(), x.end()

const ll INF = 1e18;
const ll MOD = 1'000'000'007;

vector<vector<int>> req_ids;


mt19937_64 gener(347664);

struct Node {
    Node *pl = nullptr;
    Node *pr = nullptr;
    int sz = 1;
    int x;
    int mn;
    int prior = gener();

    static int safe_sz(Node *v) {
        return v ? v->sz : 0;
    }

    static int safe_mn(Node *v) {
        return v ? v->mn : 10000000;
    }

    void relax() {
        sz = 1 + Node::safe_sz(pl) + Node::safe_sz(pr);
        mn = min(Node::safe_mn(pl), Node::safe_mn(pr));
        mn = min(mn, x);
    }

    ~Node() {
        delete pl;
        delete pr;
    }
};

pair<Node *, Node *> split(Node *v, int cnt) {
    if (!v) {
        return {nullptr, nullptr};
    }
    int bar = Node::safe_sz(v->pl) + 1;
    if (cnt >= bar) {
        auto t = split(v->pr, cnt - bar);
        v->pr = t.first;
        v->relax();
        t.first = v;
        return t;
    } else {
        auto t = split(v->pl, cnt);
        v->pl = t.second;
        v->relax();
        t.second = v;
        return t;
    }
}

Node *merge(Node *L, Node *R) {
    if (!L) return R;
    if (!R) return L;
    if (L->prior > R->prior) {
        L->pr = merge(L->pr, R);
        L->relax();
        return L;
    } else {
        R->pl = merge(L, R->pl);
        R->relax();
        return R;
    }
}

int get(Node *v, int k) {
    auto[t1, t23] = split(v, k);
    auto[t2, t3] = split(t23, 1);
    auto res = t2->x;
    merge(t2, t3);
    merge(t1, t23);
    return res;
}

void tset(Node *v, int k, int y) {
    auto[t1, t23] = split(v, k);
    auto[t2, t3] = split(t23, 1);
    t2->x = y;
    t2->relax();
    merge(t2, t3);
    merge(t1, t23);
}

Node *append(Node *v, int x) {
    Node *w = new Node;
    w->x = x;
    w->relax();
    return merge(v, w);
}

int find0(Node *v) {
    int ans = 0;
    while (true) {
        if (v->x == 0) {
            return ans + Node::safe_sz(v->pl);
        }
        if (Node::safe_mn(v->pl) == 0) {
            v = v->pl;
        } else {
            ans += Node::safe_sz(v->pl) + 1;
            v = v->pr;
        }
    }
}

void entry(int test_id) {
    (void) test_id;
    int n, m;
    scanf("%d %d", &n, &m);
    vector<int> requests(m);
    for (int i = 0; i < m; ++i) {
        int x;
        scanf("%d", &x);
        requests[i] = x - 1;
    }
    Node *order_pos = nullptr;
    for (int i = 0; i < n; ++i) {
        order_pos = append(order_pos, 0);
    }
    //vector<int> order_pos(n);
    for (int i = 0; i < n; ++i) {
        int p;
        scanf("%d", &p);
        //order[i] = p - 1;
        tset(order_pos, p - 1, i);
        //order_pos[p - 1] = i;
    }
    req_ids.clear();
    req_ids.resize(n);
    for (int i = 0; i < m; ++i) {
        int j = get(order_pos, requests[i]);
        // int j = order_pos[requests[i]];
        req_ids[j].push_back(i);
    }
    vector<int> ans;
    vector<int> next_same(m, m);
    {
        map<int, int> mp;
        for (int i = 0; i < m; ++i) {
            int x = requests[i];
            if (mp.count(x)) {
                int j = mp[x];
                next_same[j] = i;
            }
            mp[x] = i;
        }
    }
    vector<int> next_req(n, m);
    for (int i = 0; i < m; ++i) {
        int x = requests[i];
        if (next_req[x] == m) next_req[x] = i;
    }
    // multiset<int> ms;
    //int ms_l = 0;
    //int ms_r = 0;
    for (int j = 0; j < m; ++j) {
        while (true) {
            int cur = find0(order_pos);
            //for (int h = 0; h < n; ++h) {
            //    if (get(order_pos, h) == 0) cur = h;
            //}
            if (cur == requests[j]) {
                next_req[cur] = next_same[j];
            }

            int npos = 0;
            int L = j;
            int R = next_req[cur];

            for (int k = j; k < next_req[cur]; ++k) {
                int ps = get(order_pos, requests[k]);
                npos = max(npos, ps);
            }
            // int rem = R - L;
            //while (npos < n) {
            //    int cnt1 = lower_bound(all(req_ids[npos]), L) - req_ids[npos].begin();
            //    int cnt2 = lower_bound(all(req_ids[npos]), R) - req_ids[npos].begin();
            //   rem -= cnt2 - cnt1;
            //  if (rem == 0) break;
            //  ++npos;
            // }
            for (int i = 0; i < n; ++i) {
                if (get(order_pos, i) <= npos) tset(order_pos, i, get(order_pos, i)-1);
            }
            tset(order_pos, cur, npos);
            ans.push_back(npos);
            auto t = req_ids[0];
            req_ids.erase(req_ids.begin());
            req_ids.insert(req_ids.begin() + npos, t);
            if (cur == requests[j]) {
                break;
            }
        }
    }
    printf("%lld\n", (ll) ans.size());
    for (int npos : ans) {
        printf("%d ", npos + 1);
    }
    printf("\n");
    $ delete order_pos;
}