#include <iostream>
#include <vector>

using namespace std;

const long long mod = 1000000007;

long long fun(long long n, long long k) {
    if (n == k) {
        return 1;
    }
    vector <vector <pair <long long, long long>>> dp(n);
    vector <vector <pair <unsigned long long, unsigned long long>>> ps(n);
    for (int i = 0; i < n; i++) {
        dp[i].resize(n);
        ps[i].resize(n);
        dp[i][i] = {1, 1};
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j) {
                dp[i][j] = {0, 0};
            }
            if (j < i) {
                if (j > 0) {
                    dp[i][j].first = (dp[i][j].first + ps[i - j - 1][j - 1].second) % mod;
                }
                dp[i][j].second = (dp[i][j].second + (ps[i - j - 1][n - 1].first - ps[i - j - 1][j].first)) % mod;
            }
            if (j == 0) {
                ps[i][j].first = dp[i][j].first;
                ps[i][j].second = dp[i][j].second;
            } else {
                ps[i][j].first = (ps[i][j - 1].first + dp[i][j].first);
                ps[i][j].second = (ps[i][j - 1].second + dp[i][j].second);
            }
        }
    }
    return (dp[n - 1][k - 1].first + dp[n - 1][k - 1].second) % mod;
}

long long ssol(long long n, long long k) {
    if (n == k) {
        return 1;
    }
    vector <vector <pair <long long, long long>>> dp(n);
    for (int i = 0; i < n; i++) {
        dp[i].resize(n);
        dp[i][i] = {1, 1};
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < i; j++) {
            dp[i][j] = {0, 0};
            for (int l = 0; l < j; l++) {
                dp[i][j].first = (dp[i][j].first + dp[i - j - 1][l].second) % mod;
            }
            for (int l = j + 1; l < n; l++) {
                dp[i][j].second = (dp[i][j].second + dp[i - j - 1][l].first) % mod;
            }
        }
    }
    return (dp[n - 1][k - 1].first + dp[n - 1][k - 1].second) % mod;
}

int main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);
    long long n, k;
    cin >> n >> k;
    cout << fun(n, k);
    return 0;
}
