/*#include <iostream>
#include <vector>
#include <algorithm>
#include <random>

using namespace std;

const int MAXN = 300 * 1000 + 5;

int n, res;
int p[MAXN], dp[MAXN][2];
vector<int> g[MAXN];
bool used[MAXN], leaf[MAXN];

void dfs(int v) {
	used[v] = 1;
	int s0 = 0, s1 = 0;
	for (int u : g[v]) {
		dfs(u);
		s0 += dp[u][0];
		s1 += dp[u][1];
	}
	dp[v][0] = s1;
	dp[v][1] = s0 + 1;
}


signed main() {
	while (1) {
		memset(used, 0, sizeof(used));
		memset(leaf, 0, sizeof(leaf));
		memset(p, 0, sizeof(p));
		memset(dp, 0, sizeof(dp));
		for (int i = 0; i < 20; ++i) g[i].clear();

		n = rand() % 10 + 1;
		for (int i = 0; i < n; ++i) {
			p[i] = (rand() % (i + 1)) - 1;

			if (p[i] != -1) g[p[i]].push_back(i);
			else leaf[i] = 1;
		}
		int res1 = 0;
		for (int i = 0; i < (1 << (n + 1)); ++i) {
			res1 = max(res1, check(i));
		}

		int res2 = 0;
		for (int i = 0; i < n; ++i) {
			if (leaf[i] && !used[i]) {
				dfs(i);
				res2 += max(dp[i][0], dp[i][1]);
			}
		}

		if (res1 != res2) {
			cout << "ok wa " << res1 << " " << res2 << endl;
			for (int i = 0; i < n; ++i) {
				cout << p[i] << " ";
			}
			break;
		}
	}


	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
		--p[i];
	}
	for (int i = 0; i < (1 << (n + 1)); ++i) {
		res = max(res, check(i));
	}
	cout << res << endl;
	return 0;
}*/


#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 300 * 1000 + 5;

int n, p[MAXN], tmp, dp[MAXN][2], res;
vector<int> g[MAXN];
bool used[MAXN], leaf[MAXN];

int check(int a) {
	int ans = 0;
	bool f = 0;

	for (int i = 0; i < n; ++i) {
		if (1 & (a >> i)) {
			if (1 & (a >> p[i])) f = 1;
			else ++ans;
		}
	}

	if (f) return 0;
	else return ans;
}

void dfs(int v) {
	used[v] = 1;
	int s0 = 0, s1 = 0;
	for (int u : g[v]) {
		dfs(u);
		s0 += dp[u][0];
		s1 += max(dp[u][1], dp[u][0]);
	}
	dp[v][0] = s1;
	dp[v][1] = s0 + 1;
}

signed main() {
	cin >> n;
	if (n <= 20) {
		for (int i = 0; i < n; ++i) {
			cin >> p[i];
		}
		for (int i = 0; i < (1 << (n + 1)); ++i) {
			res = max(res, check(i));
		}
	}
	else {
		for (int i = 0; i < n; ++i) {
			cin >> tmp;
			if (tmp != -1) {
				g[tmp - 1].push_back(i);
			}
			else leaf[i] = 1;
		}
		for (int i = 0; i < n; ++i) {
			if (leaf[i] && !used[i]) {
				dfs(i);
				res += max(dp[i][0], dp[i][1]);
			}
		}
		cout << res << endl;
	}
	return 0;
}
