#include <bits/stdc++.h>

using namespace std;


struct seg_tree
{
    int sz;
    vector<int> L, R, DO;
    seg_tree(int n)
    {
        sz = 1;
        while (sz < n) sz <<= 1;
        L.resize(sz << 1);
        R.resize(sz << 1);
        DO.resize(sz << 1);
        for (int i = 0; i < sz; ++i)
        {
            L[sz + i] = i;
            R[sz + i] = i;
        }
        for (int i = sz - 1; i > 0; --i)
        {
            L[i] = L[i << 1];
            R[i] = R[i << 1 | 1];
        }
    }
    seg_tree(vector<int> a)
    {
        sz = 1;
        while(sz < a.size()) sz <<= 1;
        L.resize(sz << 1);
        R.resize(sz << 1);
        DO.resize(sz << 1);
        for (int i = 0; i < sz; ++i)
        {
            L[sz + i] = i;
            R[sz + i] = i;
        }
        for (int i = sz - 1; i > 0; --i)
        {
            L[i] = L[i << 1];
            R[i] = R[i << 1 | 1];
        }
        for (int i = 0; i < a.size(); ++i)
            DO[sz + i] = a[i];
        for (int i = sz - 1; i > 0; --i)
        {
            DO[i] = DO[i << 1] + DO[i << 1 | 1];
        }
    }
    int sum(int l, int r, int x = 1)
    {
        if (l <= L[x] && R[x] <= r) return DO[x];
        if (R[x] < l || r < L[x]) return 0;
        return sum(l, r, x << 1) + sum(l, r, x << 1 | 1);
    }
    void change(int pos, int val, int x = 1)
    {
        if (pos < L[x] || R[x] < pos) return;
        if (L[x] == R[x])
        {
            DO[x] = val;
            return;
        }
        change(pos, val, x << 1);
        change(pos, val, x << 1 | 1);
        DO[x] = DO[x << 1] + DO[x << 1 | 1];
    }
};

int main()
{
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    for (int i = 0; i < m; ++i) cin >> a[i];
    for (int i = 0; i < m; ++i) --a[i];
    vector<int> b(n);
    for (int i = 0; i < n; ++i) cin >> b[i];
    for (int i = 0; i < n; ++i) --b[i];
    vector<bool> used(n);
    int now = 0;
    vector<int> res;
    for (int i = 0; i < m; ++i)
    {
        if (used[a[i]])
        {
            res.push_back(a[i]);
        }
        else
        {
            while (!used[a[i]])
            {
                used[b[now]] = true;
                res.push_back(b[now]);
                ++now;
            }
        }
    }
    vector<vector<int> > pos(n, {-1});
    for (int i = res.size() - 1; i > -1; --i)
        pos[res[i]].push_back(i);
    seg_tree x(res.size());
    for (int i = 0; i < n; ++i)
    {
        x.change(pos[i].back(), 1);
    }
    vector<int> ans(res.size());
    for (int i = 0; i < res.size(); ++i)
    {
        x.change(pos[res[i]].back(), 0);
        pos[res[i]].pop_back();
        x.change(pos[res[i]].back(), 1);
        ans[i] = x.sum(0, pos[res[i]].back());
        if (pos[res[i]].back() == -1) ans[i] = n;
    }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i) cout << ans[i] << " ";
    cout << endl;
}
