#include <bits/stdc++.h>

using namespace std;

#define int long long

const int p = 1e9 + 7;

struct seg_tree
{
    int sz;
    vector<int> L, R, DO;
    seg_tree(int n)
    {
        sz = 1;
        while (sz < n) sz <<= 1;
        L.resize(sz << 1);
        R.resize(sz << 1);
        DO.resize(sz << 1);
        for (int i = 0; i < sz; ++i)
        {
            L[sz + i] = i;
            R[sz + i] = i;
        }
        for (int i = sz - 1; i > 0; --i)
        {
            L[i] = L[i << 1];
            R[i] = R[i << 1 | 1];
        }
    }
    seg_tree(vector<int> a)
    {
        sz = 1;
        while(sz < a.size()) sz <<= 1;
        L.resize(sz << 1);
        R.resize(sz << 1);
        DO.resize(sz << 1);
        for (int i = 0; i < sz; ++i)
        {
            L[sz + i] = i;
            R[sz + i] = i;
        }
        for (int i = sz - 1; i > 0; --i)
        {
            L[i] = L[i << 1];
            R[i] = R[i << 1 | 1];
        }
        for (int i = 0; i < a.size(); ++i)
            DO[sz + i] = a[i];
        for (int i = sz - 1; i > 0; --i)
        {
            DO[i] = DO[i << 1] + DO[i << 1 | 1];
        }
    }
    int sum(int l, int r, int x = 1)
    {
        if (l <= L[x] && R[x] <= r) return DO[x];
        if (R[x] < l || r < L[x]) return 0;
        return (sum(l, r, x << 1) + sum(l, r, x << 1 | 1)) % p;
    }
    void change(int pos, int val, int x = 1)
    {
        if (pos < L[x] || R[x] < pos) return;
        if (L[x] == R[x])
        {
            DO[x] = val;
            return;
        }
        change(pos, val, x << 1);
        change(pos, val, x << 1 | 1);
        DO[x] = DO[x << 1] + DO[x << 1 | 1];
    }
};
signed main()
{
    int n, f;
    cin >> n >> f;
    if (n == f)
    {
        cout << 1 << endl;
        return 0;
    }
    vector<vector<vector<int> > > dp(n + 1, vector<vector<int> > (2, vector<int> (n + 1)));
    vector<vector<seg_tree> > x(n + 1, vector<seg_tree> (2, seg_tree(n)));
    dp[f][0][f] = 1;
    dp[f][1][f] = 1;
    for (int sum = 1; sum <= n; ++sum)
    {
        for (int i = 1; i <= n; ++i)
        {
            if (sum < i) continue;
            for (int k = 0; k < 2; ++k)
            {
                if (k == 0)
                {
                    int d = x[sum - i][1].sum(i + 1, sum);
                    dp[sum][k][i] += d;
                }
                else
                {
                    int d = x[sum - i][0].sum(1, min(i - 1, sum));
                    dp[sum][k][i] += d;
                }
                x[sum][k].change(i, dp[sum][k][i]);
            }
        }
    }
    int res = 0;
    for (int i = 1; i <= n; ++i)
    {
        res += dp[n][0][i];
        if (res > p) res -= p;
        res += dp[n][1][i];
        if (res > p) res -= p;
    }
    cout << res << endl;
}

