#include <iostream>
#include <vector>

struct node{
	int c;
	std::vector<int> p;
	node(){
		p = std::vector<int>(0);
		c = -1;
	}
};

int n;
std::vector<node> g;
std::vector<int> nc;
std::vector<int> us;

int ccnt = 0;
int dfs_c(int v){
	us[v] = 1;
	
	if(g[v].c == -1){
		nc[v] = -1;
	}
	else if(!us[g[v].c]){
		nc[v] = dfs_c(g[v].c);
	}
	else if(us[g[v].c] == 2)
		nc[v] = -1;
	else if(us[g[v].c] == 1){
		nc[v] = ccnt;
		ccnt++;
		us[g[v].c] = 3;
	}
	
	if(us[v] == 3){
		us[v] = 2;
		return -1;
	}
	us[v] = 2;
	return nc[v];
}

void find_cycles(){
	us.assign(n,0);
	nc.assign(n,-1);
	for(int v=0;v<n;v++)
		if(!us[v])
			dfs_c(v);
}

std::vector<std::vector<int>> dp;
void dfs_p(int v){
	us[v] = 1;
	
	for(auto to:g[v].p){
		if(nc[to] == -1){
			if(!us[to])
				dfs_p(to);
			dp[v][0] += std::max(dp[to][1],dp[to][0]);
			dp[v][1] += dp[to][0];
		}
	}
}

void calc_dp(){
	us.assign(n,0);
	dp.assign(n,std::vector<int>{0,1});
	for(int v=0;v<n;v++)
		if(!us[v])
			dfs_p(v);
}

int calc_cdp(int v){
	std::vector<int> dp1(2);
	std::vector<int> dp2(2);
	int c = g[v].c;
	
	dp1[0] = dp[c][0];
	dp1[1] = 0;
	for(int cv=g[c].c;cv!=v;cv=g[cv].c){
		int t = dp1[0];
		dp1[0] = dp1[1]+t + dp[cv][0];
		dp1[1] = t + dp[cv][1];
	}
	
	dp2[0] = dp[c][0];
	dp1[1] = dp[c][1];
	for(int cv=g[c].c;cv!=v;cv=g[cv].c){
		int t = dp2[0];
		dp2[0] = dp2[1]+t + dp[cv][0];
		dp2[1] = t + dp[cv][1];
	}
	
	return std::max(dp[v][1] + dp1[0],std::max(dp2[0],dp2[1]));
}

int main(){
	std::cin>>n;
	g.resize(n);
	for(int i=0;i<n;i++){
		int a; std::cin>>a;
		if(a == -1)
			continue;
		g[i].c = a-1;
		g[a-1].p.push_back(i);
	}
	
	find_cycles();
	calc_dp();
	
	int ans = 0;
	std::vector<bool> c_us(ccnt,false);
	for(int v=0;v<n;v++){
		if(g[v].c == -1)
			ans += std::max(dp[v][0],dp[v][1]);
		else if(nc[v] != -1 && !c_us[nc[v]]){
			c_us[nc[v]] = true;
			ans += calc_cdp(v);
		}
	}
	
	std::cout<<ans<<std::endl;
}
