#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

typedef long long ll;

int cp;

struct arthefact {
    vector<int> param;
    vector<int> state;
    int ind;
    int k;
    arthefact(int indd, int kk) {
        ind = indd;
        k = kk;
        param.resize(k);
        state.resize(k);
    }
    bool operator<(arthefact a) {
        return param[cp] < a.param[cp];
    }
    int get_st() {
        int res = 0;
        for (int i = 0; i < k; ++i) {
            res = (res << 1) + state[i];
        }
        return res;
    }
};

int main() {
    int n, k;
    cin >> n >> k;
    vector<arthefact> v;
    for (int i = 0; i < n; ++i) {
        v.push_back({i, k});
        for (int j = 0; j < k; ++j) {
            cin >> v[i].param[j];
        }
    }
    for (cp = 0; cp < k; ++cp) {
        sort(v.begin(), v.end());
        for (int i = 0; i < n / 2; ++i) {
            v[i].state[cp] = 0;
        }
        for (int i = n / 2; i < n; ++i) {
            v[i].state[cp] = 1;
        }
    }
    int m = 1 << k;
    vector<vector<int>> by_st(m);
    for (int i = 0; i < n; ++i) {
        by_st[v[i].get_st()].push_back(v[i].ind + 1);
    }
    vector<pair<int, int>> ans;
    for (int i = 0; i < m / 2; ++i) {
        if (by_st[i].size() != by_st[m - i - 1].size()) {
            cout << "NO" << endl;
            return 0;
        }
        for (int j = 0; j < by_st[i].size(); ++j) {
            ans.push_back({by_st[i][j], by_st[m - i - 1][j]});
        }
    }
    cout << "YES" << endl;
    for (auto i : ans) {
        cout << i.first << " " << i.second << endl;
    }
}

