#include "pch.h"
#include <iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>

using namespace std;

#define int long long

const int mod = 1e9 + 7;
vector<vector<pair<int, int>>> vec;

void update(int sum, int v, int l, int r, pair<int, int> val, int pos)
{
	if (pos < l || pos >= r)
	{
		return;
	}
	else if (l + 1 == r)
	{
		vec[sum][v] = { val.first % mod, val.second % mod };
	}
	else
	{
		int m = (l + r) / 2;
		update(sum, v * 2, l, m, val, pos);
		update(sum, v * 2 + 1, m, r, val, pos);
		vec[sum][v].first = (vec[sum][v * 2].first + vec[sum][v * 2 + 1].first) % mod;
		vec[sum][v].second = (vec[sum][v * 2].second + vec[sum][v * 2 + 1].second) % mod;;
	}
}

int get(int sum, int v, int tl, int tr, int l, int r, int p)
{
	if (tr <= l || r <= tl)
	{
		return 0;
	}
	if (l <= tl && tr <= r)
	{
		if (p == 0)
		{
			return vec[sum][v].first % mod;
		}
		else
		{
			return vec[sum][v].second % mod;
		}
	}
	int m = (tl + tr) / 2;
	return (get(sum, v * 2, tl, m, l, r, p) + get(sum, v * 2 + 1, m, tr, l, r, p)) % mod;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, k;
	cin >> n >> k;
	vec.resize(n + 1, vector<pair<int, int>>((n + 1) * 4));
	update(k, 1, 0, n, { 1, 1 }, k);
	for (int i = k + 1; i <= n; i++)
	{
		for (int j = 1; j < i; j++)
		{
			int t0 = get(i - j, 1, 0, n + 1, j + 1, n + 1, 1) % mod;
			int t1 = get(i - j, 1, 0, n + 1, 1, j, 0) % mod;
			update(i, 1, 0, n, { t0, t1 }, j);
		}
	}
	int ans = 0;
	if (k == n)
	{
		cout << 1;
	}
	else
	{
		ans += get(n, 1, 0, n, 1, n, 0) % mod;
		ans += get(n, 1, 0, n, 1, n, 1) % mod;
		cout << ans % mod;
	}
} 
