#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

const int NN = 5 * 1000 + 100;

const long long MOD = 1000 * 1000 * 1000 + 9;
long long dp[NN][NN];

long long solve(long long n, long long k) {
    ++n;
    dp[k][k] = 1;
    for (int i = 1; i < n; ++i) {
        for (int j = 1; j <= i; ++j) {
            if (!dp[i][j])
                continue;
            for (long long k1 = 1; k1 < j; ++k1) {
                dp[i + k1][k1] = (dp[i + k1][k1] + 1) % MOD;
            }
            for (long long k1 = j + 1; k1 < n - i; ++k1) {
                dp[i + k1][k1] = (dp[i + k1][k1] + 1) % MOD;
            }
        }
    }
    long long res = 0;
    for (int i = 0; i < n; ++i) {
        res = (res + dp[n - 1][i]) % MOD;
    }
    return res;
}


int main()
{
    long long n, k;
    cin >> n >> k;
    cout << solve(n, k);
   
}
