#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <bitset>

using namespace std;

typedef pair<int, int> pr;

const int NN = 3 * 1000 * 100 + 7;
int countt = 0;
int used[NN];
vector<int> g[NN];
vector <vector <int> > comp;

void bfs(int root) {
    vector<int> nee;
    nee.push_back(root);
    used[root] = ++countt;
    queue<int> q;
    q.push(root);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (auto u : g[v]) {
            if (!used[u]) {
                used[u] = countt;
                nee.push_back(u);
                q.push(u);
            }
        }
    }
    comp.push_back(nee);
}

pr dp[NN];
int used1[NN];

void dfs(int root) {
    used1[root] = 1;
    dp[root] = { 0, 1 };
    for (auto u : g[root]) {
        if (used1[u])
            continue;
        dfs(u);
        dp[root].first += dp[u].second;
        dp[root].second += dp[u].first;
    }
}

int din(const vector<int> &v) {
    for (int i = 0; i < NN; ++i)
        dp[i] = { 0, 0 };
    dfs(v[0]);
    return max(dp[v[0]].first, dp[v[0]].second);
}

int solve(int n) {
    for (int i = 0; i < n; ++i) {
        if (!used[i])
            bfs(i);
    }
    int res = 0;
    for (auto v: comp) {
        res += din(v);
    }
    return res;
}


set<pr> reb;
const int MM = 20;

int peiebor(int n) {
    long long ans = 0;
    for (int mask = 1; mask < (1 << n); ++mask) {
        vector<int> now;
        bitset<MM> rr = mask;
        for (auto e = 0; e < MM; ++e) {
            if (rr[e])
                now.push_back(e);
        }
        bool fl = true;
        for (int i = 0; i < now.size(); ++i) {
            for (int j = i + 1; j < now.size(); ++j) {
                if (reb.find({ now[i], now[j] }) != reb.end())
                    fl = false;
            }
        }
        if (fl)
            ans = max(ans, (long long)now.size());
    }
    return ans;
}

int main()
{
   long long n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int c;
        cin >> c;
        if (c == -1)
            continue;
        --c;
        reb.insert({ c, i });
        reb.insert({ i, c });
        g[i].push_back(c);
        g[c].push_back(i);
    }
   if (n <= 20) {
        cout << peiebor(n);
        exit(0);
    }
    cout << solve(n);
   // cout << '\n' << peiebor(n);
   
}
