#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define f   first
#define s   second

typedef pair<int, int> ppp;

struct pr {
    int a, b;
    int ind;
};

vector<pr> v;

bool cmp(pr x, pr y) {
    return x.a < y.a;
}
bool cmp1(pr x, pr y) {
    return x.b < y.b;
}

vector<ppp> res;

vector<vector<int> > g;

bool check(const vector<int> &h, int k) {
    int n = h.size();
    vector<int> l(k, -(1 << 30));
    vector<int> r(k, (1 << 30));
    for (int i = 0; i < n; i += 2) {
        int x = h[i] - 1;
        int y = h[i + 1] - 1;
        for (int j = 0; j < k; ++j) {
            l[j] = max(l[j], min(g[x][j], g[y][j]));
            r[j] = min(r[j], max(g[x][j], g[y][j]));
        }
    }
    for (int i = 0; i < k; ++i) {
        if (r[i] - l[i] < 0)
            return false;
    }
    return true;
}

void prep(const vector<int> &h) {
    for (int i = 0; i < h.size(); i += 2)
        res.push_back({ h[i], h[i + 1] });
}

bool naive(int n, int k) {
    vector<int> h; 
    for (int i = 0; i < n; ++i)
        h.push_back(i + 1);
    if (check(h, k)) {
        prep(h);
        return true;
    }
    while (next_permutation(h.begin(), h.end())) {
        if (check(h, k)) {
            prep(h);
            return true;
        }
    }
    return false;
}

bool solve() {
    sort(v.begin(), v.end(), cmp);
    vector<pr> v1;
    vector<pr> v2;
    for (int i = 0; i < (int)v.size() / 2; ++i)
        v1.push_back(v[i]);
    for (int i = (int)v.size() / 2; i < v.size(); ++i)
        v2.push_back(v[i]);
    sort(v1.begin(), v1.end(), cmp1);
    sort(v2.begin(), v2.end(), cmp1);
    reverse(v2.begin(), v2.end());
   
    int l = -(1 << 30);
    int r = (1 << 30);
    for (int i = 0; i < (int)v.size() / 2; ++i) {
        pr g1 = v1[i];
        pr g2 = v2[i];
        l = max(l, min(g1.b, g2.b));
        r = min(r, max(g1.b, g2.b));
        res.push_back({ g1.ind, g2.ind });
    }
    if (r - l < 0)
        return false;
    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    if (n <= 10) {
        g.resize(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < k; ++j) {
                int cc;
                cin >> cc;
                g[i].push_back(cc);
            }
        }
        if (naive(n, k)) {
            cout << "YES\n";
            for (auto e : res) {
                cout << e.first << ' ' << e.second << '\n';
            }
        }
        else {
            cout << "NO";
        }

        exit(0);
    }
    if (k == 2) {

        for (int i = 0; i < n; ++i) {
            int a, b;
            cin >> a >> b;
            v.push_back({ a, b, i + 1 });
        }
        if (!solve()) {
            cout << "NO";
            exit(0);
        }
        cout << "YES\n";
        for (auto e : res) {
            cout << e.first << ' ' << e.second << '\n';
        }
        exit(0);
    }
    if (k == 1) {
        vector<ppp> vv;
        for (int i = 0; i < n; ++i) {
            int c;
            cin >> c;
            vv.push_back({ c, i + 1 });
        }
        sort(vv.begin(), vv.end());
        cout << "YES\n";
        for (int i = 0; i < n / 2; ++i) {
            cout << vv[i].second << ' ' << vv[n - i - 1].second << '\n';
        }
    }
}