#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;};
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;};
using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = (int)3e5 + 1;
int a[MAXN];
vector<int> where[MAXN];
int cnt[MAXN];

int get_min(int x) {
    return cnt[x] >= where[x].size() ? MAXN : where[x][cnt[x]];
}

struct node {
    node *l, *r;
    int x, y;
    int sz, mn;
    node(int _x) {
        l = r = nullptr;
        x = _x;
        y = (rand() << 16) + rand();
        sz = 1;
        mn = get_min(x);
    }
};

int get_sz(node *a) {
    return !a ? 0 : a->sz;
}

int get_mn(node *a) {
    return !a ? MAXN : a->mn;
}

void upd(node *a) {
    if (!a) return;
    a->sz = 1 + get_sz(a->l) + get_sz(a->r);
    a->mn = min(get_min(a->x), min(get_mn(a->l), get_mn(a->r)));
}

pair<node*, node*> split(node *a, int k) {
    if (!a) return {nullptr, nullptr};
    if (get_sz(a->l) + 1 <= k) {
        auto tmp = split(a->r, k - (get_sz(a->l) + 1));
        a->r = tmp.f;
        upd(a);
        return {a, tmp.s};
    }
    else {
        auto tmp = split(a->l, k);
        a->l = tmp.s;
        upd(a);
        return {tmp.f, a};
    }
};

node *merge(node *a, node *b) {
    if (!a) return b;
    if (!b) return a;
    if (a->y > b->y) {
        a->r = merge(a->r, b);
        upd(a);
        return a;
    }
    else {
        b->l = merge(a, b->l);
        upd(b);
        return b;
    }
}

int get_pos(node *a, int l, int k = 0) {
    if (!a) return k;
    if (get_mn(a->r) > l) {
        if (get_min(a->x) > l) {
            return get_pos(a->l, l, k);
        }
        else return k + get_sz(a->l) + 1;
    }
    else return get_pos(a->r, l, k + 1 + get_sz(a->l));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
        cnt[a[i]]++;
    }
    for (int i = 1; i <= n; ++i) {
        where[i].resize(cnt[i]);
        cnt[i] = 0;
    }
    for (int i = 0; i < m; ++i) {
        where[a[i]][cnt[a[i]]++] = i;
    }
    memset(cnt, 0, sizeof cnt);
    node *b = nullptr;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        b = merge(b, new node(x));
    }

    vector<int> ans;
    for (int i = 0; i < m; ++i) {
        while (1) {
            auto tmp = split(b, 1);
            node *cur = tmp.f;
            if (cur->x == a[i]) {
                cnt[cur->x]++;
                upd(cur);
            }
            int next_need = get_min(cur->x);
            if (next_need == MAXN) {
                ans.pb(n);
                b = tmp.s;
            }
            else {
                int pos = get_pos(tmp.s, next_need);
                ans.pb(pos + 1);
                auto tmp1 = split(tmp.s, pos);
                b = merge(tmp1.f, merge(cur, tmp1.s));
            }
            if (cur->x == a[i]) break;
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans)
        cout << i << ' ';
    return 0;
}