#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 3e5 + 1;
const int MOD = 1e9 + 7;
int fact[MAXN], rfact[MAXN];

int mul(ll a, int b) {
    return a * b % MOD;
}

int add(int a, int b) {
    a += b;
    if (a >= MOD) a -= MOD;
    if (a < 0) a += MOD;
    return a;
}

int bpow(int a, int n) {
    if (!n) return 1;
    if (n & 1)
        return mul(bpow(mul(a, a), n / 2), a);
    else return bpow(mul(a, a), n / 2);
}

void init() {
    fact[0] = 1;
    for (int i = 1; i < MAXN; ++i)
        fact[i] = mul(fact[i - 1], i);
    rfact[MAXN - 1] = bpow(fact[MAXN - 1], MOD - 2);
    for (int i = MAXN - 2; i >= 0; --i)
        rfact[i] = mul(rfact[i + 1], i + 1);
}

int check(int bits, ll k) {
    ll x = 0;
    for (int i = 0; i < bits; ++i)
        x += (1LL << i);
    return x <= k;
}

int C(int n, int k) {
    if (n < 0 || n - k < 0 || k < 0) return 0;
//    while (n < 0 || n - k < 0 || k < 0);
//    assert(n >= 0 && n - k >= 0 && k >= 0);
//    cout << n << ' ' << k << ' ' << mul(fact[n], mul(rfact[k], rfact[n - k])) << endl;
    return mul(fact[n], mul(rfact[k], rfact[n - k]));
}

int count_masks(int bits, ll k) {
    int res = 0;
    for (int i = 61; i >= 0 && bits >= 0; --i) {
        if ((k >> i) & 1) {
            if (bits <= i)
                res = add(res, C(i, bits));
            --bits;
        }
    }
    if (!bits)
        res = add(res, 1);
    return res;
}

int count_masks_stup(int bits, ll k) {
    int res = 0;
    for (int i = 0; i <= k; ++i) {
        if (__builtin_popcount(i) == bits)
            ++res;
    }
    return res;
}

map<pair<int, int>, int> d;

int solve(int rest, int bits) {
    if (d.find({rest, bits}) != d.end()) return d[{rest, bits}];
    if (rest == 0) {
        if (bits > 0) return 0;
        return d[{0, 0}] = 1;
    }
    int res = 0;
    for (int i = 0; i <= bits; ++i) {
        int tmp = solve(rest - 1, bits - i);
        res = add(res, mul(tmp, C(bits, i)));
    }
    return d[{rest, bits}] = res;
}

int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0), cout.tie(0);
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout); lol
    init();
    int n, m;
    ll k;
    cin >> n >> m >> k;
    if (m == 0) {
        int ans = 0;
        for (int i = 0; check(i, k); ++i) {
            int val = count_masks(i, k);
            ans = add(ans, mul(val, solve(n, i)));
        }
        cout << ans;
        return 0;
    }
//    int n, m;
//    ll k;
//    cin >> n >> m >> k;
//
//    rec(0, 0, -1);

    return 0;
}