#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define mp make_pair
using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1, MAXK = 8;
int k, CUR;
vector<int> a[MAXN];
vector<int> features[MAXK];
int b[MAXK];
vector<int> masks;

int pw(int x, int n) {
    int res = 1;
    for (int i = 0; i < n; ++i)
        res *= x;
    return res;
}

vector<int> mask[10000];
vector<int> to_vector[10000];
int binmask[10000];

int to_mask(vector<int> & kek) {
    int res = 0;
    for (int i = 0; i < kek.size(); ++i) {
        res = res * 3 + kek[i];
    }
    return res;
}

bool match(int i, int j) {
    vector<int> a = to_vector[i], b = to_vector[j];
    for (int l = 0; l < k; ++l) {
        if (a[l] == 1 || b[l] == 1) continue;
        if (a[l] == b[l]) return false;
    }
    return true;
}

void init() {
    for (int i = 0; i < pw(3, k); ++i) {
        int mask = i;
        while (to_vector[i].size() < k) {
            to_vector[i].pb(mask % 3);
            mask /= 3;
        }
        reverse(to_vector[i].begin(), to_vector[i].end());
        for (int j = 0; j < k; ++j)
            if (to_vector[i][j] == 1)
                binmask[i] |= (1 << j);
        masks.pb(i);
    }
}

bool cmp(int a, int b) {
    if (binmask[a] == binmask[b]) return a < b;
    return (binmask[a] & binmask[b]) == binmask[a];
}


void solve_stupid(int n) {
	for (int i = 0; i < n; ++i)
		a[i].pb(i + 1);
	sort(a, a + n);
	vector<int> a1, a2;
	for (int i = 0; i < n / 2; ++i) {
		a1.pb(i);
		a2.pb(i + n / 2);
	}
	do {
		sort(a2.begin(), a2.end());
		do {
			bool fl = true;
			for (int i = 0; i < n / 2; ++i) {

				for (int j = 0; j < k; ++j) {
					if ((a[a1[i]][j] <= b[j] && b[j] <= a[a2[i]][j]) || (a[a1[i]][j] >= b[j] && b[j] >= a[a2[i]][j])) {

					}
					else
						fl = false;
				}
			}
			if (fl) {
				cout << "YES\n";
				for (int i = 0; i < n / 2; ++i) {
					cout << a[a1[i]][k] << ' ' << a[a2[i]][k] << '\n';
				}
				return;
			}

		} while (next_permutation(a2.begin(), a2.end()));
	} while (next_permutation(a1.begin(), a1.end()));
	cout << "NO";
}

bool cmp228(vector<int> a, vector<int> b) {
	return a[CUR] < b[CUR];
}

const int MAXN1 = 1000;
int lft[MAXN1];
int gt[MAXN1][MAXN1];
vector<int> gl[MAXN1];
int pl[MAXN1], pr[MAXN1];
int used[MAXN1];
int ct = 1;

bool try_kuhn(int v) {
	if (used[v] == ct) return false;
	used[v] = ct;
	for (int u : gl[v]) {
		if (pr[u] == -1 || try_kuhn(pr[u])) {
			pl[v] = u;
			pr[u] = v;
			return true;
		}
	}
	return false;
}

void solve_kuhn(int n) {
	for (int i = 0; i < n; ++i)
		a[i].pb(i);
	sort(a, a + n);
	for (int i = 0; i < n / 2; ++i) {
		lft[a[i][k]] = true;
	}
	for (int j = 0; j < k; ++j) {
		CUR = j;
		sort(a, a + n, cmp228);
		// for (int i = 0; i < n; ++i) {
		// 	for (int j = 0; j <= k; ++j) {
		// 		cout << j << ' ';
		// 	}

		// }
		for (int i = 0; i < n; ++i) {
			for (int l = 0; l < n; ++l) {
				if ((a[i][j] <= b[j] && b[j] <= a[l][j]) || (a[i][j] >= b[j] && b[j] >= a[l][j]))
					++gt[a[i][k]][a[l][k]];
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (!lft[i]) continue;
		for (int j = 0; j < n; ++j) {
			if (lft[j]) continue;
			if (gt[i][j] == k) {
				gl[i].pb(j);
			}
		}
	}
	// for (int i = 0; i < n; ++i) {
	// 	cout << i + 1 << ": ";
	// 	for (int j : gl[i])
	// 		cout << j + 1 << ' ';
	// 	cout << endl;
	// }
	memset(pl, 255, sizeof pl);
	memset(pr, 255, sizeof pr);
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (!lft[i]) continue;
		if (pl[i] == -1 && try_kuhn(i)) {
			++ct, ++cnt;
		}
	}
	if (cnt < n / 2) {
		cout << "NO";
		return;
	}
	cout << "YES\n";
	for (int i = 0; i < n; ++i) {
		if (lft[i]) {
			cout << i + 1 << ' ' << pl[i] + 1 << '\n';
		}
	}
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
   // freopen("input.txt", "r", stdin);
//	 freopen("output.txt", "w", stdout);

    int n;
    cin >> n >> k;
    init();
    sort(masks.begin(), masks.end(), cmp);
    for (int i = 0; i < n; ++i) {
        a[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
            features[j].pb(a[i][j]);
        }
    }
    // cout << "b: ";
    for (int j = 0; j < k; ++j) {
        sort(features[j].begin(), features[j].end());
        b[j] = features[j][n / 2];
        // cout << b[j] << ' ';
    }
    // cout << endl;
    if (n <= 400) {
    	// solve_stupid(n);
    	solve_kuhn(n);
    	return 0;
    }
    cout << "masks" << endl;
    for (int i = 0; i < n; ++i) {
        vector<int> cur(k);
        for (int j = 0; j < k; ++j) {
            if (a[i][j] < b[j])
                cur[j] = 0;
            if (a[i][j] == b[j])
                cur[j] = 1;
            if (a[i][j] > b[j])
                cur[j] = 2;
        }
        for (auto j : cur)
        	cout << j;
        cout << endl;
        mask[to_mask(cur)].pb(i);
    }
    cout << endl << endl;
    vector<pair<int, int>> ans;
    for (int i : masks) {
    	if (mask[i].size()) {
    		auto tmp = to_vector[i];
    		for (auto j : tmp)
    			cout << j;
    		cout << endl;
    	}
    }
    for (int i = 0; i < masks.size(); ++i) {
        int cmask = masks[i];
        while (!mask[cmask].empty()) {
            bool fl = false;
            for (int j = i; j < masks.size(); ++j) {
                int tmask = masks[j];
                if (mask[tmask].empty() || !match(cmask, tmask)) continue;
                ans.pb({mask[cmask].back(), mask[tmask].back()});
                mask[cmask].pop_back();
                mask[tmask].pop_back();
                fl = true;
                break;
            }
            if (!fl) {
                cout << "NO";
                return 0;
            }
        }
    }
    cout << "YES\n";
    for (auto i : ans)
        cout << i.f + 1 << ' ' << i.s + 1 << '\n';
    return 0;
}