#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define all(v) v.begin(), v.end()
#define x first
#define y second
#pragma GCC optimize("fast-math")

vector<int> rmq;

vector<int> a, b;

void build(int v, int l, int r)
{
	if (l + 1 == r)
	{
		rmq[v] = 0;
		return;
	}
	build(v + v, l, (l + r) / 2);
	build(v + v + 1, (l + r) / 2, r);
	rmq[v] = rmq[v + v] + rmq[v + v + 1];
}

int get(int v, int l, int r, int ind)
{
	if (l == ind && l + 1 == r) return rmq[v];
	int m = (l + r) / 2;
	if (ind < m) return get(v + v, l, m, ind) + rmq[v];
	return get(v + v + 1, m, r, ind) + rmq[v];
}


void update(int v, int l, int r, int tl, int tr)
{
	if (tl >= tr) return;
	if (tl >= r) return;
	if (tr <= l) return;
	if (tl <= l && tr >= r)
	{
		rmq[v]++;
		return;
	}
	int m = (l + r) / 2;
	if (tr < m) update(v + v, l, m, tl, tr);
	else update(v + v + 1, m, r, tl, tr);
}


int32_t main()
{
	cin.tie(NULL);
	ios::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	a.resize(m);
	b.resize(n);
	for (int i = 0; i < m; i++)
	{
		cin >> a[i];
		a[i]--;
	}
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
		b[i]--;
	}

	if (n == m)
	{
		bool flag = true;
		for (int i = 0; i < n; i++) flag = flag & (a[i] == b[i]);
		if (flag)
		{
			cout << n << '\n';
			for (int i = 0; i < n; i++)
			{
				cout << n << " ";
			}
			system("pause");
			return 0;
		}
		flag = true;
		for (int i = 0; i < n; i++) flag = flag & (a[i] == b[n - i - 1]);
		if (flag)
		{
			cout << n + n - 1 << '\n';
			for (int i = 0; i < n - 1; i++)
			{
				cout << n - i << " ";
			}
			for (int i = 0; i < n; i++) cout << n << " ";
			system("pause");
			return 0;
		}
	}


	if (n <= 2000 && m <= 2000)
	{
		vector<int> ans;
		bool flag;
		int kolvo;
		int curr = 0;
		vector<bool> used(n, false);
		int where;
		auto it = b.begin();
		int j;
		for (int i = 0; i < m;)
		{
			flag = false;
			curr = b[0];
			kolvo = 0;
			j = i + 1;
			if (a[i] != b[0]) j--;
			for (j; j < m; j++)
			{
				if (a[j] == b[0])
				{
					flag = true;
					break;
				}
				if (!used[a[j]])
				{
					kolvo++;
					used[a[j]] = true;
				}
			}
			b.erase(b.begin());
			where = 1;
			for (it = b.begin(); it != b.end(); it++)
			{
				if (kolvo == 0) break;
				where++;
				if (used[*it])
				{
					used[*it] = false;
					kolvo--;
				}
			}
			ans.push_back(where);
			b.insert(it, curr);
			if (curr == a[i]) i++;
		}
		cout << ans.size() << '\n';
		for (auto i : ans) cout << i << " ";
		return 0;
	}

	int pp = 1;
	while (pp < n) pp <<= 1;
	rmq.resize(2 * pp + 100, 0);
	int tm = 0;
	vector<int> ind(n, -1);
	vector<int> ind2(n, -1);
	vector<bool> used(n, false);
	vector<bool> u(n, false);
	for (auto i : a) u[i] = true;
	int curr = 0;
	vector<int> ans;
	int last = 0;
	build(1, 0, pp);
	for (int i = 0; i < m;)
	{
		
		if (b[curr] == a[i])
		{
			ans.push_back(n);
			update(1, 0, pp, 0, last);
			curr++;
			i++;
			continue;
		}
		if (used[a[i]])
		{
			update(1, 0, pp, ind[a[i]] + 1, last);
			ans[ind2[a[i]]] = get(1, 0, pp, ind[a[i]]) + 1;
			i++;
			continue;
		}
		if (!u[b[curr]])
		{
			ans.push_back(n);
			curr++;
			update(1, 0, pp, 0, last);
			continue;
		}
		update(1, 0, pp, 0, last);
		used[b[curr]] = true;
		ind2[b[curr]] = ans.size();
		ans.push_back(-1);
		ind[b[curr++]] = last++;
	}
	cout << ans.size() << '\n';
	last--;
	for (auto i : ans)
	{
			cout << i << " ";
			continue;
	}
	system("pause");
	return 0;
}
/*
#define mod 1000000007

bool check(int a, int b)
{
	for (int i = 0; i <= 10; i++)
	{
		if ((a >> i) & 1)
		{
			if (!((b >> i) & 1)) return false;
		}
	}
	return true;
}

int32_t main()
{
	
	int n, m, k;
	cin >> n >> m >> k;
	if (n <= 500 && k <= 500)
	{
		int ans = 0;
		vector<vector<int>> a(k + 1, vector<int>(0));
		for (int i = 0; i <= k; i++)
		{
			for (int j = i; j <= k; j++)
			{
				if (check(i, j)) a[i].push_back(j);
			}
		}
		vector<int> curr(k + 1, 1), tmp(k + 1);
		for (int i = 1; i < n; i++)
		{
			tmp.assign(k + 1, 0);
			for (auto j = 0; j <= k; j++)
			{
				for (auto t : a[j])
				{
					tmp[t] += curr[j];
					if (tmp[t] >= mod) tmp[t] -= mod;
				}
			}
			curr = tmp;
		}
		for (auto i : curr)
		{
			ans += i;
			if (ans >= mod) ans -= mod;
		}
		cout << ans;
		return 0;
	}
	if (n >= 300000) return 2;
	system("pause");
	return 0;
}*/