#include <iostream>
#include <vector>
#include <set>
#pragma GCC optimize "O3"

using namespace std;

struct node {
    long long x, y, sz, mn, v;
    node * left, * right;
    node (long long val, long long val2) {
        x = val;
        v = val2;
        sz = 1;
        left = right = nullptr;
        y = rand();
    }
};

inline long long getSize(node * root) {
    if (root == nullptr) return 0;
    return root -> sz;
}

inline long long getMin(node * root) {
    if (root == nullptr) return 1000000000;
    return root -> mn;
}

inline void update(node * root) {
    if (root == nullptr) return;
    root -> sz = getSize(root -> left) + getSize(root -> right) + 1;
    root -> mn = min(getMin(root -> left), min(getMin(root -> right), root -> v));
}

inline node * merge(node * root1, node * root2) {
    if (root1 == nullptr) return root2;
    if (root2 == nullptr) return root1;
    if (root1 -> y < root2 -> y) {
        root1 -> right = merge(root1 -> right, root2);
        update(root1);
        return root1;
    }
    root2 -> left = merge(root1, root2 -> left);
    update(root2);
    return root2;
}

inline pair<node *, node *> split(node * root, long long x) {
    if (root == nullptr) return {nullptr, nullptr};
    if (x <= 0) return {nullptr, root};
    if (getSize(root) == x) return {root, nullptr};
    if (getSize(root -> left) >= x) {
        auto res = split(root -> left, x);
        root -> left = res.second;
        update(res.first);
        update(root);
        return {res.first, root};
    }
    auto res = split(root -> right, x - getSize(root -> left) - 1);
    root -> right = res.first;
    update(root);
    update(res.second);
    return {root, res.second};
}

void print (node * root) {
    if (root == nullptr) return;
    print (root -> left);
    cout << "(" << root -> x << ", " << getMin(root) << "); ";
    print (root -> right);
}

inline node * add(node * root, long long x, long long v, long long v1) {
    auto [res1, res2] = split(root, x);
    res1 = merge(res1, new node(v, v1));
    return merge(res1, res2);
}

inline node * cut(node * root, long long x) {
    auto[res1, tmp] = split(root, x);
    auto [res2, res3] = split(tmp, 1);
    return merge(res1, res3);
}

inline long long first (node * root) {
    if (root == nullptr) return -1;
    if (root -> left != nullptr) return first(root -> left);
    else return root -> x;
}

int main() {
    node * rt = nullptr;
    long long n, m, b;
    cin >> n >> m;
    vector<long long> ar(n);
    for (long long i = 0; i < m; ++i) {
        cin >> ar[i];
        ar[i]--;
    }
    vector<long long> cur(n, -1), fr(n, 1000000000);
    for (long long i = 0; i < m; ++i) {
        fr[ar[i]] = min(fr[ar[i]], i);
    }
    for (long long i = 0; i < n; ++i) {
        cin >> b;
        rt = add(rt, i, b - 1, fr[b - 1]);
        cur[b - 1] = i;
    }
    vector<long long> last(n, -1), next(m, -1);
    set<pair<long long, long long>> qs;
    for (long long i = 0; i < m; ++i) {
        qs.insert({ar[i], i});
        if (last[ar[i]] != -1) next[last[ar[i]]] = i;
        last[ar[i]] = i;
    }
    vector<long long> ans;
    for (long long i = 0; i < m; ++i) {
        long long f = first(rt);
        while (f != ar[i]) {
            rt = cut(rt, 0);
            auto nx = qs.upper_bound({f, i});
            if (nx == qs.end() || nx -> first != f || (*nx == (pair<long long, long long>){f, i})) {
                if (f == first(rt)) {
                    ans.push_back(1);
                    rt = add(rt, 0, f, 1000000000);
                } else {
                    ans.push_back(n);
                    rt = add(rt, n - 1, f, 1000000000);
                }
            } else {
                long long l = -1, r = n, mm;
                while (r > l + 1) {
                    mm = (l + r) / 2;
                    auto[res1, res2] = split(rt, mm);
                    if (getMin(res2) > nx->second) r = mm;
                    else l = mm;
                    merge(res1, res2);
                }
                ans.push_back(r + 1);
                rt = add(rt, r, f, nx -> second != 0 ? nx -> second : 1000000000);
            }
            f = first(rt);
        }
        rt = cut(rt, 0);
        auto nx = qs.upper_bound({f, i});
        if (nx == qs.end() || nx -> first != f || (*nx == (pair<long long, long long>){f, i})) {
            if (f == first(rt)) {
                ans.push_back(1);
                rt = add(rt, 0, f, 1000000000);
            } else {
                ans.push_back(n);
                rt = add(rt, n - 1, f, 1000000000);
            }
        } else {
            if (i == m- 2) {
//                cout << first(rt) << endl;
//                cout << f << endl;
//                print(rt);
//                cout << endl;
            }
            long long l = -1, r = n, mm;
            while (r > l + 1) {
                mm = (l + r) / 2;
//                if (i == m - 4) cout << l << ' ' << r << ' ' << mm << endl;
                auto[res1, res2] = split(rt, mm);
//                if (i == m - 4) print(res2);
//                if (i == m - 4) cout << ' ' << 1543 << ' ' << f << ' ' << getMin(res2) << endl;
                if (getMin(res2) >= nx->second) r = mm;
                else l = mm;
                merge(res1, res2);
            }
            ans.push_back(r + 1);
            rt = add(rt, r, f, nx -> second != 0 ? nx -> second : 1000000000);
        }
    }
    cout << ans.size() << endl;
    for (auto i : ans) cout << i << ' ';
    cout << endl;
    return 0;
}
