// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int64_t ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

const ll MOD = 1'000'000'007;

ll power(ll a, ll n) {
	if (n == 0) {
		return 1;
	}
	if (n % 2 == 0) {
		return power((a * a) % MOD, n / 2);
	}
	return (a * power((a * a) % MOD, n / 2)) % MOD;
}

ll get1(ll k, ll n) {
	ll res = 0;
	for (ll i = 0; i <= k; ++i) {
		ll m = 0;
		ll j = i;
		while (j) {
			m += (j & 1);
			j >>= 1;
		}
		res += power(n, m);
	}
	return res % MOD;
}

vector<vector<ll>> g;

vector<vector<ll>> dist;
vector<ll> used;

void dfs(ll v) {
	dist[v].resize(v);
	used[v] = 1;
	dist[v][0] = 1;
	for (auto u : g[v]) {
		if (!used[u]) {
			dfs(u);
		}
		for (ll i = 1; i < 20; ++i) {
			dist[v][i] = (dist[v][i] + dist[u][i - 1]) % MOD;
		}
	}
}

inline void solve() {
	ll n;
	cin >> n;
	ll m;
	cin >> m;
	ll k;
	cin >> k;
	if (m == 0) {
		cout << get1(k, n) << endl;
		return;
	}
	vector<pair<ll, ll>> seg(m);
	for (ll i = 0; i < m; ++i) {
		cin >> seg[i].first >> seg[i].second;
		--seg[i].first;
		--seg[i].second;
	}
	for (ll i = 0; i < n; ++i) {
		for (ll j = i + 1; j < n; ++j) {
			ll flag = 1;
			for (auto q : seg) {
				if (q.first >= i && q.second <= j) {
					flag = 0;
					break;
				}
			}
			g[i].emplace_back(j);
		}
	}
	used.resize(n);
	dist.resize(n);
	dfs(0);
	ll res = 0;
	for (ll i = 0; i < k; ++i) {
		ll m = 0;
		ll j = i;
		while (j) {
			m += (j & 1);
			j >>= 1;
		}
		res = (res + dist[0][m]) % MOD;
	}
}

int main() {
	start();
	solve();
	return 0;
}
