// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int64_t ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

const ll MOD = 1'000'000'007;

ll power(ll a, ll n) {
	if (n == 0) {
		return 1;
	}
	if (n % 2 == 0) {
		return power((a * a) % MOD, n / 2);
	}
	return (a * power((a * a) % MOD, n / 2)) % MOD;
}

ll get1(ll k, ll n) {
	ll res = 0;
	for (ll i = 0; i <= k; ++i) {
		ll m = 0;
		ll j = i;
		while (j) {
			m += (j & 1);
			j >>= 1;
		}
		res += power(n, m);
	}
	return res % MOD;
}

inline void solve() {
	ll n;
	cin >> n;
	ll m;
	cin >> m;
	ll k;
	cin >> k;
	if (m == 0) {
		cout << get1(k, n) << endl;
		return;
	}
	vector<pair<ll, ll>> a(m);
	for (ll i = 0; i < m; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	vector<vector<ll>> dp(n + 1, vector<ll>(6));
	for (ll i = 1; i <= n; ++i) {
		for (ll j = 0; j <= i; ++j) {
			ll flag = 0;
			for (auto s : a) {
				if (s.first > i || s.second < j) {
					flag = 1;
				}
			}
			if (flag) {
				continue;
			}
			for (ll q = 1; q  < 6; ++q) {
				for (ll q2 = 0; q2 < q; ++q2) {
					dp[i][q] = (dp[i][q] + dp[j][q2]) % MOD;
				}
			}
		}
	}
	ll left = 0;
	for (auto i : a) {
		left = max(left, i.first);
	}
	ll res = 0;
	for (ll i = 0; i <= k; ++i) {
		ll m = 0;
		ll j = i;
		while (j) {
			m += (j & 1);
			j >>= 1;
		}
		for (ll i = left; i <= n; ++i) {
			res = (res + dp[i][m]) % MOD;
		}
	}
	cout << res << endl;
}

int main() {
	start();
	solve();
	return 0;
}
