// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

typedef int64_t ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

ll n;
vector<vector<ll>> g;
vector<ll> height;
vector<ll> color;

ll is_odd(ll v, ll p) {
	height[v] = height[p] + 1;
	for (auto u : g[v]) {
		if (u == p) {
			continue;
		}
		if (height[u]) {
			if ((height[v] - height[u]) % 2 == 0) {
				return 0;
			}
		}
		else {
			if (is_odd(u, v)) {
				continue;
			}
			return 0;
		}
	}
	return 1;
}

void dfs(ll v, ll c, ll& cnt1, ll& cnt2) {
	color[v] = c;
	if (c == 1) {
		++cnt1;
	}
	if (c == 2) {
		++cnt2;
	}
	for (ll u : g[v]) {
		if (color[u]) {
			continue;
		}
		dfs(u, 3 - c, cnt1, cnt2);
	}
}

ll get_result(ll v) {
	if (is_odd(v, v)) {
		ll cnt1 = 0;
		ll cnt2 = 0;
		dfs(v, 1, cnt1, cnt2);
		return max(cnt1, cnt2);
	}
}

inline void solve() {
	cin >> n;
	g.resize(n);
	height.resize(n);
	color.resize(n);
	for (ll i = 0; i < n; ++i) {
		ll p;
		cin >> p;
		if (p == -1) {
			continue;
		}
		g[p - 1].emplace_back(i);
		g[i].emplace_back(p - 1);
	}
	ll res = 0;
	for (ll i = 0; i < n; ++i) {
		if (height[i]) {
			continue;
		}
		res += get_result(i);
	}
	cout << res << endl;
}

int32_t main() {
	start();
	solve();
	return 0;
}
