// Megumin top

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <ctime>
#include <set>
#include <map>

using namespace std;

typedef int64_t ll;

inline void start() {
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
}

ll n;
vector<vector<ll>> g;
vector<pair<ll, ll>> dp;
vector<ll> used;
ll need = 1;

void dfs(ll v) {
	used[v] = need;
	dp[v].first = 0;
	dp[v].second = 1;
	for (ll u : g[v]) {
		if (used[u] == need) {
			continue;
		}
		dfs(u);
		dp[v].first += max(dp[u].second, dp[u].first);
		dp[v].second += dp[u].first;
	}
}

inline void solve() {
	cin >> n;
	g.resize(n);
	used.resize(n);
	dp.resize(n);
	for (ll i = 0; i < n; ++i) {
		ll p;
		cin >> p;
		if (p == -1) {
			continue;
		}
		g[p - 1].emplace_back(i);
		g[i].emplace_back(p - 1);
	}
	ll result = 0;
	vector<ll> index(n);
	for (ll i = 0; i < n; ++i) {
		index[i] = i;
	}
	while (clock() < CLOCKS_PER_SEC) {
		random_shuffle(index.begin(), index.end());
		ll res = 0;
		for (ll i : index) {
			if (used[i]) {
				continue;
			}
			dfs(i);
			res += max(dp[i].first, dp[i].second);
		}
		result = max(res, result);
		++need;
	}
	cout << result << endl;
}

int32_t main() {
	start();
	solve();
	return 0;
}
