#include <iostream>
#include <vector>

using namespace std;

int n;
vector<vector<int> > g;
vector<bool> used;
vector<int> p;

void find_comp(int v){
    used[v] = true;
    for (auto i : g[v]){
        if (!used[i]){
            find_comp(i);
        }
    }
}

void find_cycle(int v, int pr, vector<int> & cycle){
    used[v] = true;
    p[v] = pr;
    for (auto i : g[v]){
        if (cycle.size() != 0){
            return;
        }
        if (used[i] && i != p[v]){
            int start = v;
            int fin = i;
            while (start != fin){
                if (start == -1){
                    cout << 5 / 0;
                }
                cycle.push_back(start);
                start = p[start];
            }
            cycle.push_back(fin);
            return;
        }
        if (!used[i]){
            find_cycle(i, v, cycle);
        }
    }
}

vector<int> save;

int dfs(int v, int take){
    used[v] = true;
    int ans = take;
    for (auto i : g[v]){
        if (!used[i]){
            save.push_back(i);
            ans += dfs(i, 1 - take);
        }
    }
    return ans;
}

void undo(){
    for (auto i : save){
        used[i] = false;
    }
    save.resize(0);
}

void clean(){
    used.resize(0);
    used.resize(n);
}

int main()
{
    //freopen("input.txt", "r", stdin);
    cin >> n;
    g.resize(n);
    clean();
    p.resize(n, -1);
    for (int i = 0; i < n; i++){
        int x;
        cin >> x;
        if (x != -1){
            x--;
            g[x].push_back(i);
            g[i].push_back(x);
        }
    }
    vector<int> comp;
    for (int i = 0; i < n; i++){
        if (!used[i]){
            comp.push_back(i);
            find_comp(i);
        }
    }
    clean();
    int ans = 0;
    for (auto r : comp){
        vector<int> cycle;
        find_cycle(r, -1, cycle);
        if (cycle.size()){
            clean();
            int cur = dfs(r, 0);
            undo();
            cur = max(cur, dfs(r, 1));
            ans += cur;
        }else{
            clean();
            int m = cycle.size();
            for (auto i : cycle){
                used[i] = true;
            }
            vector<vector<int> > sz(m, vector<int>(2));
            for (int i = 0; i < m; i++){
                sz[i][0] = dfs(cycle[i], 0);
                undo();
                sz[i][1] = dfs(cycle[i], 1);
            }
            vector<vector<int> > dp1(m, vector<int>(2));
            dp1[0][0] = sz[0][0];
            for (int i = 1; i < m; i++){
                dp1[i][0] = sz[i][0] + max(dp1[i - 1][0], dp1[i - 1][1]);
                dp1[i][1] = sz[i][1] + dp1[i - 1][0];
            }
            vector<vector<int> > dp2(m, vector<int>(2));
            dp2[1][1] = sz[1][0] + sz[0][1];
            dp2[1][0] = sz[1][0] + sz[0][0];
            for (int i = 2; i < m - 1; i++){
                dp2[i][0] = sz[i][0] + max(dp2[i - 1][0], dp2[i - 1][1]);
                dp2[i][1] = sz[i][1] + dp2[i - 1][0];
            }
            ans += max(max(dp1[m - 1][0], dp1[m - 1][1]), sz[m - 1][0] + max(dp2[m - 2][0], dp2[m - 2][1]));
        }

    }
    cout << ans << endl;
    return 0;
}
