#include <iostream>
#include <cmath>

using namespace std;

long long naive(long long k) {
	if (k % 4 == 2) {
		return -1;
	}

	unsigned long long i;
	unsigned long long n = 0;
	while (n * n != k + i * i) {
		if (n * n > k + i * i) {
			i++;
		}
		if (n * n < k + i * i) {
			n++;
		}
		cout << "";
	}
	return n;
}

long long solve(long long k) {
	unsigned long long d, r, m, bestD;
	bool isNegative;

	if (k == 0 || k == -1) {
		return 0;
	}
	if (k == 1) {
		return 1;
	}
	if (abs(k) % 4 == 2) {
		return -1;
	}

	isNegative = (k < 0);
	d = 2;
	k = llabs(k);
	if (isNegative) {
		while (d * d <= k && (d <= sqrt(k))) {
			if (k % d == 0) {
				break;
			}
			d++;
		}
		if (k % d != 0) {
			d = 1;
		}
	} else {
		bestD = (k % 2 == 0) ? 2 : 1;
		while (d * d <= k && (d <= sqrt(k))) {
			if (k % d == 0 && (!(k % 2 == 0) || (d % 2 == 0))) {
				bestD = d;
				//cout << d << " " << (k / d + d) / 2 << endl;
			}
			d++;
		}
		d = bestD;
	}

	r = k / d;
	//cout << d << " " << r << endl;
	m = isNegative ? ((r - d) / 2) : ((r + d) / 2);

	return m;
}

int main() {
	long long k, res;

	cin >> k;

	//cout << solve(k) << ":" << naive(k) << endl;
	res = solve(k);
	if (res >= 0) {
		cout << res << endl;
	} else {
		cout << "none" << endl;
	}

	/*for (long long i = 1000000000; i < k; i++) {
		res = solve(i);
		long long n = i - res * res;
		long long d = 1;
		while (d * d < n) {
			d++;
		}
		if (d * d != n) {
			cout << i << " " << res << endl;
			cout << res * res << " " << i - res * res << endl;
			return -1;
		}
	}*/
	//res = solve(k);
	//cout << " " << res << endl;
	//cout << " " << res * res << endl;
	//cout << " " << res * res - k << endl;

	return 0;
}