#include <bits/stdc++.h>

using namespace std;

#define int long long
const int MOD = 1e9 + 7;

struct DO {
    int n;
    vector<int> tree;

    DO(long long n) : n(n) {
        tree.resize(n * 2, 0);
    }

public:
    void add(int k, int x) {
        k += n;
        tree[k] += x;
        for (k /= 2; k >= 1; k /= 2) {
            tree[k] = f(tree[k * 2], tree[k * 2 + 1]);
        }
    }

    int sum(int a, int b) {
        a += n;
        b += n;
        int res = 0;
        while (b >= a) {
            if (a % 2 == 1) {
                res += tree[a++];
            }
            if (b % 2 == 0) {
                res += tree[b--];
            }
            a /= 2;
            b /= 2;
        }
        return res;
    }

private:
    int f(int a, int b) {
        int res = a + b;
        if (res >= MOD) {
            res -= MOD;
        }
        return res;
    }
};

signed main() {
    int n, k;
    cin >> n >> k;
    if (n == k) {
        cout << 1;
        return 0;
    }
    vector<vector<int>> dp_les(n + 1, vector<int>(n + 1));
    for (int i = 0; i <= n; ++i) {
        dp_les[i][i] = 1;
    }
    vector<vector<int>> dp_gre(n + 1, vector<int>(n + 1));
    for (int i = 0; i <= n; ++i) {
        dp_gre[i][i] = 1;
    }
    for (int sum = 0; sum <= n; ++sum) {
        for (int cur = 1; cur < sum; ++cur) {
            int ost = sum - cur;
            for (int i = 0; i < min(cur, ost); ++i) {
                dp_les[sum][cur] += dp_gre[ost][i];
            }
            for (int i = cur + 1; i <= ost; ++i) {
                dp_gre[sum][cur] += dp_les[ost][i];
            }
            dp_les[sum][cur] %= MOD;
            dp_gre[sum][cur] %= MOD;
        }
    }
    cout << dp_gre[n][k] + dp_les[n][k];


    return 0;
}