#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e9 + 7;

struct DO {
    int n;
    vector<int> tree;

    DO(long long n) : n(n) {
        tree.resize(n * 2, 0);
    }

public:
    void add(int k, int x) {
        k += n;
        tree[k] += x;
        for (k /= 2; k >= 1; k /= 2) {
            tree[k] = f(tree[k * 2], tree[k * 2 + 1]);
        }
    }

    int sum(int a, int b) {
        a += n;
        b += n;
        int res = 0;
        while (b >= a) {
            if (a % 2 == 1) {
                res += tree[a++];
            }
            if (b % 2 == 0) {
                res += tree[b--];
            }
            a /= 2;
            b /= 2;
        }
        return res;
    }

private:
    int f(int a, int b) {
        int res = a + b;
        if (res >= MOD) {
            res -= MOD;
        }
        return res;
    }
};

signed main() {
    int n, k;
    cin >> n >> k;
    if (k == 1) {
        vector<pair<int, int>> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].first;
            a[i].second = i;
        }
        sort(a.begin(), a.end());
        cout << "YES" << "\n";
        for (int i = 0; i < n / 2; ++i) {
            cout << a[i].second + 1 << " " << a[n - i - 1].second + 1 << "\n";
        }
    } else {
        vector<vector<int>> a(n, vector<int>(k));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < k; ++j) {
                cin >> a[i][j];
            }
        }
        vector<int> tmp(n);
        for (int l = 0; l < n; ++l) {
            tmp[l] = l / 2;
        }
        int cnt = 0;
        do {
            bool isOk = true;
            for (int ind = 0; ind < k; ++ind) {
                vector<vector<int>> cur(n / 2);
                for (int i = 0; i < n; i++) {
                    cur[tmp[i]].push_back(a[i][ind]);
                }
                for (int i = 0; i < n / 2; ++i) {
                    sort(cur[i].begin(), cur[i].end());
                }
                vector<pair<int, int>> scan;
                for (int i = 0; i < n / 2; ++i) {
                    scan.push_back({cur[i][0], 1});
                    scan.push_back({cur[i][1], -1});
                }
                sort(scan.begin(), scan.end());
                bool flag = false;
                int balance = 0;
                for (int j = 0; j < n; ++j) {
                    balance += scan[j].second;
                    if (balance == n / 2) {
                        flag = true;
                    }
                }
                if (!flag) {
                    isOk = false;
                }
            }
            if (isOk) {
                vector<vector<int>> cur2(n / 2);
                for (int i = 0; i < n; i++) {
                    cur2[tmp[i]].push_back(i);
                }
                cout << "YES\n";
                for (int j = 0; j < n / 2; ++j) {
                    cout << cur2[j][0]+1 << " " << cur2[j][1]+1 << "\n";
                }
                return 0;
            }
        } while (next_permutation(tmp.begin(), tmp.end()));
        cout << "NO";
    }
    return 0;
}