#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>

#ifndef LOCAL
#define fprintf if (0) fprintf
#endif

void linear_up_solution(int n, int m, std::vector<int>& a, std::vector<int>& b);
void linear_down_solution(int n, int m, std::vector<int>& a, std::vector<int>& b);
void quad_solution(int n, int m, std::vector<int>& a, std::vector<int>& b);

bool is_up(const std::vector<int>& a, const std::vector<int>& b)
{
    if (a.size() != b.size())
        return false;
    for (int i = 0; i < a.size(); ++i)
        if (a[i] != b[i])
            return false;
    return true;
}

bool is_down(const std::vector<int>& a, const std::vector<int>& b)
{
    if (a.size() != b.size())
        return false;
    for (int i = 0; i < a.size(); ++i)
        if (a[i] != b[a.size() - i - 1])
            return false;
    return true;
}

int main(int argc, char const *argv[])
{
    int n, m;
    std::cin >> n >> m;
    std::vector<int> a(m);
    std::vector<int> b(n);
    for (auto &e : a) {
        std::cin >> e;
    }
    for (auto &e : b) {
        std::cin >> e;
    }

    if (is_down(a, b))
        linear_down_solution(n, m, a, b);
    else if (is_up(a, b))
    {
        linear_up_solution(n, m, a, b);
    }
    else
        quad_solution(n, m, a, b);

    return 0;
}

void linear_up_solution(int n, int m, std::vector<int>& a, std::vector<int>& b)
{
    std::cout << n << '\n';
    for (int i = 0; i < n; ++i)
        std::cout << n << ' ';
}

void linear_down_solution(int n, int m, std::vector<int>& a, std::vector<int>& b)
{
    std::cout << 2 * n - 1 << '\n';
    int out = n;
    for (int i = 0; i < n - 1; ++i)
        std::cout << out-- << ' ';
    for (int i = 0; i < n; ++i)
        std::cout << n << ' ';
}

void quad_solution(int n, int m, std::vector<int>& a, std::vector<int>& b)
{

}