#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>

#ifndef LOCAL
#define fprintf if (0) fprintf
#endif

char MEM[(size_t)2e5];
size_t MEM_PTR = 0;

void* operator new(size_t s)
{
    void* ret = MEM_PTR + MEM;
    MEM_PTR += s;
    return ret;
}

void operator delete(void*)
{}

const long long MOD = 1e9 + 7;

template<typename Cont>
void print_dp(const Cont& c)
{
    for (const auto &line : c) {
        for (const auto &cell : line) {
            std::cerr << cell << ' ';
        }
        std::cerr << '\n';
    }
}

int main(int argc, char const *argv[])
{
    int n, k;
    std::cin >> n >> k;

    std::vector<std::vector<long long>> dp_up(n + 1, std::vector<long long>(n + 1, 0));
    std::vector<std::vector<long long>> dp_down(n + 1, std::vector<long long>(n + 1, 0));
    std::vector<std::vector<long long>> suffix_dp_up(n + 1, std::vector<long long>(n + 1, 0));
    std::vector<std::vector<long long>> prefix_dp_down(n + 1, std::vector<long long>(n + 1, 0));

    dp_up[k][k] = 1;
    suffix_dp_up[k][k] = 1;
    dp_down[k][k] = 1;
    prefix_dp_down[k][k] = 1;

    for (int i = 1; i < n + 1; ++i)
        prefix_dp_down[k][i] = prefix_dp_down[k][i - 1] + dp_down[k][i];
    for (int i = n - 1; i >= 0; --i)
        suffix_dp_up[k][i] = suffix_dp_up[k][i + 1] + dp_up[k][i];

    for (int s = k + 1; s < n + 1; ++s)
    {
        for (int y = 0; y <= s; ++y)
        {
            if (y > 0)
            {
                dp_up[s][y] += prefix_dp_down[s - y][y - 1];
                dp_up[s][y] %= MOD;
            }
            if (y != n)
            {
                dp_down[s][y] += suffix_dp_up[s - y][y + 1];
                dp_down[s][y] %= MOD;
            }
        }
        prefix_dp_down[s][0] = dp_down[s][0];
        for (int i = 1; i < n + 1; ++i)
        {
            prefix_dp_down[s][i] = prefix_dp_down[s][i - 1] + dp_down[s][i];
            prefix_dp_down[s][i] %= MOD;
        }
        suffix_dp_up[k][n] = dp_up[k][n];
        for (int i = n - 1; i >= 0; --i)
        {
            suffix_dp_up[s][i] = suffix_dp_up[s][i + 1] + dp_up[s][i];
            suffix_dp_up[s][i] %= MOD;
        }
    }
    /*
    std::cerr << "dp_up" << '\n';
    print_dp(dp_up);
    std::cerr << "dp_down" << '\n';
    print_dp(dp_down);
    */
    long long answ = 0;
    for (int i = 0; i < n + 1; ++i)
    {
        answ += dp_up[n][i];
        answ %= MOD;
        answ += dp_down[n][i];
        answ %= MOD;
    }
    if (n == k)
    {
        answ = 1;
    }
    std::cout << answ << '\n';

    return 0;
}