#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <unordered_set>

#ifndef LOCAL
#define fprintf if (0) fprintf
#endif

using Graph = std::vector<std::unordered_set<int>>;

int brute_force(const Graph& g)
{
    int n = g.size();
    int answ = 0;
    for (int mask = 0; mask < (1 << n); ++mask)
    {
        std::vector<int> elems;
        for (int i = 0; i < n; ++i)
            if (mask & (1 << i))
                elems.push_back(i);
        bool valid = true;
        for (auto v : elems)
            for (auto u : elems)
                valid &= g[v].find(u) == g[v].end();
        if (valid)
        {
            answ = std::max(int(elems.size()), answ);
        }
    }
    return answ;
}

int main(int argc, char const *argv[])
{
    int n;
    std::cin >> n;
    Graph g(n);
    for (int i = 0; i < n; ++i)
    {
        int x;
        std::cin >> x;
        if (x != -1)
        {
            --x;
            g[i].insert(x);
            g[x].insert(i);
        }
    }
    //if (n <= 20)
        std::cout << brute_force(g) << '\n';
    
    return 0;
}