#include <iostream>
#include <random>
#include <ctime>
#include <algorithm>
#include <cmath>
#define int long long

using namespace std;

int main43(int nn, int kk) {
    if (nn == kk) {
        return 1;
    }

    nn++;
    kk++;
    vector<vector<vector<int>>> a(nn, vector<vector<int>> (nn, vector<int> (2, 0)));
    for (int i = 1; i < nn; ++i) {
        a[i][i][0] = 1;
        a[i][i][1] = 1;
    }

    //cout << "crush";
    for (int n = 2; n < nn; ++n) {
        for (int k = 1; k < n; ++k) {
            for (int i = 1; i < k; ++i) {
                a[n][k][0] += a[n - k][i][1];
            }
            for (int i = k + 1; i <= n - k; ++i) {
                a[n][k][1] += a[n - k][i][0];
            }
        }
    }
    return a[nn - 1][kk - 1][0] + a[nn - 1][kk - 1][1];
}

const int MOD = 1e9 + 7;

int main66(int nn, int kk) {
    if (nn == kk) {
        return 1;
    }

    nn++;
    kk++;
    vector<vector<vector<int>>> a(nn, vector<vector<int>> (nn, vector<int> (2, 0)));
    for (int i = 1; i < nn; ++i) {
        a[i][i][0] = 1;
        a[i][i][1] = 1;
    }

    //cout << "crush";
    for (int n = 2; n < nn; ++n) {
        for (int k = 1; k < n; ++k) {
            for (int i = 1; i < k; ++i) {
                a[n][k][0] = (a[n][k][0] + a[n - k][i][1]) % MOD;
            }
            for (int i = k + 1; i <= n - k; ++i) {
                a[n][k][1] = (a[n][k][1] + a[n - k][i][0]) % MOD;
            }
        }
    }
    return (a[nn - 1][kk - 1][0] + a[nn - 1][kk - 1][1]) % MOD;
}

int main100(int nn, int kk) {
    if (nn == kk) {
        return 1;
    }

    nn++;
    kk++;
    vector<vector<vector<int>>> a(nn, vector<vector<int>> (nn, vector<int> (2, 0)));
    vector<vector<vector<int>>> p(nn, vector<vector<int>> (nn, vector<int> (2, 0)));
    vector<vector<vector<int>>> s(nn, vector<vector<int>> (nn + 1, vector<int> (2, 0)));
    for (int i = 1; i < nn; ++i) {
        a[i][i][0] = 1;
        a[i][i][1] = 1;
    }

    for (int i = 1; i < nn; ++i) {
        p[1][i][0] = p[1][i - 1][0] + a[1][i][0];
        p[1][i][1] = p[1][i - 1][1] + a[1][i][1];
    }
    for (int i = nn - 1; i > 0; --i) {
        s[1][i][0] = s[1][i + 1][0] + a[1][i][0];
        s[1][i][1] = s[1][i + 1][1] + a[1][i][1];
    }

    //cout << "crush";
    for (int n = 2; n < nn; ++n) {
        for (int k = 1; k < n; ++k) {
                /*
            for (int i = 1; i < k; ++i) {
                a[n][k][0] = (a[n][k][0] + a[n - k][i][1]) % MOD;
            }
                */
            a[n][k][0] = (a[n][k][0] + p[n - k][k - 1][1]) % MOD;
                /*
            for (int i = k + 1; i <= n - k; ++i) {
                a[n][k][1] = (a[n][k][1] + a[n - k][i][0]) % MOD;
            }
                */
            a[n][k][1] = (a[n][k][1] + s[n - k][k + 1][0] - s[n - k][n - k - 1][0]) % MOD;
        }
        for (int k = 1; k < nn; ++k) {
            p[n][k][0] = (p[n][k - 1][0] + a[n][k][0]) % MOD;
            p[n][k][1] = (p[n][k - 1][1] + a[n][k][1]) % MOD;
        }
        for (int k = nn - 1; k > 0; --k) {
            s[n][k][0] = (s[n][k + 1][0] + a[n][k][0]) % MOD;
            s[n][k][1] = (s[n][k + 1][1] + a[n][k][1]) % MOD;
        }
    }
    return (a[nn - 1][kk - 1][0] + a[nn - 1][kk - 1][1]) % MOD;
}

signed main()
{
    int nn, kk;
    cin >> nn >> kk;
    cout << main66(nn, kk);
    return 0;
}
