#include <iostream>
#include <vector>
#include <random>
#include <ctime>
#include <algorithm>
#include <cmath>
#define int long long
#define all(a) a.begin(), a.end()
#include <ctime>

/**
    
**/

using namespace std;

int n, k;

void main1() {
    vector<vector<int>> a(n, vector<int> (k, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
        }
    }
    vector<int> mask(n);
    for (int i = 0; i < n; ++i) {
        mask[i] = i;
    }
    do {
        bool ok = true;
        for (int j = 0; j < k; ++j) {
            int l = -2 * 1e9;
            int r = 2 * 1e9;
            for (int i = 0; i < n; i += 2) {
                l = max(l, min(a[mask[i]][j], a[mask[i + 1]][j]));
                r = min(r, max(a[mask[i]][j], a[mask[i + 1]][j]));
            }
            if (l > r) {
                ok = false;
            }
        }
        if (ok) {
            cout << "YES\n";
            for (int i = 0; i < n; i += 2) {
                cout << mask[i] + 1 << " " << mask[i + 1] + 1 << endl;
            }
            return;
        }
        if (clock() > 0.9 * CLOCKS_PER_SEC) {
            break;
        }
    } while (next_permutation(all(mask)));
    cout << "NO\n";
    return;
}

void main2() {
    vector<int> a(n);
    vector<pair<int, int>> events;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        events.push_back({a[i], i});
    }
    sort(all(events));
    cout << "YES\n";
    for (int i = 0; i < n/2; ++i) {
        cout << events[i].second + 1 << " " << events[n - i - 1].second + 1 << endl;
    }

}

void main4() {
    vector<int> a(n);
    vector<int> b(n);
    vector<pair<int, int>> events1;
    vector<pair<int, int>> events2;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        events1.push_back({a[i], i});
        events2.push_back({b[i], i});
    }
    sort(all(events1));
    sort(all(events2));
    vector<int> fp1;
    vector<int> sp1;
    vector<int> fp2;
    vector<int> sp2;
    for (int i = 0; i < n/2; ++i) {
        fp1.push_back(events1[i].second);
        fp2.push_back(events2[i].second);
        sp1.push_back(events1[n - i - 1].second);
        sp2.push_back(events2[n - i - 1].second);
    }
    sort(all(fp1));
    sort(all(fp2));
    sort(all(sp1));
    sort(all(sp2));

    int cfp = 0;
    int i = 0;
    int j = 0;
    while (i < n / 2 && j < n / 2) {
        if (fp1[i] == fp2[j]) {
            cfp++;
            i++;
            j++;
        }
        else if (fp1[i] < fp2[j]) {
            i++;
        }
        else {
            j++;
        }
    }

    int csp = 0;
    i = 0;
    j = 0;
    while (i < n / 2 && j < n / 2) {
        if (sp1[i] == sp2[j]) {
            csp++;
            i++;
            j++;
        }
        else if (sp1[i] < sp2[j]) {
            i++;
        }
        else {
            j++;
        }
    }
    if (cfp != csp) {
        cout << "NO";
        return;
    }
    cout << "YES\n";

    vector<int> cfpt;
    vector<int> nfpt;
    vector<int> cspt;
    vector<int> nspt;

    i = 0;
    j = 0;
    while (i < n / 2 && j < n / 2) {
        if (fp1[i] == fp2[j]) {
            cfpt.push_back(fp1[i]);
            i++;
            j++;
        }
        else if (fp1[i] < fp2[j]) {
            nfpt.push_back(fp1[i]);
            i++;
        }
        else {
            nspt.push_back(fp2[j]);
            j++;
        }
    }
    while (i < n / 2) {
        nfpt.push_back(fp1[i]);
        i++;
    }
    while (j < n / 2) {
        nspt.push_back(fp2[j]);
        j++;
    }

    i = 0;
    j = 0;
    while (i < n / 2 && j < n / 2) {
        if (sp1[i] == sp2[j]) {
            cspt.push_back(sp1[i]);
            i++;
            j++;
        }
        else if (sp1[i] < sp2[j]) {
            i++;
        }
        else {
            j++;
        }
    }

    for (int i = 0; i < cfpt.size(); ++i) {
        cout << cfpt[i] + 1 << " " << cspt[i] + 1 << endl;
    }
    for (int i = 0; i < nfpt.size(); ++i) {
        cout << nfpt[i] + 1 << " " << nspt[i] + 1 << endl;
    }
}

signed main()
{
    cin >> n >> k;

    if (k == 1) {
        main2();
    }
    else if (k == 2) {
        main4();
    }
    else if (n <= 20) {
        main1();
    }
    else {
        main1();
    }
    return 0;
}

/*
22 1
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22
*/
