#pragma GCC optimize("O3")
#include <iostream>
#include <fstream>
#include <utility>
#include <stdio.h>
#include <stdlib.h>
#include <utility>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#define x first
#define y second

using namespace std;

typedef long double ld;

const int N = 3e5 + 10;

int n;
vector<int> adj[N];
set<int> s_adj[N];
vector<vector<int> > comps;
bool used[N];
int ans = 0;

inline void fast() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

inline void dfs(int v) {
    used[v] = 1;
    comps.back().push_back(v);
    for (auto el : adj[v]) {
        if (!used[el]) dfs(el);
    }
}

inline void mw(vector<int> &comp, set<int> &can) {
    for (auto v : comp) {
        can.insert(v);
    }
    set<int> not_can;
    set<int> meow;
    while (1) {
        not_can.clear();
        meow.clear();
        int cnt = 0;
        for (auto v : can) {
            if (s_adj[v].empty()) {
                ++ans;
                meow.insert(v);
                continue;
            }
            if (s_adj[v].size() == 1) {
                ++cnt;
                ++ans;
                meow.insert(v);
                can.erase(*s_adj[v].begin());
                not_can.insert(*s_adj[v].begin());
            }
        }
        for (auto v : meow) can.erase(v);
        if (!cnt) return;
        meow.clear();
        for (auto v : can) {
            for (auto u : s_adj[v]) {
                if (not_can.count(u))
                    meow.insert(u);
            }
            for (auto u : meow) {
                s_adj[v].erase(u);
                s_adj[u].erase(v);
            }
            meow.clear();
        }
    }
}

set<int> sused, dead;
inline void dfs2(int v, int &ans, bool fl = 0) {
    sused.insert(v);
    if (!dead.count(v)) {
        ++ans;
    }
    for (auto u : s_adj[v]) {
        if (!sused.count(u)) {
            if (!dead.count(v)) dead.insert(u);
        }
    }
    for (auto u : s_adj[v]) {
        if (!sused.count(u)) dfs2(u, ans);
    }
}

inline int get_ans(vector<int> &comp) {
    ans = 0;
    set<int> can;
    sused.clear();
    dead.clear();
    mw(comp, can);
    if (!can.empty()) {
        dfs2(*can.begin(), ans);
    }
    return ans;
}

signed main() {
    fast();
    cin >> n;
    bool is_tree = 1;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x == -1) {
            continue;
        }
        --x;
        if (i == 0 && x == -1) continue;
        if (x != i - 1) is_tree = 0;
        s_adj[i].insert(x);
        s_adj[x].insert(i);
    }
    if (is_tree) {
        cout << (n + 1) / 2;
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        for (auto el : s_adj[i]) {
            adj[i].push_back(el);
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            comps.push_back({});
            dfs(i);
        }
    }
    int cur_ans = 0;
    for (auto cmp : comps) {
        cur_ans += get_ans(cmp);
    }
    cout << cur_ans;
}
