#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long inf = 1e9 + 7;
vector <vector <long long> > cnk(64, vector <long long> (64, 0));

void precalc(){
    for (int i = 0; i < 64; i++){
        cnk[i][0] = 1;
    }
    for (int i = 1; i < 64; i++){
        for (int j = 1; j <= i; j++){
            cnk[i][j] = (cnk[i - 1][j - 1] + cnk[i - 1][j]) % inf;
        }
    }
}

int calc(int n, int k, const vector <int> &a){
    if (k < 0){
        return 0;
    }
    vector <vector <int> > dp(n, vector <int> (k + 1, 0));
    for (int i = 0; i <= k; i++){
        dp[0][i] = cnk[k][i];
//        cout << dp[0][i] << " ";
    }
//    cout << endl;
    for (int i = 1; i < n; i++){
        for (int j = 0; j <= k; j++){
            for (int j2 = 0; j2 <= j; j2++) {
                dp[i][j] += (long long) dp[i - 1][j2] * cnk[k - j2][j - j2] % inf;
                dp[i][j] %= inf;
            }
            if (a[i] != -1 && dp[i][j] != 0){
                dp[i][j] = (dp[i][j] - dp[a[i]][j] + inf) % inf;
            }
            //cout << dp[i][j] << " ";
        }
        //cout << endl;
    }
//    for (int i = 0; i < n; i++){
//        for (int j = 0; j <= k; j++){
//            cout << dp[i][j] << " ";
//        }
//        cout << endl;
//    }
    int res = 0;
    for (int i = 0; i <= k; i++){
        res += dp[n - 1][i];
        res %= inf;
    }
    return res;
}

int calcones(long long k){
    int res = 0;
    while (k != 0){
        res += k % 2;
        k /= 2;
    }
    return res;
}

int main() {
    precalc();
    int n, m;
    long long k;
    cin >> n >> m >> k;
    long long tk = k, rk = 0;
    while (tk != 0){
        rk++;
        tk /= 2;
    }
    vector <pair <int, int> > otr(m);
    vector <pair <pair <int, int>, int> > evnt;
    for (int i = 0; i < m; i++){
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        otr[i] = make_pair(l, r);
        evnt.push_back(make_pair(make_pair(r, -l), -1));
        //evnt.push_back(make_pair(otr[i], 1));
    }
    int mleft = 0;
    sort(evnt.begin(), evnt.end());
    vector <int> a(n, -1);
    for (int i = 0; i < m; i++){
        if (-evnt[i].first.second >= mleft){
            mleft = -evnt[i].first.second;
            a[evnt[i].first.first] = -evnt[i].first.second;
        }
    }
//    for (auto t: a){
//        cout << t << " ";
//    }
//    cout << endl;
    long long res = 0;
    if (rk == calcones(k)){
        res = calc(n, rk, a);
        cout << res;
        return 0;
    }
    else {
        res += calc(n, rk - 1, a) + calc(n, calcones(k), a) - calc(n, calcones(k) - 1, a);
    }
//    for (int i = 0; i < 3; i++){
//        cout << calc(n, i, a) << " ";
//    }
//    cout << endl;
    for (int i = 0; i < rk - 2; i++){
        if (!(1 & (k >> i)) && (1 & (k >> (i + 1)))){
//            cout << i << " " << (k >> (i + 1)) << endl;
            res += calc(n, calcones((k >> (i + 2))) + i + 1, a) - calc(n, i + 1, a) - calc(n, calcones((k >> (i + 2))), a) + calc(n, 0, a);
        }
    }
    cout << (res % inf + inf) % inf;
    return 0;
}