#include <iostream>
#include <vector>

using namespace std;

vector <bool> used;
vector <int> prevu;
vector <int> cycle;
vector <vector <int> > gr;

bool hascyc(int now, int prev = -1){
    prevu[now] = prev;
    used[now] = true;
    for (auto u: gr[now]){
        if (used[u] && prev != u){
            cycle.push_back(now);
            int tnow = now;
            while (tnow != u){
                tnow = prevu[tnow];
                cycle.push_back(tnow);
            }
            return true;
        }
        if (!used[u]){
            bool has = hascyc(u, now);
            if (has){
                return true;
            }
        }
    }
    return false;
}

vector <bool> counted;
vector <int> dp1, dp2;
// dp1 - used vertex;
// dp2 - unused vertex;

void countdfs(int now){
    counted[now] = true;
    dp1[now] = 1;
    dp2[now] = 0;
    for (auto u : gr[now]){
        if (!counted[u]){
            countdfs(u);
            dp1[now] += dp2[u];
            dp2[now] += dp1[u];
        }
    }
    dp1[now] = max(dp1[now], dp2[now]);
}

int main() {
    int n;
    cin >> n;
    gr.resize(n);
    dp1.resize(n);
    dp2.resize(n);
    counted.assign(n, false);
    for (int i = 0; i < n; i++){
        int t;
        cin >> t;
        if (t != -1){
            t--;
            gr[i].push_back(t);
            gr[t].push_back(i);
        }
    }
    int res = 0;
    used.assign(n, false);
    prevu.assign(n, -1);
    for (int i = 0; i < n; i++){
        if (!counted[i]){
            cycle.clear();
            int has = hascyc(i);
            if (!has){
                countdfs(i);
                res += dp1[i];
            }
            else {
                for (auto u: cycle){
                    counted[u] = true;
                }
                for (auto u: cycle){
                    countdfs(u);
                }
//                for (auto u: cycle){
//                    cout << dp1[u] << " " << dp2[u] << endl;
//                }
                if (cycle.size() == 2){
                    res += max(dp1[cycle[0]] + dp2[cycle[1]], dp1[cycle[1]] + dp2[cycle[0]]);
                }
                else {
                    int tres = dp1[cycle[0]] + dp2[cycle[1]] + dp2[cycle.back()];
                    int upr = tres, nupr = tres;
                    for (int i = 2; i < (int) cycle.size() - 1; i++){
                        int tupr = nupr + dp1[cycle[i]];
                        int tnupr = max(upr + dp2[cycle[i]], nupr + dp2[cycle[i]]);
                        upr = tupr;
                        nupr = tnupr;
                    }
                    tres = max(upr, nupr);
//                    cout << tres << endl;
                    upr = dp2[cycle[0]];
                    nupr = dp2[cycle[0]];
                    for (int i = 1; i < (int) cycle.size(); i++){
                        int tupr = nupr + dp1[cycle[i]];
                        int tnupr = max(upr + dp2[cycle[i]], nupr + dp2[cycle[i]]);
                        upr = tupr;
                        nupr = tnupr;
                    }
                    tres = max(tres, max(upr, nupr));
                    res += tres;
                }
            }
        }
    }
    cout << res;
    return 0;
}