#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector <int> py;
vector <vector <int> > gr;
vector <bool> used;

bool trydfs(int now){
    used[now] = true;
    for (int i = 0; i < (int) gr[now].size(); i++){
        int u = gr[now][i];
        if (py[u] == -1 || (!used[py[u]] && trydfs(py[u]))){
            py[u] = now;
            return true;
        }
    }
    return false;
}

int main() {
    int n, k;
    cin >> n >> k;
    vector <vector <int> > a(n, vector <int> (k + 1));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < k; j++){
            cin >> a[i][j];
        }
        a[i][k] = i;
    }
    sort(a.begin(), a.end());
    if (k == 1){
        cout << "YES" << endl;
        for (int i = 0; i < n / 2; i++){
            cout << a[i][k] + 1 << " " << a[n - i - 1][k] + 1 << endl;
        }
        return 0;
    }
    vector <vector <bool> > can(n, vector <bool> (n, true));
    vector <pair <int, int> > b;
    for (int i = 1; i < k; i++){
        b.clear();
        for (int j = 0; j < n; j++){
            b.push_back(make_pair(a[j][i], j));
        }
        sort(b.begin(), b.end());
//        cout << b[n / 2].first << endl;
//        cout << b[n / 2 - 1].first << endl;
        for (int j1 = 0; b[j1].first < b[n / 2].first; j1++){
            for (int j2 = 0; j2 < j1; j2++){
                can[b[j1].second][b[j2].second] = false;
                can[b[j2].second][b[j1].second] = false;
            }
        }
        for (int j1 = n - 1; b[j1].first > b[n / 2 - 1].first; j1--){
            for (int j2 = j1 + 1; j2 < n; j2++){
                can[b[j1].second][b[j2].second] = false;
                can[b[j2].second][b[j1].second] = false;
            }
        }
    }
    gr.resize(n / 2);
    for (int i = 0; i < n / 2; i++){
        for (int j = n / 2; j < n; j++){
            if (can[i][j]){
//                cout << "kek" << endl;
                gr[i].push_back(j - n / 2);
            }
        }
    }
    py.assign(n / 2, -1);
    bool res = true;
    for (int i = 0; i < n / 2; i++){
        used.assign(n / 2, false);
        res &= trydfs(i);
//        cout << res << endl;
    }
    if (res){
        cout << "YES" << endl;
        for (int i = 0; i < n / 2; i++){
            cout << a[i + n / 2][k] + 1 << " " << a[py[i]][k] + 1 << endl;
        }
    }
    else {
        cout << "NO";
    }
    return 0;
}