#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 30005;
vector <int> g[MAXN];
bool used[MAXN];
int col[MAXN];
int prev_v[MAXN];
vector <int> post_v[MAXN];
bool in_cycle[MAXN];
int ans_for_v[MAXN][2];
vector <int> cycle;
int d[MAXN][2];

int n;
bool flag = false;

inline void dfs(int s) {
    ////cerr << "\n" << s << " " << prev_v[s] << ":";
    col[s] = 1;
    used[s] = true;
    for (auto u : g[s]) {
        ////cerr << u << ", ";
        if (!used[u]) {
            prev_v[u] = s;
            post_v[s].push_back(u);
            dfs(u);
        } else if (u != prev_v[s] && !flag) {
            flag = true;
            ////cerr << "found cycle: ";
            cycle.push_back(s);
            ////cerr << s << flag;
            in_cycle[s] = true;
            int v = s;
            do {
                v = prev_v[v];
                ////cerr << "-" << v;
                in_cycle[v] = true;
                cycle.push_back(v);
            } while (v != u);
            ////cerr << ", ";
        }
    }
    ////cerr << "\n";
}

/*inline int ans_in_tree(int s, bool c) {
    //cerr << s << " " << ans_for_v[s][0] << ", " << ans_for_v[s][1] << "\n";
    int t = 1;
    if (!c) {
        t = 0;
    }

    if (post_v[s].size() == 0) {
        ans_for_v[s][0] = 0;
        ans_for_v[s][1] = 1;
    }

    if (ans_for_v[s][t] != -1) {
        return ans_for_v[s][t];
    }

    int res = 0;
    if (c) {
        for (int u : post_v[s]) {
            if(in_cycle[u]) {
                continue;
            }
            res += max(ans_in_tree(u, true), ans_in_tree(u, false));
        }
    } else {
        for (int u : post_v[s]) {
            if(in_cycle[u]) {
                continue;
            }
            res += ans_in_tree(u, false);
        }
    }

    ans_for_v[s][t] = res;

    return res;
}*/

inline void ans_in_tree(int v) {
    //cerr << v;
    if (in_cycle[v] || prev_v[v] == -1) {
        return;
    }

    ans_for_v[prev_v[v]][0] += max(ans_for_v[v][0], ans_for_v[v][1]);
    ans_for_v[prev_v[v]][1] += ans_for_v[v][0];
    ans_in_tree(prev_v[v]);
}

int main() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x != -1) {
            --x;
            g[x].push_back(i);
            g[i].push_back(x);
        }
    }


    int ans = 0;


    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            for (int i = 0; i < n; ++i) {
                ans_for_v[i][0] = 0;
                ans_for_v[i][1] = 1;
            }
            prev_v[i] = -1;
            cycle.resize(0);
            flag = false;
            dfs(i);
            ////cerr << "OK";
            if (cycle.size() == 0) {
                cycle.push_back(0);
            }
            for (int i = 0; i < n; ++i) {
                if (col[i] == 1 && post_v[i].size() == 0) {
                    ////cerr << i << " ";
                    ans_in_tree(i);
                }
            }

            for (auto v : cycle) {
                cerr << v << " " << ans_for_v[v][0] << ", " << ans_for_v[v][1] << "\n";
            }

            cerr << "\n";

            d[0][0] = ans_for_v[cycle[0]][0];
            d[0][1] = ans_for_v[cycle[0]][1];
            for (int i = 1; i < cycle.size(); ++i) {
                /*if (i == cycle.size() - 1) {
                    d[i][0] = max(d[i-1][1], d[i-1][0]);
                }*/
                d[i][0] = max(d[i-1][1], d[i-1][0]);
                d[i][1] = d[i - 1][0] + ans_for_v[cycle[i]][1];
            }

            ans += max(d[cycle.size() - 1][0], d[cycle.size() - 1][1]);
            for (int i = 0; i < n; ++i) {
                col[i] = 0;
            }
        }
    }

    cout << ans;

    return 0;
}
