#include <iostream>
#include <vector>
#include <string>
#include <random>
#include <fstream>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7;

mt19937_64 MyRand(0);

struct Node{
	Node *l = nullptr, *r = nullptr;
	ll x, y = MyRand(), size = 1, minvalue;
	pair<ll, ll> value;
	Node(pair<ll, ll> value) :value(value), minvalue(value.first) {}
	void Update() {
		size = 1;
		minvalue = value.first;
		if (l != nullptr) {
			size += l->size;
			minvalue = min(minvalue, l->value.first);
		}
		if (r != nullptr) {
			size += r->size;
			minvalue = min(minvalue, r->value.first);
		}
	}
};

Node* Merge(Node *a, Node *b) {
	if (a == nullptr) return b;
	if (b == nullptr) return a;
	Node *Root = nullptr;
	if (a->y > b->y) {
		Root = a;
		Root->r = Merge(Root->r, b);
	} else {
		Root = b;
		Root->l = Merge(a,Root->l);
	}
	Root->Update();
	return Root;
}

pair<Node *, Node *> Split(Node *Root, ll k) {
	if (Root == nullptr) return{ nullptr, nullptr };
	ll sizeleft = 0;
	if (Root->l != nullptr) sizeleft = Root->l->size;
	if (k > sizeleft) {
		auto splt = Split(Root->r, k - 1 - sizeleft);
		Root->r = splt.first;
		Root->Update();
		return{ Root, splt.second };
	} else {
		auto splt = Split(Root->l, k);
		Root->l = splt.second;
		Root->Update();
		return { splt.first, Root };
	}
}


int main() {
	ll n, m;
	cin >> n >> m;
vector<vector <ll> > v(n);
	vector<ll> j(n, 1), ans(0);
	for (ll i = 0; i < m; i++) {
		ll a;
		cin >> a;
		v[a - 1].push_back(i);
	}
	for (auto &u : v) u.push_back(m);
	Node * Root = nullptr;
	for (ll i = 0; i < n; i++) {
		ll b;
		cin >> b;
		b--;
		Node * node = new Node({ v[b][0], b });
		Root = Merge(Root, node);
	}
	ll c = 0;
	while (true) {
		auto splt = Split(Root, 1);
		Root = splt.second;
		if (splt.first->value.first == c) {
			if (j[splt.first->value.second] == v[splt.first->value.second].size())break;
			splt.first->value.first = v[splt.first->value.second][j[splt.first->value.second]];
			j[splt.first->value.second]++;
			c++;
		}
		ll l = -1, r = n - 1;
		while (r - l > 1) {
			ll m = (l + r) / 2;
			auto splt2 = Split(Root, m);
			if (splt2.second == nullptr) { r = m; continue; }
			if (splt2.second->minvalue >= splt.first->value.first) r = m;
			else l = m;
			Root = Merge(splt2.first, splt2.second);
		}
		ans.push_back(r + 1);
		auto splt2 = Split(Root, r);
		Root = Merge(splt2.first, Merge(splt.first, splt2.second));
	}
	cout << ans.size() << "\n";
	for (auto i : ans) cout << i << " ";
}

