#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <string>
#include <utility>
#include <cassert>
#include <ctime>
#include <vector>
#include <deque>
#include <bitset>

#pragma warning(disable: 4996)

using namespace std;

#include <iostream>
//const string FILENAME = "test";
//ifstream cin(FILENAME + ".in");
//ofstream cout(FILENAME + ".out");

template<class C> void chkmin(C& a, const C& b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, const C& b) { if (a < b) a = b; }

typedef long long ll;
typedef long double ld;

const int MAXN = 3e5 + 3;

vector<int> g[MAXN];
int p[MAXN];

int d[2][MAXN];
int dd[MAXN];
int d2[MAXN];
bitset<MAXN> used;
bitset<MAXN> used2;

void DFS(int v, int f) {
	if (used[v]) return;
	used[v] = true;
	d[0][v] = 0;
	d[1][v] = 1;
	for (int u : g[v]) {
		if (!used[u] && u != f) {
			DFS(u, f);
			d[0][v] += dd[u];
			d[1][v] += d[0][u];
		}
	}
	dd[v] = max(d[0][v], d[1][v]);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
		if (p[i] != -1) {
			--p[i];
			g[p[i]].push_back(i);
		}
	}
	int res = 0;
	for (int v = 0; v < n; ++v) {
		if (p[v] != -1 || used[v]) continue;
		DFS(v, -1);
		res += dd[v];
	}
	for (int v = 0; v < n; ++v) {
		if (used[v]) continue;
		int u = v;
		while (!used2[u]) {
			used2[u] = true;
			u = p[u];
		}
		vector<int> cycle;
		int bu = u;
		do {
			cycle.push_back(u);
			u = p[u];
		} while (u != bu);
		cycle.push_back(cycle[0]);
		int m = cycle.size() - 1;
		for (int i = 0; i < m; ++i) {
			DFS(cycle[i + 1], cycle[i]);
		}
		if (m == 2) {
			res += max(d[0][cycle[0]] + dd[cycle[1]],
				dd[cycle[0]] + d[0][cycle[1]]);
			continue;
		}
		d2[1] = 0;
		d2[2] = dd[cycle[2]];
		for (int i = 3; i < m - 1; ++i) {
			d2[i] = max(d[0][cycle[i]] + d2[i - 1],
				dd[cycle[i]] + d[0][cycle[i - 1]] + d2[i - 2]);
		}
		int cres = dd[cycle[0]] + d[0][cycle[1]] + d2[m - 2] + d[0][cycle[m - 1]];
		d2[0] = 0;
		d2[1] = dd[cycle[1]];
		for (int i = 2; i < m; ++i) {
			d2[i] = max(d[0][cycle[i]] + d2[i - 1],
				dd[cycle[i]] + d[0][cycle[i - 1]] + d2[i - 2]);
		}
		chkmax(cres, d2[m - 1] + d[0][cycle[0]]);
		res += cres;
	}
	cout << res << '\n';
}

