#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include <cmath>
#include <random>
#include <time.h>
#include <queue>

const int INF = 1e9 + 7;
typedef long long ll;

using namespace std;

#define int long long

vector<int> c;

struct node
{
    int x;
    int add;
    node* l;
    node* r;
    node(int x_ = 0, int add_ = 0)
    {
        x = x_;
        add = add_;
        l = nullptr;
        r = nullptr;
    }
};

node * root = new node();

node* build(int L, int R)
{
    if  (L + 1 == R)
    {
        return new node(c[L]);
    }
    int M = (L + R) / 2;
    node * v = new node();
    v->l = build(L, M);
    v->r = build(M, R);
    v->x = max(v->l->x, v->r->x);
    return v;
}

int maxn(node* v, int L, int R, int l, int r)
{
    if (L <= l && r <= R)
    {
        return v->x;
    }
    else if (R < l || r <= L)
    {
        return -INF;
    }
    int M = (L + R) / 2;
    return max(maxn(v->l, L, M, l, r), maxn(v->r, M, R, l, r));
}

void change(node* v, int L, int R, int idx, int x)
{
    if (L + 1 == R)
    {
        v->x = x;
        return;
    }
    if (idx < L || idx >= R)
        return;
    int M = (L + R) / 2;
    change(v->l, L, M, idx, x);
    change(v->r, M, R, idx, x);
    v->x = max(v->l->x, v->r->x);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    mt19937_64 rnd;
    rnd.seed(228);
   // freopen("input.txt", "r", stdin);

    int n;
    int m;
    cin >> n >> m;
    vector<int> b(m), a(n);
    for (int i = 0; i < m; ++i)
    {
        cin >> b[i];
    }
    for (int i = 0 ; i < n; ++i)
    {
        cin >> a[i];
    }
    vector<int> ans;
    if (n <= 2000 && m <= 2000)
    {
        for (int i = 0; i < m; ++i)
        {
           // cout << i << "\n";
            while (a[0] != b[i])
            {
                vector<int> idx(n + 1);
                for (int k = 0; k < n; ++k)
                {
                    idx[a[k]] = k + 1;
                }
                int cur = 0;
                int j = i;
                while (j < m && b[j]!= a[0])
                {
                    cur = max(idx[b[j]], cur);
                    ++j;
                }
                ans.push_back(cur);
                int t = a[0];
                a.erase(a.begin());
                a.insert(a.begin() + cur - 1, t);
                //cout << a[0] << " " << "ans " << ans.back() << '\n';
            }


            vector<int> idx(n + 1);
            for (int k = 0; k < n; ++k)
            {
                idx[a[k]] = k + 1;
            }
            int cur = 0;
            int j = i + 1;
            while (j < m && b[j]!= a[0])
            {
                cur = max(idx[b[j]], cur);
                ++j;
            }
            if (cur != 0)
            {
                ans.push_back(cur);
                int t = a[0];
                a.erase(a.begin());
                a.insert(a.begin() + cur - 1, t);
               // cout << a[0] << " " << "ans " << ans.back() << '\n';
            }
            else
            {
                ans.push_back(1);
                //cout << a[0] << " " << "ans " << ans.back() << '\n';

            }


        }
        cout << ans.size() << '\n';
        for (int t: ans)
            cout << t << ' ';
        return 0;
    }
    if (n == m)
    {
        bool f = true;
        for (int i = 0; i < n; ++i)
        {
            if (a[i] != b[i])
                f = false;
        }
        if (f)
        {
            cout << m << '\n';
            for (int i = 0; i < m; ++i)
                cout << m << ' ';
            cout << '\n';
        }
        else
        {
            cout << 2 * m - 1 << '\n';
            for (int i = m; i > 1; --i)
            {
                cout << i << ' ';
            }
            for (int i = 0; i < m; ++i)
                cout << m << ' ';
            cout << '\n';
        }
    }

}
/*
4 5
4 1 2 4 4
4 3 2 1


*/
