#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <stack>


#define ll long long
#define pii pair<ll, ll>
#define x first
#define y second
#define ld long double

using namespace std;

const ll NMAX = 211111;
const ll inf = 2e18;
const ll M = 1e9 + 7;

int a[NMAX][10];
int c[NMAX];
int b[10];

int cnt[NMAX];
vector<int> dop[NMAX];
int ptr[NMAX];

struct edge
{
	int u, v;
	int f, c;
	edge * e;
} e[511111];

edge * ls = e;

pair<edge *, edge * > nedge(int u, int v, int c)
{
	ls->c = c;
	ls->f = 0;
	ls->u = u;
	ls->v = v;
	ls->e = ls + 1;
	ls++;
	ls->c = 0;
	ls->f = 0;
	ls->u = v;
	ls->v = u;
	ls->e = ls - 1;
	ls++;
	return { ls - 2, ls - 1 };
}

vector<edge *> g[NMAX];

int pw3(int n)
{
	if (n == 0)
		return 1;
	else if (n % 2 == 0)
	{
		int x = pw3(n / 2);
		return x * x;
	}
	else
		return pw3(n - 1) * 3;
}

int used[NMAX];
int tm = 1;

int dfs(int v, int f, int cur)
{
	if (v == f)
	{
		return cur;
	}
	used[v] = tm;
	for (auto u : g[v])
	{
		if (used[u->v] != tm && u->c > u->f)
		{
			int a = dfs(u->v, f, min(cur, u->c - u->f));
			if (a != 0)
			{
				u->f += a;
				u->e->f -= a;
				return a;
			}
		}
	}
	return 0;
}

vector<pii> ans;

signed main()
{
	cin.tie(0);
	cout.tie(0);
	cin.sync_with_stdio(0);
	cout.sync_with_stdio(0);
	cout.precision(10);
	int n, k;
	cin >> n >> k;
	for (int i = 1; i <= n; i++)
	{
		for (int j = 0; j < k; j++)
			cin >> a[i][j], a[i][j] *= 2;
	}
	for (int j = 0; j < k; j++)
	{
		for (int i = 1; i <= n; i++)
			c[i] = a[i][j];
		sort(c + 1, c+ n + 1);
		int q = n / 2;
		if (c[q] == c[q + 1])
			b[j] = c[q];
		else
			b[j] = (c[q] + c[q + 1]) / 2;
	}

	int st = pw3(k - 1);
	int fn = pw3(k);

	for (int i = 1; i <= n; i++)
	{
		int cur = 0;
		for (int j = k - 1; j >= 0; j--)
		{
			cur *= 3;
			if (a[i][j] > b[j])
				cur += 2;
			else if (a[i][j] == b[j])
				cur += 1;
		}
		cnt[cur]++;
		dop[cur].push_back(i);
	}

	for (int i = 0; i < pw3(k - 1); i++)
	{
		auto w = nedge(st, i, cnt[i]);
		g[st].push_back(w.first);
		g[i].push_back(w.second);


		int cur = i + pw3(k - 1) * 2;
		w = nedge(cur, fn, cnt[cur]);
		g[cur].push_back(w.first);
		g[fn].push_back(w.second);
	}

	for (int i = 0; i < pw3(k - 1); i++)
	{
		for (int j = pw3(k - 1) * 2; j < pw3(k - 1) * 3; j++)
		{
			int a = i;
			int b = j;
			pair<edge *, edge *> w;
			for (int q = 0; q < k; q++)
			{
				int x = a % 3;
				int y = b % 3;
				if (x == 0 && y == 0 || x == 2 && y == 2)
					goto lab;
				a /= 3;
				b /= 3;
			}
			w = nedge(i, j, inf);
			g[i].push_back(w.first);
			g[j].push_back(w.second);
		lab:
			;
		}
	}

	while (dfs(st, fn, inf))
	{
		tm++;
	}
	int res = 0;
	for (auto u : g[st])
	{
		res += u->f;
	}
	if (res * 2 != n)
	{
		cout << "NO" << endl;
		return 0;
	}

	for (int i = 0; i < pw3(k - 1); i++)
	{
		for (auto e : g[i])
		{
			while (e->f > 0)
			{
				ans.push_back({ dop[i][ptr[i]++], dop[e->v][ptr[e->v]++] });
				e->f--;
			}
		}
	}

	cout << "YES" << endl;
	
	for (auto u : ans)
		cout << u.x << ' ' << u.y << endl;

	return 0;
}