#include <iostream>
#include <vector>
#include <set>

using namespace std;

bool kuhn(int v, vector<set<int> > &gr, vector<int> &par, vector<bool> &Is)
{
    if (Is[v]) return false;
    Is[v] = true;
    for (auto i:gr[v]){
        if (par[v]==i) continue;
        if (par[i]==-1 || kuhn(par[i], gr, par, Is)){
            if (par[v]!=-1) par[par[v]] = -1;
            par[i] = v;
            par[v] = i;
            return true;
        }
    }
    return false;
}

int main()
{
    int n;
    cin >> n;
    vector<set<int> > A(n);
    vector<int> B(n, -1);
    for (int i=0; i<n; i++){
        int a;
        cin >> a;
        if (a!=-1){
            A[i].insert(a-1);
            A[a-1].insert(i);
        }
    }
    for (int i=0; i<n; i++){
        vector<bool> Is(n);
        kuhn(i, A, B, Is);
    }
    int ans = 0;
    for (int i=0; i<n; i++){
        if (B[i]!=-1) ans++;
    }
    cout << n-ans/2 << endl;
}

