#include <bits/stdc++.h>

#ifdef AAA_LOCAL_EXECUTION
    #define db(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbs(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;35m" << x << "\x1b[0m" <<  endl;
    #define dbsx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;35m" << x << "\x1b[0m" << endl;
#else
    #define db(x)
    #define dbx(x)
    #define dbs(x)
    #define dbsx(x)
#endif

using namespace std;

using ll = long long;

const ll MOD = 1'000'000'007;


template <typename T>
ostream& operator<<(ostream& s, const vector<T>& v)
{
    for (auto& i : v) {
        s << i << "\t";
    }
    return s;
}


template <typename T, typename U>
ostream& operator<<(ostream& s, const pair<T, U>& p)
{
    s << "[" << p.first << "," << p.second << "]";
    return s;
}


void dfs(vector<vector<ll>>& g, vector<ll>& colors, vector<int>& used, ll root)
{
    if (used[root]) {
        return;
    }

    used[root] = 1;

    ll n = (ll)colors.size();
    vector<int> used_colors(n, 0);
    for (auto& to : g[root]) {
        if (colors[to] != -1) {
            used_colors[colors[to]] = 1;
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (!used_colors[i]) {
            colors[root] = i;
            break;
        }
    }
    for (auto& to : g[root]) {
        dfs(g, colors, used, to);
    }
}


ll max_count(const vector<ll>& v)
{
    unordered_map<ll, ll> count;
    for (auto& i : v) {
        if (i >= 0) {
            if (count.count(i) == 0) {
                count.emplace(i, 0);
            }
            count.at(i)++;
        }
    }
    
    ll max_count = 0;
    for (auto [c, n] : count) {
        max_count = max(max_count, n);
    }
    return max_count;
}


int main()
{
    ll n;
    cin >> n;
    vector<vector<ll>> g(n);
    for (ll i = 0; i < n; ++i) {
        ll t;
        cin >> t;
        if (t == -1) {
            continue;
        }
        --t;
        g[i].push_back(t);
        g[t].push_back(i);
    }

    vector<int> used(n, 0);

    ll sum = 0;
    for (ll root = 0; root < n; ++root) {
        vector<ll> colors(n, -1);
        dfs(g, colors, used, root);
        auto x = max_count(colors);
        sum += x;
        db(used);
        db(colors);
        db(x);
    }

    cout << sum << endl;
}
