#include <bits/stdc++.h>

#ifdef AAA_LOCAL_EXECUTION
    #define db(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;34m" << #x << "\x1b[0;35m = \x1b[1;31m" << (x) << "\x1b[0m" << endl;
    #define dbs(x) cerr << "\x1b[1;35m[DEBUG] \x1b[1;35m" << x << "\x1b[0m" <<  endl;
    #define dbsx(x) cerr << "\x1b[1;35m[DEBUG]     \x1b[1;35m" << x << "\x1b[0m" << endl;
#else
    #define db(x)
    #define dbx(x)
    #define dbs(x)
    #define dbsx(x)
#endif

using namespace std;

using ll = long long;

const ll MOD = 1'000'000'007;


template <typename T>
ostream& operator<<(ostream& s, const vector<T>& v)
{
    for (auto& i : v) {
        s << i << "\t";
    }
    return s;
}


template <typename T, typename U>
ostream& operator<<(ostream& s, const pair<T, U>& p)
{
    s << "[" << p.first << "," << p.second << "]";
    return s;
}


void dfs(vector<vector<ll>>& g, vector<ll>& colors, vector<int>& used, ll root)
{
    if (used[root]) {
        return;
    }

    used[root] = 1;

    ll n = (ll)colors.size();
    vector<int> used_colors(n, 0);
    for (auto& to : g[root]) {
        if (colors[to] != -1) {
            used_colors[colors[to]] = 1;
        }
    }
    for (ll i = 0; i < n; ++i) {
        if (!used_colors[i]) {
            colors[root] = i;
            break;
        }
    }
    for (auto& to : g[root]) {
        dfs(g, colors, used, to);
    }
}


ll max_count(const vector<ll>& v)
{
    unordered_map<ll, ll> count;
    for (auto& i : v) {
        if (i >= 0) {
            if (count.count(i) == 0) {
                count.emplace(i, 0);
            }
            count.at(i)++;
        }
    }
    
    ll max_count = 0;
    for (auto [c, n] : count) {
        max_count = max(max_count, n);
    }
    return max_count;
}


bool bit(ll a, ll n) {
    if (n < 0) {
        return 0;
    }
    return (a & (1 << n)) != 0;
}

ll gcount = 0;

bool tree_dfs(const vector<vector<ll>>& ch, ll root = 0)
{
    if (ch[root].empty()) {
        ++gcount;
        return true;
    }

    bool okval = true;
    for (ll child : ch[root]) {
        if (tree_dfs(ch, child)) {
            okval = false;
        }
    }
    if (!okval) {
        return false;
    }

    ++gcount;
    return true;
}

/*
bool operator<(const vector<ll>& a, const vector<ll>& b)
{
    for (ll i = 0; i < (ll)min(a.size(), b.size()); ++i) {
        if (a[i] < b[i]) {
            return true;
        } else if (a[i] > b[i]) {
            return false;
        }
    }
    if (a.size() < b.size()) {
        return true;
    }
    return false;
}
*/

int main()
{
    ll n;
    cin >> n;
    vector<unordered_set<ll>> og(n);
    vector<ll> zz;
    for (ll i = 0; i < n; ++i) {
        ll t;
        cin >> t;
        if (t == -1) {
            continue;
        }
        --t;
        og[t].insert(i);
        og[i].insert(t);
    }

    vector<set<ll>> g(n);
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            if (og[i].count(j) == 0 && i != j) {
                g[i].insert(j);
            }
        }
    }

    map<ll, set<set<ll>>> fulls;
    for (ll i = 0; i < n; ++i) {
        for (ll to : g[i]) {
            fulls[2].insert({to, i});
        }
    }

    ll fsize = 3;
    while (!fulls[fsize - 1].empty()) {
        for (auto& fg : fulls[fsize-1]) {
            for (ll i = 0; i < n; ++i) {
                if (fg.count(i) > 0) {
                    goto nonono;
                }
                for (auto& vtx : fg) {
                    if (!g[i].count(vtx)) {
                        goto nonono;
                    }
                }
                auto myset = fg;
                myset.insert(i);
                fulls[fsize].insert(myset);
            }
        nonono:
            0;
        }
        ++fsize;
    }
    cout << fsize - 2 << endl;
}
