#include <iostream>
#include <unistd.h>

using namespace std;

typedef long int i64;
typedef long unsigned int u64;
typedef int i32;
typedef unsigned int u32;

i64 sqrt(i64 n) {
    if (n == 0) {
        return 0;
    }
    i64 a = n;
    for (int _ = 0; _ < 64; _++) {
        a = (a + n / a) / 2;
    }
    while (a * a > n) {
        a--;
    }
    return a;
}

i64 sqr(i64 n) {
    return n * n;
}

bool is_sqr(i64 n) {
    return (n >= 0) && (sqr(sqrt(n)) == n);
}

int main() {
    i64 k;
    cin >> k;
    if (is_sqr(k)) {
        cout << sqrt(k) << endl;
    } else if (k > 0) {
        if (k % 2 == 0) {
            for (int i = 0; i < k; i++) {
                if (is_sqr(sqr(sqrt(k) + i) - k)) {
                    cout << sqrt(sqr(sqrt(k) + i)) << endl;
                    return 0;
                }
            }
            cout << "none";
        } else {
            //int x = (k + 1) / 2;
            for (int i = 1; !is_sqr(k); k += i, i += 2);
            cout << sqrt(k);
        }
    } else {
        i64 t = sqrt(sqr((-k + 1) / 2) + k);
        if (sqrt(-k) >= t) {
            cout << sqrt(sqr((-k + 1) / 2) + k) << endl;
        } else {
            cout << "none" << endl;
        }
    }
}
