#include <bits/stdc++.h>

using namespace std;

#define mp make_pair

vector<int> ops;
vector<int> a;
deque<int> b;

vector<int> cnt;

struct Node {
	int val, left, right;
};

vector<Node> nodes;

int get() {
	int res = nodes.size();
	nodes.push_back(Node());
	return res;
}

int build(int tl, int tr) {
	if (tl == tr) {
		return get();
	}
	int tm = (tl + tr) >> 1, v = get();
	int tmp = build(tl, tm);
	nodes[v].left = tmp;
	tmp = build(tm + 1, tr);
	nodes[v].right = tmp;
	return v;
}

int update(int v, int tl, int tr, int pos, int delta) {
	int nv = get();
	nodes[nv] = nodes[v];
	if (tl == tr) {
		nodes[nv].val += delta;
		return nv;
	}
	int tm = (tl + tr) >> 1;
	if (pos <= tm) {
		int tmp = update(nodes[v].left, tl, tm, pos, delta);
		nodes[nv].left = tmp;
	} else {
		int tmp = update(nodes[v].right, tm + 1, tr, pos, delta);
		nodes[nv].right = tmp;
	}
	nodes[nv].val = nodes[ nodes[nv].left ].val + nodes[ nodes[nv].right ].val; 
	return nv;
}

int get(int v, int tl, int tr, int left, int right) {
	if (left > right) return 0;
	if (tl == left && tr == right) {
		return nodes[v].val;
	}
	int tm = (tl + tr) >> 1;
	return get(nodes[v].left, tl, tm, left, min(tm, right)) + 
	get(nodes[v].right, tm + 1, tr, max(tm + 1, left), right);
}


const int K = 3e5 + 5;

vector<int> numbers;
unordered_map<int, int> prevv;

void add(int val) {
	int pos = numbers.size();
	int root = numbers.back();
	if (prevv.count(val)) {
		root = update(root, 0, K, prevv[val], -1);
	}
	prevv[val] = pos;
	root = update(root, 0, K, pos, 1);
	numbers.push_back(root);
}

inline int get(int left, int right) {
	int ans = get(numbers[right], 0, K, left, right);
	ans -= get(numbers[left - 1], 0, K, left, right);
	return ans;
}

void solve() {
	int n, m;
	cin >> n >> m;
	nodes.reserve(n * 64);
	numbers.reserve(m + 4);
	a.resize(m);
	b.resize(n);
	cnt.resize(n + 1);
	for (int i = 0; i < m; ++i) { cin >> a[i]; }
	for (int i = 0; i < n; ++i) { cin >> b[i]; }
	unordered_map<int, pair<int, int> > s;
	int cur = 1;
	numbers.push_back(build(0, K));
	for (int i = 0; i < m; ++i) {
		if (!cnt[a[i]]) {
			while (b.front() != a[i]) {
				cnt[b.front()] = 1;
				s[b.front()].first = cur++;
				s[b.front()].second = (int)ops.size();
				add(b.front());
				b.pop_front();
				ops.push_back(n);
			}
			add(b.front());
			cnt[b.front()] = 1;
			s[b.front()].first = cur++;
			s[b.front()].second = (int)ops.size();
			b.pop_front();
			ops.push_back(n);
		} else {
			int op, time;
			tie(time, op) = s[a[i]];
			s.erase(s.find(a[i]));
			ops[op] = get(time, cur - 1);
			add(a[i]);
			s[a[i]].first = cur++;
			s[a[i]].second = (int) ops.size();
			ops.push_back(n);
		}
	}
	cout << ops.size() << endl;
	for (int x : ops)  cout << x << " ";
	cout << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}