// C.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int maxn = 1e6;

int p[maxn], t[2 * maxn];
int cur_pos = maxn - 1;

void update(int pos, int val) {
	int i = pos + maxn;
	while (i > 0) {
		t[i] += val;
		i /= 2;
	}
}

int get_sum(int pos) {
	int i = pos + maxn;
	int sum = 0;
	while (i > 0) {
		if (!(i & 1)) sum += t[i--];
		i /= 2;
	}
	//cout << pos << ' ' << sum << endl;
	return sum;
}

int mv(int val) {
	int pos = p[val];
	int sum = get_sum(pos - 1);
	p[val] = cur_pos--;
	update(pos, -1);
	update(p[val], 1);
	return sum;
}

int main()
{
	ios::sync_with_stdio(0);
	int n, m;
	cin >> n >> m;
	vector<int> b(m), a(n);
	for (int i = 0; i < m; i++) {
		cin >> b[i];
		b[i]--;
	}
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
	}
	vector<int> ans;
	vector<int> cnt(n);
	for (int i = 0; i < m; i++) {
		cnt[b[i]]++;
	}
	int j = n - 1;
	while (j >= 0 && cnt[a[j]] == 0) j--;
	for (int i = n - 1; i >= 0; i--) {
		p[a[i]] = cur_pos;
		update(cur_pos--, 1);
	}
	for (int i = m - 1; i >= 0; i--) {
		int pos = mv(b[i]);
		ans.push_back(pos);
		cnt[b[i]]--;
		while (j >= 0 && cnt[a[j]] == 0) {
			int pos = mv(a[j]);
			if (pos != 0) ans.push_back(pos);
			j--;
		}
	}
	reverse(ans.begin(), ans.end());
	cout << (int)ans.size() << endl;
	for (int i = 0; i < (int)ans.size(); i++) {
		cout << ans[i] + 1 << ' ';
	}
	cout << endl;
	return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
