#include <iostream>

using namespace std;

long long gcd(long long a, long long b, long long& x, long long& y)
{
    long long aa = 1, ab = 0, ba = 0, bb = 1;
    while(a != 0)
    {
        swap(a, b);
        swap(aa, ba);
        swap(ab, bb);
        long long mod = a / b;
        a -= b * mod;
        aa -= ba * mod;
        ab -= bb * mod;
    }
    x = ba;
    y = bb;
    return b;
}

long long my_div(long long a, long long b)
{
    // b * x + mod * y = a
    long long x, y;
    long long c = gcd(b, 1000000007, x, y);
    if(c < 0)
    {
        c = -c;
        x = -x;
        y = -y;
    }
    if(c != 1)
        exit(1);
    x = (x % 1000000007 + 1000000007) % 1000000007;
    x = (x * a) % 1000000007;
    x = (x % 1000000007 + 1000000007) % 1000000007;
    return x;
}

struct C
{
    int n;
    int k = 0;
    long long val = 1;
    C(int n) : n(n){};
    int operator[](int new_k)
    {
        if(new_k < 0 || new_k > n)
            return 0;
        else if(new_k == 0 || new_k == n)
        {
            k = new_k;
            val = 1;
            return 1;
        }
        else
        {
            while(k < new_k)
            {
                val = (val * (n - k)) % 1000000007;
                val = my_div(val, k + 1);
                k++;
            }
            while(k > new_k)
            {
                k--;
                val = (val * (k + 1) % 1000000007);
                val = my_div(val, n - k);
            }
            return val;
        }
    }
};

void num_bitways(long long x, long long* bitways)
{
    for(int i = 0; i <= 64; i++)
        bitways[i] = 0;
    for(int i = 63; i >= 0; i--)
        if(x & (1ll << i))
        {
            int cnt_left = __builtin_popcountll(x & -(1ll << i)) - 1;
            C c(i);
            for(int j = 0; j + cnt_left <= 64; j++)
                bitways[cnt_left + j] = (bitways[cnt_left + j] + c[j]) % 1000000007;
        }
    bitways[__builtin_popcountll(x)]++;
}

long long fastpow(long long a, long long b)
{
    if(b == 0)
        return 1;
    else if(b % 1)
        return (fastpow(a, b - 1) * a) % 1000000007;
    else
        return fastpow((a * a) % 1000000007, b / 2);
}

int main()
{
    long long dyna[65][65];
    long long factor = 1;
    for(int i = 0; i <= 64; i++)
    {
        for(int j = 0; j < i; j++)
            dyna[i][j] = (dyna[i - 1][j - 1] + (dyna[i - 1][j] * j) % 1000000007) % 1000000007;
        dyna[i][i] = factor;
        for(int j = i + 1; j <= 64; j++)
            dyna[i][j] = 0;
        factor *= i + 1;
    }
    long long n, m, k;
    cin >> n >> m >> k;
    if(m != 0)
        return 1;
    long long data[65];
    num_bitways(k, data);
    long long ans = 1;
    C c(n);
    for(int j = 0; j <= 64; j++)
    {
        if(j)
            factor = (factor * j) % 1000000007;
        C cj(j);
        for(int i = 1; i <= j; i++)
        {
/*          long long cur = (cj[i] * fastpow(i, j - i)) % 1000000007;
            cur = (cur * factor) % 1000000007;*/
            long long cur = dyna[j][i];
            cur = (cur * c[i]) % 1000000007;
            cur = (cur * data[j]) % 1000000007;
//          cout << i << " slots, " << j << " bits - " << cur << " answers\n";
            ans = (ans + cur) % 1000000007;
        }
    }
    cout << ans << endl;
    return 0;
}
