#include<set>
#include<map>
#include<list>
#include<cmath>
#include<ctime>
#include<vector>
#include<random>
#include<utility>
#include<iostream>
#include<iterator>
#include<algorithm>
using namespace std;

const int N = 20;

vector<int> g_in, g[N];
int dp[N][2], used[N], cur_u = 1;
pair<int, int> e = { -1, -1 };
bool is_in[N];

void dfs_calc(int v, int p)
{
    used[v] = cur_u;

    int sum_0 = 0, sum_1 = 0;

    for (int u : g[v])
    {
        if (used[u] == cur_u)
        {
            if (u != p) e = { v, u };
            continue;
        }
        dfs_calc(u, v);
        sum_0 += dp[u][0];
        sum_1 += max(dp[u][1], dp[u][0]);
    }

    dp[v][0] = sum_1;
    dp[v][1] = sum_0 + 1;
}

void dfs_restore(int v, int c)
{
    used[v] = cur_u;

    if (c == 0)
    {
        for (int u : g[v])
        {
            if (used[u] == cur_u) continue;
            dfs_restore(u, 1);
        }
    }
    else
    {
        is_in[v] = dp[v][1] > dp[v][0];
        for (int u : g[v])
        {
            if (used[u] == cur_u) continue;
            dfs_restore(u, dp[v][1] <= dp[v][0]);
        }
    }
}

int solve_1(int n)
{
    int ans = 0;
    for (int mask = 0; mask < 1 << n; mask++)
    {
        int cnt = 0;
        bool flag = true;
        for (int j = 0; j < n; j++)
        {
            if ((mask >> j) & 1)
            {
                ++cnt;
                if (g_in[j] != -1 && ((mask >> g_in[j]) & 1))
                {
                    flag = false;
                    break;
                }
            }
        }

        if (flag)
        {
            ans = max(ans, cnt);
        }
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    
    int n, ans = 0;

    cin >> n;

    g_in.resize(n);


    for (int i = 0; i < n; i++)
    {
        cin >> g_in[i];
        if (g_in[i] != -1) --g_in[i];
    }
    if (n <= 20)
    {
        cout << solve_1(n) << '\n';
        return 0;
    }

    for (int i = 0; i < n; i++)
    {
        if (g_in[i] == -1) continue;
        if (g_in[g_in[i]] == i && i < g_in[i]) continue;

        g[i].push_back(g_in[i]);
        g[g_in[i]].push_back(i);
    }

    for (int i = 0; i < n; i++)
    {
        if (used[i] != 0) continue;

        dfs_calc(i, -1);
        ++cur_u;
        dfs_restore(i, dp[i][1] > dp[i][0]);
        int a = max(dp[i][1], dp[i][0]);

        if (e.first != -1 && is_in[e.first] && is_in[e.second])
        {
            int x = dp[e.first][0] - dp[e.first][1], y = dp[e.second][0] - dp[e.second][1];
            a += max(x, y);
        }

        e = { -1, -1 };
        ans += a;
    }

    cout << ans;
}

int main1()
{
    int n = 4;
    while (true)
    {
        srand(clock());
        g_in.clear();
        g_in.resize(n);

        for (int i = 0; i < n; i++)
        {
            int x = rand();
            if (x % (n + 1) == 0)
            {
                g_in[i] = -1;
            }
            else
            {
                g_in[i] = x % (n + 1);
            }
        }

        int x = solve_1(n), y = 0;

        if (x != y)
        {
            for (int i = 0; i < n; i++)
            {
                cout << g_in[i] << ' ';
            }
            cout << '\n' << x << ' ' << y << '\n';
            system("pause");
        }

        cur_u = 1;
        for (int i = 0; i < N; i++)
        {
            g[i].clear();
            dp[i][0] = dp[i][1] = 0;
            used[i] = 0;
            is_in[i] = false;
        }
    }

    return 0;
}