#include<set>
#include<map>
#include<list>
#include<cmath>
#include<ctime>
#include<vector>
#include<random>
#include<utility>
#include<iostream>
#include<iterator>
#include<algorithm>
using namespace std;

void solve_k1(int n)
{
    vector<pair<int, int>> v(n);

    for (int i = 0; i < n; i++)
    {
        cin >> v[i].first;
        v[i].second = i + 1;
    }

    sort(v.begin(), v.end());
    cout << "YES\n";

    for (int i = 0; i < n / 2; i++)
    {
        cout << v[i].second << ' ' << v[n - i - 1].second << '\n';
    }
}

void solve_n_f(int n, int k, vector<vector<int>> v)
{
    vector<int> perm(n + 1);

    for (int i = 1, x = 0; i <= n; i += 2) perm[i] = perm[i + 1] = x++;

    bool f = false;
    do
    {
        vector<vector<vector<int>>> pr(n / 2);
        vector<pair<int, int>> insp(k, { -1e9, 1e9 });
        for (int i = 1; i <= n; i++) pr[perm[i]].push_back(v[i]);
        for (int i = 0; i < n / 2; i++)
        {
            for (int j = 0; j < k; j++)
            {
                insp[j].first = max(insp[j].first, min(pr[i][0][j], pr[i][1][j]));
                insp[j].second = min(insp[j].second, max(pr[i][0][j], pr[i][1][j]));
            }
        }

        bool flag = true;

        for (int i = 0; i < k; i++)
        {
            flag = flag && insp[i].second >= insp[i].first;
        }

        if (flag)
        {
            f = true;
            break;
        }

    } while (next_permutation(perm.begin(), perm.end()));

    if (!f)
    {
        cout << "NO";
    }
    else
    {
        vector<vector<int>> ans(n / 2);
        for (int i = 1; i <= n; i++) ans[perm[i]].push_back(i + 1);
        cout << "YES\n";
        for (int i = 0; i < n / 2; i++) cout << ans[i][0] << ' ' << ans[i][1] << '\n';
    }
}

vector<vector<int>> v;
int cur_it = 0;

bool cmp(int a, int b)
{
    return v[a][cur_it] < v[b][cur_it];
}

const int N = 802;
vector<int> g[N];
int mt[N];
bool used[N];

bool dfs_calc(int v)
{
    if (used[v]) return false;
    used[v] = true;

    for (int i : g[v])
    {
        if (mt[i] == 0)
        {
            mt[i] = v;
            mt[v] = i;
            return true;
        }
    }

    for (int i : g[v])
    {
        if (dfs_calc(mt[i]))
        {
            mt[v] = i;
            mt[i] = v;
            return true;
        }
    }

    return false;
}

int main()
{
    int n, k;
    cin >> n >> k;

    v.resize(n + 1, vector<int>(k));
    vector<int> nums(n + 1);
    vector<vector<char>> valid(n + 1, vector<char>(n + 1, true));

    if (k == 1)
    {
        solve_k1(n);
        return 0;
    }

    for (int i = 1; i <= n; i++)
    {
        nums[i] = i;
        for (int j = 0; j < k; j++)
        {
            cin >> v[i][j];
        }
    }
    
    if (n <= 20)
    {
        solve_n_f(n, k, v);
        return 0;
    }

    for (int i = 0; i < k; i++)
    {
        sort(nums.begin() + 1, nums.end(), cmp);

        for (int i = 1; i <= n / 2; i++)
        {
            for (int j = 1; j <= n / 2; j++)
            {
                valid[nums[i]][nums[j]] = valid[nums[j]][nums[i]] = false;
            }
        }

        for (int i = n / 2 + 1; i <= n; i++)
        {
            for (int j = n / 2 + 1; j <= n; j++)
            {
                valid[nums[i]][nums[j]] = valid[nums[j]][nums[i]] = false;
            }
        }

        ++cur_it;
    }

    for (int i = 1; i <= n; i++)
    {
        for (int j = i + 1; j <= n; j++)
        {
            if (valid[i][j])
            {
                g[i].push_back(j + n);
                g[j + n].push_back(i);
                g[i + n].push_back(j);
                g[j].push_back(i + n);
            }
        }
    }

    for (int v = 1; v <= n; v++)
    {
        for (int u : g[v])
        {
            if (mt[u] == 0)
            {
                mt[u] = v;
                mt[v] = u;
                break;
            }
        }
    }

    bool flag = true;

    while (flag)
    {
        flag = false;

        for (int i = 0; i <= 2 * n; i++) used[i] = false;

        for (int i = 1; i <= n; i++)
        {
            if (mt[i] == 0) flag = flag || dfs_calc(i);
        }
    }

    vector<pair<int, int>> ans;
    vector<vector<char>> out(n + 1, vector<char>(n + 1));

    for (int i = 1; i <= n; i++)
    {
        if (mt[i] == 0)
        {
            cout << "NO";
            return 0;
        }
        else
        {
            ans.push_back({ i, mt[i] - n });
        }
    }

    cout << "YES\n";

    for (int i = 1; i <= n; i++)
    {
        if (!out[i][mt[i] - n])
        {
            out[i][mt[i] - n] = out[mt[i] - n][i] = true;
            cout << i << ' ' << mt[i] - n << '\n';
        }
    }
}