#include <iostream>
#include <vector>
#include <algorithm>

typedef long long ll;

using namespace std;

const ll MOD = 1e9 + 7;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, k;
    cin >> n >> k;
    n -= k;
    if (n == 0)
        return cout << "1" << endl, 0;

    vector<vector<vector<ll>>> dp(n + 1,
            vector<vector<ll>>(n + 1, vector<ll>(2, 0)));
    dp[n][k][0] = 1;
    dp[n][k][1] = 1;
    for (int i = n - 1; i >= 0; i--)
    {
        for (int j = 0; j <= n - i; j++)
        {
            for (int x = 1; x <= n; x++)
            {
                if (x < j)
                {
                    dp[i][j][1] += dp[i + j][x][0];
                    dp[i][j][1] %= MOD;
                }
                else if (x > j)
                {
                    dp[i][j][0] += dp[i + j][x][1];
                    dp[i][j][0] %= MOD;
                }
            }
        }
    }

    ll ans = 0;
    for (int j = 0; j <= n; j++)
    {
        for (int k = 0; k <= 1; k++)
        {
            ans += dp[0][j][k];
            ans %= MOD;
        }
    }

    cout << ans << endl;

    return 0;
}