#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MOD = 1e9 + 7;
const int MAXN = 5000;

int dp[MAXN + 1][MAXN + 1][2];
int pfx[MAXN + 1][MAXN + 2][2];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;
    if (n == k)
        return cout << "1" << endl, 0;

    dp[n - k][k][0] = 1;
    dp[n - k][k][1] = 1;
    for (int j = 1; j <= n + 1; j++)
    {
        pfx[n - k][j][0] = (pfx[n - k][j - 1][0] + dp[n - k][j - 1][0]) % MOD;
        pfx[n - k][j][1] = (pfx[n - k][j - 1][1] + dp[n - k][j - 1][1]) % MOD;
    }

    for (int i = n - k - 1; i >= 0; i--)
    {
        for (int j = 0; j <= n - i; j++)
        {
            dp[i][j][1] += pfx[i + j][j][0] - pfx[i + j][1][0] + MOD;
            dp[i][j][1] %= MOD;
            dp[i][j][0] += pfx[i + j][n + 1][1] - pfx[i + j][j + 1][1] + MOD;
            dp[i][j][0] %= MOD;
        }

        for (int j = 1; j <= n + 1; j++)
        {
            pfx[i][j][0] = (pfx[i][j - 1][0] + dp[i][j - 1][0]) % MOD;
            pfx[i][j][1] = (pfx[i][j - 1][1] + dp[i][j - 1][1]) % MOD;
        }
    }

    int ans = 0;
    for (int j = 0; j <= n; j++)
    {
        for (int k = 0; k <= 1; k++)
        {
            ans += dp[0][j][k];
            ans %= MOD;
        }
    }

    cout << ans << endl;

    return 0;
}