#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>

typedef long long ll;

using namespace std;

struct object
{
    int idx;
    vector<int> p;
    vector<int> srt;
    vector<bool> good;
};

int n, k;

vector<object> objects;
vector<vector<int>> g;
vector<int> taken;
vector<int> color;
unordered_set<int> boys;
unordered_set<int> girls;
int iter = 0;

bool can_pair(int a, int b)
{
    for (int j = 0; j < k; j++)
        if (!objects[a].good[j] && !objects[b].good[j] &&
                ((objects[a].srt[j] < n / 2 && objects[b].srt[j] < n / 2) ||
                 (objects[a].srt[j] >= n / 2 && objects[b].srt[j] >= n / 2)))
            return false;
    return true;
}

bool dfs(int i)
{
    color[i] = iter;

    for (int x : girls)
        if (can_pair(i, x) && taken[x] == -1)
            return (taken[x] = i), true;

    for (int x : girls)
        if (color[taken[x]] != iter && can_pair(i, x) && dfs(taken[x]))
            return (taken[x] = i), true;

    return false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> k;

    objects.resize(n);
    for (int i = 0; i < n; i++)
    {
        objects[i].idx = i;
        objects[i].p.resize(k);
        objects[i].srt.resize(k);
        objects[i].good.resize(k, false);
        for (int j = 0; j < k; j++)
            cin >> objects[i].p[j];
    }

    if (k == 1)
    {
        sort(objects.begin(), objects.end(), [](object a, object b){return a.p[0] < b.p[0];});
        cout << "YES" << endl;
        for (int i = 0; i < n / 2; i++)
            cout << objects[i].idx + 1 << " " << objects[i + n / 2].idx + 1 << endl;
        return 0;
    }

    for (int j = 0; j < k; j++)
    {
        sort(objects.begin(), objects.end(), [j](object a, object b){return a.p[j] < b.p[j];});
        for (int i = 0; i < n; i++)
        {
            objects[i].srt[j] = i;
//            if (objects[n / 2 - 1].p[j] == objects[n / 2].p[j] && objects[n / 2].p[j] == objects[i].p[j])
//                objects[i].good[j] = true;
            if (j == 0)
            {
                if (objects[i].p[j] < objects[n / 2].p[j])
                    boys.insert(objects[i].idx);
                else if (objects[i].p[j] >= objects[n / 2].p[j])
                    girls.insert(objects[i].idx);
            }
        }
    }

    sort(objects.begin(), objects.end(), [](object a, object b){return a.idx < b.idx;});
    taken.resize(n, -1);
    color.resize(n, -1);
    for (int x : boys)
    {
        dfs(x);
        iter++;
    }

    vector<pair<int, int>> ans;
    for (int x : girls)
    {
        if (taken[x])
            ans.push_back({x + 1, taken[x] + 1});
        else
            return cout << "NO" << endl, 0;
    }

    cout << "YES" << endl;
    for (auto p : ans)
        cout << p.first << " " << p.second << endl;

    return 0;
}