#include <bits/stdc++.h>

#define INT_INF (int)(2 * 1e9)
#define LL_INF  (ll)(2 * 1e18)

#define __LOCAL
#define FAST_IO ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef __LOCAL
#define DBG(X) cout << #X << "=" << (X) << endl;
#else
#define DBG(X) 
#endif

using namespace std;

typedef long long int ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

int n, k;

vector<pii> p;
vector<vector<int>> data;
int color[20];
bool done = false;

pii intersect(pii a, pii b)
{
	int l = max(a.first, b.first);
	int r = min(a.second, b.second);

	return make_pair(l, r);
}

bool check()
{
	vector<pii> v(k, make_pair(-INT_INF, INT_INF));

	for(int i = 0; i < n; ++i)
	{
		for(int j = 0; j < i; ++j)
		{
			if(color[i] != color[j])
				continue;
			
			for(int l = 0; l < k; ++l)
			{
				pii nnn = make_pair(min(data[i][l], data[j][l]), max(data[i][l], data[j][l]));

				v[l] = intersect(v[l], nnn);

				if(v[l].first > v[l].second)
					return false;
			}
		}
	}

	return true;
}

void find_sol(int c)
{
	bool found = false;

	if(done)
		return;

	for(int i = 0; i < n; ++i)
	{
		for(int j = 0; j < i; ++j)
		{
			if(color[i] == 0 && color[j] == 0)
			{
				found = true;

				color[i] = c, color[j] = c;
				find_sol(c + 1);

				if(done)
					return;

				color[i] = 0, color[j] = 0;
			}
		}
	}

	if(!found)
	{
		if(check())
		{
			done = true;

			vector<pii> ans;

			for(int i = 0; i < n; ++i)
			{
				for(int j = 0; j < i; ++j)
				{
					if(color[i] == color[j])
						ans.emplace_back(i + 1, j + 1);
				}
			}

			cout << "YES" << endl;

			for(auto el: ans)
				cout << el.first << " " << el.second << endl;
		}
	}
}

void solve()
{
	cin >> n >> k;

	if(k == 1)
	{
		p.resize(n);

		for(int i = 0; i < n; ++i)
		{
			int vl;
			cin >> vl;

			p[i].first = vl;
			p[i].second = i + 1;
		}

		sort(p.begin(), p.end());

		int i = 0, j = n - 1;

		cout << "YES" << endl;

		while(i < j)
		{
			cout << p[i].second << " " << p[j].second << endl;

			++i, --j;
		}

		return;
	}

	for(int i = 0; i < n; ++i)
	{
		data.push_back(vector<int>());
		data.rbegin()->resize(k);

		for(int j = 0; j < k; ++j)
			cin >> data[i][j];
	}

	if(n <= 10)
	{
		find_sol(1);

		if(!done)
		{
			cout << "NO" << endl;
			return;
		}
	}
}

int main()
{
	FAST_IO;
	solve();

	return 0;
}