#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

#define int long long

struct node {
	int val, prior, sz, mx;
	node *l, *r;
	node(int v)
	{
		val = v;
		mx = v;
		sz = 1;
		prior = (rand() << 16) | rand();
		l = nullptr;
		r = nullptr;
	}
};

int sz(node * tree)
{
	if (tree == nullptr)
	{
		return 0;
	}
	return tree->sz;
}

int mx(node * tree)
{
	if (tree == nullptr)
		return -1e9;
	return tree->mx;
}

void upd(node * tree)
{
	if (tree == nullptr)
		return;
	tree->sz = 1 + sz(tree->l) + sz(tree->r);
	tree->mx = max(tree->val, max(mx(tree->l), mx(tree->r)));
}

node * merge(node * tree_l, node * tree_r)
{
	if (tree_l == nullptr)
		return tree_r;
	if (tree_r == nullptr)
		return tree_l;
	if (tree_l->prior < tree_r->prior)
	{
		tree_l->r = merge(tree_l->r, tree_r);
		upd(tree_l);
		return tree_l;
	}
	else
	{
		tree_r->l = merge(tree_l, tree_r->l);
		upd(tree_r);
		return tree_r;
	}
}

pair <node *, node *> split(node * tree, int size)
{
	if (tree == nullptr)
		return { nullptr, nullptr };
	if (sz(tree->l) >= size)
	{
		auto p = split(tree->l, size);
		tree->l = p.second;
		upd(tree);
		return { p.first, tree };
	}
	else
	{
		auto p = split(tree->r, size);
		tree->r = p.first;
		upd(tree);
		return { tree, p.second };
	}
}

node * insert(node * tree, node * x, int pos)
{
	if (tree == nullptr)
		return x;
	auto p = split(tree, pos);
	auto i = merge(p.first, x);
	auto j = merge(i, p.second);
	upd(j);
	return j;
}

node * del(node * tree)
{
	if (tree == nullptr)
		return nullptr;
	if (tree->l == nullptr && tree->r == nullptr)
		return nullptr;
	if (tree->l != nullptr)
	{
		tree->l = del(tree->l);
		upd(tree);
		return tree;
	}
}

const int MAXN = 3 * 1e5 + 10;
int a[MAXN], b[MAXN];
int n, m;
bool flag_g1 = true, flag_g2 = true;
void read()
{
	cin >> n >> m;
	if (n != m)
	{
		flag_g1 = false;
		flag_g2 = false;
	}
	for (int i = 0; i < m; i++)
	{
		cin >> a[i];
	}
	for (int i = 0; i < n; i++)
	{
		cin >> b[i];
		if (n == m)
		{
			if (a[i] != b[i])
				flag_g1 = false;
			if (b[i] != a[n - 1 - i])
				flag_g2 = false;
		}
	}
}
vector <int> ans;

void run_g1()
{
	ans.assign(n, n);
}

void run_g2()
{
	ans.assign(2 * n - 2, 0);
	for (int i = 0; i < n - 1; i++)
	{
		ans[i] = n - i;
	}
	for (int i = 0; i < n - 1; i++)
	{
		ans[i + n - 1] = n;
	}
}

void run()
{
	for (int i = 0; i < m; i++)
	{

	}
}

void write()
{
	cout << ans.size() << endl;
	for (auto i : ans)
		cout << i << " ";
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	if (flag_g1)
		run_g1();
	else if (flag_g2)
		run_g2();
	else
		run();
	write();
	return 0;
}