#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <vector>
using namespace std;
const int MAXN = 3 * 1e5 + 10;
vector <int> g[MAXN];
int n;
vector <int> a;
void read()
{
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++)
	{
		int v;
		cin >> v;
		if (v == -1)
			continue;
		v--;
		g[i].push_back(v);
		g[v].push_back(i);
		a.push_back(v);
	}
}

bool used[MAXN];
int color[MAXN];
int cnt1, cnt2;
void dfs(int v, int c)
{
	if (c == 1)
		for (auto i : g[v])
		{
			if (color[i] == 1)
			{
				c = 2;
				break;
			}
		}
	if (c == 1)
		cnt1++;
	else
		cnt2++;
	color[v] = c;
	used[v] = 1;
	for (auto i : g[v])
	{
		if (!used[i])
		{
			dfs(i, 3 - c);
		}
	}
}

int ans;

void run()
{
	ans = 0;
	for (int i = 0; i < n; i++)
	{
		if (!used[i])
		{
			cnt1 = 0;
			cnt2 = 0;
			dfs(i, 1);
			ans += max(cnt1, cnt2);
		}
	}
}

bool check(vector <int> x)
{
	for (int i = 0; i < n; i++)
	{
		if (a[i] == -1)
			continue;
		if (x[i] == 1 && x[a[i]] == 1)
			return false;
	}
	return true;
}

void run2()
{
	ans = 0;
	for (int i = 1; i <= n; i++)
	{
		vector <int> pos(n);
		for (int j = 0; j < i; j++)
			pos[n - j - 1] = 1;
		do
		{
			if (check(pos))
			{
				ans = i;
				break;
			}
		} while (next_permutation(pos.begin(), pos.end()));
		if (ans != i)
			break;
	}
}

void write()
{
	cout << ans;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	read();
	if (n <= 20)
		run2();
	else
		run();
	write();
	return 0;
}
