//FPI
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <functional>

using namespace std;

int main() {
	int n, m;
	cin >> n >> m;
	vector <int> a(m);
	for (int i = 0; i < m; i++) {
		cin >> a[i];
		a[i] --;
	}
	vector <int> b(n);
	vector <int> c(n);
	for (int i = 0; i < n; i++) {
		cin >> b[i];
		b[i]--;
		c[b[i]] = i;
	}

	vector <int> dp_dp_last(n, -1);
	vector <int> next(m, m);
	vector <int> first(n, m);
	for (int i = 0; i < m; i++) {
		if (first[a[i]] == m) {
			first[a[i]] = i;
		}
		if (dp_dp_last[a[i]] != -1) {
			next[dp_dp_last[a[i]]] = i;
		}
		dp_dp_last[a[i]] = i;
	}

	vector <pair<int, int>> tree(4 * m, {0 , 0});

	function <void(int, int, int)> build = [&](int v, int l, int r) {
		if (r == l + 1) {
			tree[v].first = c[a[l]];
			return;
		}
		int mid = (l + r) / 2;
		build(v * 2 + 1, l, mid);
		build(v * 2 + 2, mid, r);
		tree[v].first = max(tree[v * 2 + 1].first, tree[2 * v + 2].first);
	};

	build(0, 0, m);

	function <void(int, int, int)> push = [&](int v, int l, int r) {
		tree[v].first += tree[v].second;
		if (r > l + 1) {
			tree[2 * v + 1].second += tree[v].second;
			tree[2 * v + 2].second += tree[v].second;
		}
		tree[v].second = 0;
	};

	function <void(int, int, int, int, int)> update2 = [&](int v, int l, int r, int L, int R) {
		push(v, l, r);
		if ((R <= l) || (r <= L)) {
			return;
		}
		if ((L <= l) && (r <= R)) {
			tree[v].second--;
			push(v, l, r);
			return;
		}
		int mid = (l + r) / 2;
		update2(v * 2 + 1, l, mid, L, R);
		update2(v * 2 + 2, mid, r, L, R);
		tree[v].first = max(tree[2 * v + 1].first, tree[2 * v + 2].first);
	};

	function <void(int, int, int, int, int)> update1 = [&](int v, int l, int r, int i, int num) {
		push(v, l, r);
		if ((r <= i) || (i < l)) {
			return;
		}
		if (r == l + 1) {
			tree[v].first = num;
			return;
		}
		int mid = (l + r) / 2;
		update1(v * 2 + 1, l, mid, i, num);
		update1(v * 2 + 2, mid, r, i, num);
		tree[v].first = max(tree[2 * v + 1].first, tree[2 * v + 2].first);
	};

	function <int(int, int, int, int, int)> find = [&](int v, int l, int r, int L, int R) {
	//	cout << v << "\n";
		push(v, l, r);
		if ((r <= L) || (R <= l)) {
			return -1;
		}
		if ((L <= l) && (r <= R)) {
			return tree[v].first;
		}
		int mid = (l + r) / 2;
		return max(find(2 * v + 1, l, mid, L, R), find(2 * v + 2, mid, r, L, R));
	};

	//find(0, 0, m, 1, m);

	vector <int> ans(0);
	int j = 0;
	vector <int> dp(n, 0);
	for (int i = 0; i < m; i++) {
		if (dp[a[i]]) {
			first[a[i]] = next[i];
			int x = find(0, 0, m, i, first[a[i]]);
			update2(0, 0, m, i, first[a[i]]);
			if (first[a[i]] != m) {
				update1(0, 0, m, first[a[i]], x);
			}
			ans.push_back(x + 1);
		}
		else {
			while ((j < n) && (b[j] != a[i])) {
				int x = find(0, 0, m, i, first[b[j]]);
				update2(0, 0, m, i, first[b[j]]);
				if (first[b[j]] != m) {
					update1(0, 0, m, first[b[j]], x);
				}
				ans.push_back(x + 1);
				dp[b[j]] = 1;
 				j++;
			}
			if (j == n) {
				cout << "lox";
//				return 0;
//				system("pause");
			}
			first[a[i]] = next[i];
			int x = find(0, 0, m, i, first[b[j]]);
			update2(0, 0, m, i, first[b[j]]);
			if (first[b[j]] != m) {
				update1(0, 0, m, first[b[j]], x);
			}
			ans.push_back(x + 1);
			dp[b[j]] = 1;
			j++;
		}
	}
	cout << ans.size() << "\n";
	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << " ";
	}
//	system("pause");
	return 0;
}