#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <functional>

using namespace std;

int main() {
	long long n;
	cin >> n;
	long long a;
	vector <long long> dp(n, -1);
	vector <vector <long long>> graf(n, vector <long long>(0));
	for (long long i = 0; i < n; i++) {
		cin >> a;
		a--;
		if ((a >= 0) && (dp[a] != i)) {
			graf[a].push_back(i);
			graf[i].push_back(a);
			dp[i] = a;
		}
	}

	pair<int, int> dp_pair = {-1, -1};
	vector <vector <long long>> ans1(n, vector <long long>(2, 0));
	vector <vector <long long>> ans2(n, vector <long long>(2, 0));
	vector <long long> used(n, -1);

	function<void(int, int)>dfs1 = [&](int v, int prev) {
//		cout << v << "\n";
		used[v] = 0;
		for (int i = 0; i < graf[v].size(); i++) {
			int to = graf[v][i];
			if (used[to] == -1) {
				dfs1(to, v);
			}
			else if (to != prev) {
				dp_pair = make_pair(to, v);
			}
		}
	};

	function<void(int, int)> dfs2 = [&](int v, int prev) {
		used[v] = 1;
		if (v != dp_pair.first) {
			ans1[v][1] = 1;
		}
		if (v != dp_pair.second) {
			ans2[v][1] = 1;
		}
		for (int i = 0; i < graf[v].size(); i++) {
			int to = graf[v][i];
			if (used[to] == 0) {
				dfs2(to, v);
				ans1[v][1] += ans1[to][0];
				ans1[v][0] += max(ans1[to][1], ans1[to][0]);
				ans2[v][1] += ans2[to][0];
				ans2[v][0] += max(ans2[to][1], ans2[to][0]);
			}
			else if (used[to] == -1) {
				cout << "lox";
			}
		}
	};

	long long dp_ans = 0;
	for (long long i = 0; i < n; i++) {
		if (used[i] == -1) {
			dfs1(i, -1);
//			cout << dp_pair.first << " " << dp_pair.second << "\n";
			dfs2(i, -1);
			dp_ans += max(max(ans1[i][0], ans1[i][1]), max(ans2[i][0], ans2[i][1]));
			dp_pair = make_pair(-1, -1);
		}
	}
	/*
7
2
3
1
2
4
2
3
	*/
	cout << dp_ans;
//	system("pause");
	return 0;
}