#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <algorithm>

using namespace std;

#define int long long

#define LATER(limit) if(1000 * clock() / CLOCKS_PER_SEC > limit)

int solve(int k) {
	if(k == 0) {
		return 0;
	}

	if(k % 2 == 0 && k % 4 != 0) {
		return -1;
	}
	bool even = false;
	if(k % 4 == 0) {
		even = true;
		k /= 4;
	}

	vector<int> f;
	int k1 = abs(k);
	for(int i = 2; i <= abs(k1); i++) {
		while(k1 % i == 0) {
			f.push_back(i);
			k1 /= i;
		}
	}

	reverse(f.begin(), f.end());
	f.push_back(1);
	reverse(f.begin(), f.end());

	vector<bool> dp(1000002);
	dp[1] = true;
	for(int d: f) {
		for(int i = d; i < 1000002; i += d) {
			dp[i] = dp[i] || dp[i / d];
		}
	}

	int d;
	for(d = (int)(sqrt(abs(k)) + 0.5); !dp[d]; d--);
	// cerr << "[" << d << "]";

	int d1 = k / d;
	return abs((d + d1) / 2) * (even ? 2 : 1);
}

int ok(int k) {
	int i = 1;
	if(k < 0) {
		int sq = (int)(sqrt(-k) + 0.5f);
		if(k + sq * sq >= 0) {
			k += sq * sq;
		} else {
			sq++;
			k += sq * sq;
		}
		i = sq * 2;

		i = 2 * sq - 1;
	}

	int tries = 0;
	while(true) {
		int sq = (int)(sqrt(k) + 0.5f);
		if(sq * sq == k) {
			return sq;
		}

		tries++;
		if(tries >= 1000000) {
			return -1;
		}

		k += i;
		i += 2;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k;
	cin >> k;

	cout << ok(k) << endl;
	cout << solve(k) << endl;

	return 0;
}
