#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <algorithm>

using namespace std;

#define int long long

#define LATER(limit) if(1000 * clock() / CLOCKS_PER_SEC > limit)

int intsqrt(int n) {
	if(n == 0) {
		return 0;
	}
	int fl = sqrt(n);
	for(int i = max(0LL, fl - 100); i < fl + 100; i++) {
		if(i * i > n) {
			return i - 1;
		}
	}
	assert(false);
}

int solve(int k) {
	if(k == 0) {
		return 0;
	}

	if(k % 2 == 0 && k % 4 != 0) {
		return -1;
	}
	bool even = false;
	if(k % 4 == 0) {
		even = true;
		k /= 4;
	}
	bool neg = false;
	if(k < 0) {
		neg = true;
		k = -k;
	}

	vector<int> f;
	int k1 = k;
	for(int i = 2; i <= k1; i++) {
		while(k1 % i == 0) {
			f.push_back(i);
			k1 /= i;
		}
	}

	reverse(f.begin(), f.end());
	f.push_back(1);
	reverse(f.begin(), f.end());

	bitset<1000002> dp;
	dp[1] = true;
	for(int d: f) {
		for(int i = 1000002 / d * d, j = i / d; i >= 0; i -= d, j--) {
			dp[i] = dp[i] || dp[j];
		}
	}

	int d;
	for(d = intsqrt(k); !dp[d]; d--);
	// cerr << "[" << d << "]";

	if(even) {
		k *= 4;
		d *= 2;
	}

	int d1 = k / d;
	int ans = abs((d + d1) / 2);
	return neg ? intsqrt(ans * ans - k) : ans;
}

int ok(int k) {
	int i = 1;

	int tries = 0;
	while(true) {
		if(k >= 0) {
			int sq = intsqrt(k);
			if(sq * sq == k) {
				return sq;
			}
		}

		tries++;
		if(tries >= 1000000) {
			return -1;
		}

		k += i;
		i += 2;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int k;
	cin >> k;

	//cout << ok(k) << endl;
	//cout << solve(k) << endl;

	int ans = solve(k);
	if(ans == -1) {
		cout << "none";
	} else {
		cout << ans;
	}

	return 0;
}