#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <algorithm>
#include <cassert>

using namespace std;

#define int long long

const int MOD = 1000000007LL;

#define LATER(limit) if(1000 * clock() / CLOCKS_PER_SEC > limit)

int fast_pow(int n, int k) {
	if(k == 1) {
		return n;
	} else if(k == 0) {
		return 1;
	} else if(k % 2 == 1) {
		return fast_pow(n, k - 1) * n % MOD;
	} else {
		int x = fast_pow(n, k / 2);
		return x * x % MOD;
	}
}
int fast_pow0(int n, int k) {
	if(n == 0 || k == 0) {
		return 0;
	}
	return fast_pow(n, k);
}

int total(int gl, int gr, int all, int cnt) {
	return fast_pow(all, cnt) - fast_pow(all - (gr - gl + 1), cnt);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, k;
	cin >> n >> m >> k;

	if(k == 0) {
		cout << 1;
		return 0;
	}

	vector< pair<int, int> > segs;
	for(int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		l--; r--;
		segs.push_back(make_pair(l + 1, r));
	}
	int gl = 0, gr = n;
	for(pair<int, int> seg: segs) {
		gl = max(gl, seg.first);
		gr = min(gr, seg.second);
	}
	if(gr < gl) {
		cout << 0;
		return 0;
	}

	int b = log2(k) + 2;
	int ans = 0;
	int cnt_one = 0;
	for(int i = b - 1; i >= 0; i--) {
		if((k & (1LL << i)) == 0) {
			continue;
		}
		// Case 1. Bit I is not set => all other bits can contain anything

		int good1 = fast_pow(n + 1, i);
		int good2 = fast_pow(n, cnt_one);
		int bad1 = fast_pow0(n + 1 - (gr - gl + 1), i);
		int bad2 = fast_pow0(n - (min(n - 1, gr) - gl + 1), cnt_one);
		// cerr << "Bit " << i << ": good1=" << good1 << ", good2=" << good2 << ", bad1=" << bad1 << ", bad2=" << bad2 << endl;
		ans += good1 * good2 - bad1 * good2 - good1 * bad2 + bad1 * bad2;
		ans %= MOD;
		// Case 2. Bit I is set, handled in next iterations
		cnt_one++;
	}

	int good2 = fast_pow(n, cnt_one);
	int bad2 = fast_pow0(n - (min(n - 1, gr) - gl + 1), cnt_one);
	ans += good2 - bad2;
	ans %= MOD;

	cout << ans;
	return 0;
}