#pragma GCC target("tune=native,sse,sse2,sse3,ssse3,sse4,avx,mmx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>
#include <bitset>
#include <vector>
#include <utility>
#include <tuple>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <ctime>
#include <random>
#include <algorithm>

using namespace std;

vector< vector<int> > adj;
vector<int> loop;
set<int> loop_vertexes;

pair<int, int> dfs(int v) {
	int ans1 = 0, ans2 = 1;
	for(int u: adj[v]) {
		if(loop_vertexes.count(u)) {
			continue;
		}

		pair<int, int> p = dfs(u);
		ans1 += max(p.first, p.second);
		ans2 += p.first;
	}
	return make_pair(ans1, ans2);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	vector<int> a(n);
	adj.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> a[i];
		if(a[i] != -1) {
			a[i]--;
			adj[a[i]].push_back(i);
		}
	}

	vector<bool> used(n);
	for(int i = 0; i < n; i++) {
		if(used[i]) {
			continue;
		}

		used[i] = true;

		int j = i;
		set<int> items;
		vector<int> item_list;
		items.insert(j);
		while(a[j] != -1) {
			j = a[j];
			used[j] = true;
			if(items.count(j)) {
				// Found loop
				int idx = find(item_list.begin(), item_list.end(), j) - item_list.begin();
				for(int k = idx; k < item_list.size(); k++) {
					loop.push_back(item_list[k]);
					loop_vertexes.insert(item_list[k]);
				}
				break;
			}
			item_list.push_back(j);
			items.insert(j);
		}

		if(loop.size()) {
			break;
		}
	}

	int ans;

	// We may have NOT found a loop
	if(!loop.size()) {
		for(int i = 0; i < n; i++) {
			if(a[i] == -1) {
				pair<int, int> p = dfs(i);
				ans = max(p.first, p.second);
				break;
			}
		}
	} else {
		vector< pair<int, int> > anses;
		int sum = 0;
		for(int v: loop) {
			anses.push_back(dfs(v));
			sum += anses.back().first;
		}

		int ans1 = 0, ans2 = 0;
		for(int i = 0; i < loop.size() - 1; i += 2) {
			ans1 += max(anses[i].second - anses[i].first, 0);
		}
		for(int i = 1; i < loop.size(); i += 2) {
			ans2 += max(anses[i].second - anses[i].first, 0);
		}
		ans = max(ans1, ans2) + sum;
	}

	cout << ans;

	return 0;
}