#pragma GCC target("tune=native")
#include <bits/stdc++.h>

using namespace std;
using i32 = int32_t;
using u32 = uint32_t;
using i64 = int64_t;

namespace trandom {
    struct random {
        u32 seed = chrono::high_resolution_clock::now().time_since_epoch().count() ^ (u32)(make_unique<i32>().get() - (i32 *)0);
        mt19937 engine;
        uniform_int_distribution<i32> dist;

        random(i32 l = numeric_limits<i32>::min(), i32 r = numeric_limits<i32>::max()):
            engine(seed),
            dist(l, r) {

        }

        i32 operator() () {
            return dist(engine);
        }
    } next;
}

int main() {
#ifdef DEBUG
    assert(freopen("input", "r", stdin));
    assert(freopen("output", "w", stdout));
#endif
    cin.tie(nullptr)->sync_with_stdio(false);

    i64 l, r, a;
    cin >> l >> r >> a;

    auto dist = r - l + 1;
    auto mod = dist % a;

    auto div1 = dist / a;
    auto div2 = (dist + a - 1) / a;

    auto cnt1 = div1 * (div1 - 1) / 2;
    auto cnt2 = div2 * (div2 - 1) / 2;

    cout << mod * cnt2 + (a - mod) * cnt1 << endl;
}