#pragma GCC target("tune=native")
#include <bits/stdc++.h>

using namespace std;
using i32 = int32_t;
using u32 = uint32_t;
using i64 = int64_t;

namespace trandom {
    struct random {
        u32 seed = chrono::high_resolution_clock::now().time_since_epoch().count() ^ (u32)(make_unique<i32>().get() - (i32 *)0);
        mt19937 engine;
        uniform_int_distribution<i32> dist;

        random(i32 l = numeric_limits<i32>::min(), i32 r = numeric_limits<i32>::max()):
            engine(seed),
            dist(l, r) {

        }

        i32 operator() () {
            return dist(engine);
        }
    } next;
}

template<class T,class T1>
bool cmp1(T a, T1 b) {
    if (a.size() == b.size()) {
        i32 j = 0;
        for (auto i: b) {
            if (i != a[j]) {
                return false;
            }
            ++j;
        }
    } else {
        return false;
    }
    return true;
}

template<class T,class T1>
bool cmp2(T a, T1 b) {
    if (a.size() == b.size()) {
        i32 j = a.size() - 1;
        for (auto i: b) {
            if (i != a[j]) {
                return false;
            }
            --j;
        }
    } else {
        return false;
    }
    return true;
}

int main() {
#ifdef DEBUG
    assert(freopen("input", "r", stdin));
    assert(freopen("output", "w", stdout));
#endif
    cin.tie(nullptr)->sync_with_stdio(false);

    i32 n, m;
    cin >> n >> m;

    vector<i32> a(m);
    for (i32 i = 0; i < m; ++i) {
        cin >> a[i];
        --a[i];
    }

    vector<i32> ord(n, -1);
    ord[a[0]] = 0;
    for (i32 i = 1; i < m; ++i) {
        ord[a[i]] = ord[a[i - 1]];
        if (a[i] != a[i - 1]) ord[a[i]]++;
    }

    list<i32> b;
    for (i32 i = 0; i < n; ++i) {
        i32 x;
        cin >> x;
        --x;

        b.push_back(x);
    }

    if (cmp1(a, b)) {
        cout << n << endl;
        for (i32 i = 1; i <= n; ++i) {
            cout << n << " ";
        }
    } else if (cmp2(a, b)) {
        cout << 2 * n - 1 << endl;
        for (i32 i = 1; i < n; ++i) {
            cout << n - i + 1 << " ";
        }
        for (i32 i = 1; i <= n; ++i) {
            cout << n << " ";
        }
    } else {
        vector<i32> ans;
        i32 i = 0;
        while (i < m) {
            auto t = b.front();
            b.pop_front();

            if (t == a[i]) {
                ++i;
            }

            i32 j = i;

            if (find(a.begin() + i, a.end(), t) == a.end()) {
                ans.push_back(n);
                b.push_back(t);
            } else {
                auto to_ins = b.begin();
                i32 k = 0;
                i32 l = 1;
                for (auto it = b.begin(); it != b.end(); ++it, ++l) {
                    if (ord[*it] < ord[t]) {
                        ++k;
                    }
                    if (ord[t] == k) {
                        b.insert(++it, t);
                        ans.push_back(l);
                        break;
                    }
                }
            }
        }

        cout << ans.size() << endl;
        for (auto i: ans) {
            cout << i << " ";
        }
    }
}