#pragma GCC target("tune=native")
#include <bits/stdc++.h>

using namespace std;
using i32 = int32_t;
using u32 = uint32_t;
using i64 = int64_t;

namespace trandom {
    struct random {
        u32 seed = chrono::high_resolution_clock::now().time_since_epoch().count() ^ (u32)(make_unique<i32>().get() - (i32 *)0);
        mt19937 engine;
        uniform_int_distribution<i32> dist;

        random(i32 l = numeric_limits<i32>::min(), i32 r = numeric_limits<i32>::max()):
            engine(seed),
            dist(l, r) {

        }

        i32 operator() () {
            return dist(engine);
        }
    } next;
}

const i64 mod = 1e9 + 7;

int main() {
#ifdef DEBUG
    assert(freopen("input", "r", stdin));
    assert(freopen("output", "w", stdout));
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    
    i64 n, m, k;
    cin >> n >> m >> k;

    vector<i32> d(k + 1, 1);
    for (i32 i = 1; i < n; ++i) {
        vector<i32> nd(k + 1, 0);
        for (i32 j = 0; j <= k; ++j) {
            for (i32 l = 0; l <= k; ++l) {
                if ((j & l) == j) {
                    nd[l] += d[j];
                    nd[l] %= mod;
                }
            }
        }
        swap(nd, d);
    }

    i64 ans = 0;
    for (auto i : d) {
        ans += i;
        ans %= mod;
    }

    cout << ans << endl;
}