#pragma GCC target("tune=native,avx,avx2")
#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>

using namespace std;
using i32 = int32_t;
using u32 = uint32_t;
using i32 = int64_t;

namespace trandom {
    struct random {
        u32 seed = chrono::high_resolution_clock::now().time_since_epoch().count() ^ (u32)(make_unique<i32>().get() - (i32 *)0);
        mt19937 engine;
        uniform_int_distribution<i32> dist;

        random(i32 l = numeric_limits<i32>::min(), i32 r = numeric_limits<i32>::max()):
            engine(seed),
            dist(l, r) {

        }

        i32 operator() () {
            return dist(engine);
        }
    } next;
}

// i32 d[5001]
const i32 mod = 1e9 + 7;

enum cmp {
    greater, less
};

i32 add(i32 a, i32 b) {
    i32 c = a + b;
    if (c >= mod) {
        return c - mod;
    } else {
        return c;
    }
}

inline i32 solve(i32, i32);
inline i32 solve(i32, i32, cmp);

inline i32 solve(i32 k, i32 sum, cmp c) {
    if (sum == 0) {
        return 1;
    }

    i32 ans = 0;
    switch (c) {
        case cmp::greater:
            for (i32 i = k + 1; sum - i >= 0; ++i) {
                ans = add(ans, solve(i, sum - i, cmp::less));
            }
            break;
        case cmp::less:
            for (i32 i = 1; sum - i >= 0 && i < k; ++i) {
                ans = add(ans, solve(i, sum - i, cmp::greater));
            }
    }

    return ans;
}

inline i32 solve(i32 k, i32 sum) {
    return add(solve(k, sum, cmp::greater), solve(k, sum, cmp::less));
}

int main() {
#ifdef DEBUG
    assert(freopen("input", "r", stdin));
    assert(freopen("output", "w", stdout));
#endif
    cin.tie(nullptr)->sync_with_stdio(false);

    i32 n, k;
    cin >> n >> k;
    
    if (k != n) {
        cout << solve(k, n - k) << endl;
    } else {
        cout << 1 << endl;
    }
}