#pragma GCC target("tune=native")
#include <bits/stdc++.h>

using namespace std;
using i32 = int32_t;
using u32 = uint32_t;
using i64 = int64_t;

namespace trandom {
    struct random {
        u32 seed = chrono::high_resolution_clock::now().time_since_epoch().count() ^ (u32)(make_unique<i32>().get() - (i32 *)0);
        mt19937 engine;
        uniform_int_distribution<i32> dist;

        random(i32 l = numeric_limits<i32>::min(), i32 r = numeric_limits<i32>::max()):
            engine(seed),
            dist(l, r) {

        }

        i32 operator() () {
            return dist(engine);
        }
    } next;
}

i32 g[20];
i32 d[1 << 20];

i32 log_lsob(i32 i) {
    i32 lsob = i & (-i);
    i32 ans = 0;
    while (lsob > 1) {
        lsob >>= 1;
        ++ans;
    }

    return ans;
}

int main() {
#ifdef DEBUG
    assert(freopen("input", "r", stdin));
    assert(freopen("output", "w", stdout));
#endif
    cin.tie(nullptr)->sync_with_stdio(false);

    i32 n;
    cin >> n;

    if (n <= 20) {
        for (i32 i = 0; i < n; ++i) {
            i32 x;
            cin >> x;
            if (x != -1) {
                --x;
                g[i] |= 1 << x;
                g[x] |= 1 << i;
            }
        }

        d[0] = 1;
        for (i32 i = 0; i < n; ++i) {
            g[i] = ~g[i];
            d[1 << i] = 1;
        }

        for (i32 mask = 1, end = 1 << n; mask < end; ++mask) {
            i32 i = log_lsob(mask);
            d[mask] = d[mask ^ (1 << i)] && (mask == (mask & g[i]));
        }

        i32 ans = 0;
        for (i32 mask = 1, end = 1 << n; mask < end; ++mask) {
            if (d[mask] == 1) {
                ans = max(ans, __builtin_popcount(mask));
            }
        }

        cout << ans << endl;
    } else {
        vector<i32> t(n + 1, -1);
        for (i32 i = 0; i < n; ++i) {
            i32 x;
            cin >> x;
            if (x != -1) {
                t[x] = i + 1;
            } else {
                t[0] = i + 1;
            }
        }

        i32 ans = 0;

        vector<char> used(n + 1, 0);
        for (i32 i = 0; i <= n; ++i) {
            if (!used[i]) {
                i32 p = i;

                i32 k = 0;
                if (p == 0) {
                    --k;
                }
                
                do {
                    ++k;
                    used[p] = true;
                    p = t[p];
                } while (p != -1);

                ans += (k + 1) / 2;
            }
        }

        cout << ans << endl;
    }
}