#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>

using namespace std;

void sol1(int n, int m, vector<int>& a, vector<int>& b) {
	if (n != m)
		return;
	for (int i = 0; i < n; ++i)
		if (a[i] != b[i])
			return;
	cout << n << "\n";
	for (int i = 0; i < n; ++i)
		cout << n << " ";
	exit(0);
}

void sol2(int n, int m, vector<int>& a, vector<int>& b) {
	if (n != m)
		return;
	for (int i = 0; i < n; ++i)
		if (a[i] != b[n - i - 1])
			return;
	cout << n + n - 1 << "\n";
	for (int i = 0; i < n - 1; ++i)
		cout << n - i << " ";
	for (int i = 0; i < n; ++i)
		cout << n << " ";
	exit(0);
}

void sol4(int n, int m, vector<int>& a, vector<int>& b) {
	vector<int> num_prev_we(n);
	for (int i = 1; i < n; ++i)
		num_prev_we[a[i]] = a[i - 1];
	num_prev_we[a[0]] = -1;

	vector<int> next(m);
	for (int i = 0; i < m - 1; ++i)
		next[i] = i + 1;
	next[m - 1] = -1;
	int pos = 0;

	vector<int> action;
	action.reserve(2 * m);

	for (int i = 0; i < n; ++i) {
		while (a[i] != b[pos]) {
			int j = pos;
			while (b[j] != num_prev_we[b[pos]])
				j = next[j];
			int new_pos = next[pos];
			next[pos] = next[j];
			next[j] = pos;
			action.push_back(j);
			pos = new_pos;
		}
		pos = next[pos];
		action.push_back(m);
	}
	cout << action.size() << "\n";
	for (int elem : action)
		cout << elem << " ";
	exit(0);
}

int main() {
	int n, m;
	cin >> n >> m;
	vector<int> a(n), b(m);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		--a[i];
	}
	for (int i = 0; i < m; ++i) {
		cin >> b[i];
		--b[i];
	}
	sol1(n, m, a, b);
	sol2(n, m, a, b);
	sol4(n, m, a, b);
}
