#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const uint64_t mod = 1e9 + 7;

uint64_t pow(uint64_t n, uint64_t deg) {
	if (deg == 0)
		return 1;
	if (deg % 2 == 0) {
		uint64_t n2 = pow(n, deg / 2);
		return (n2 * n2) % mod;
	}
	else
		return (n * pow(n, deg - 1)) % mod;
}

int main() {
	uint64_t n, m, k;
	cin >> n >> m >> k;
	uint64_t cp_k = k, power_k = 0;
	while (cp_k) {
		cp_k /= 2;
		++power_k;
	}
	uint64_t ans = pow(n + 1, power_k - 1);
	for (uint64_t num = (1 << power_k - 1); num <= k; ++num) {
		uint64_t cp_num = num, digit = 0;
		while (cp_num) {
			if (cp_num & 1)
				++digit;
			cp_num /= 2;
		}
		ans = (ans + pow(n, digit)) % mod;
	}
	cout << ans;
}
