#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int mod = 1e9 + 7;

int main() {
	int n, k;
	cin >> n >> k;
	if (k > n) {
		cout << 0;
		return 0;
	}
	else if (k == n) {
		cout << 1;
		return 0;
	}
	vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>>(n + 1, { 0, 0 }));
	dp[n - k][k].first = 1;
	dp[n - k][k].second = 1;
	for (int pow = n - k - 1; pow >= 0; --pow) {
		for (int digit = 1; pow + digit <= n; ++digit) {
			for (int prev_digit = 1; prev_digit < digit; ++prev_digit) {
				dp[pow][digit].first += dp[pow + digit][prev_digit].second;
				if (dp[pow][digit].first >= mod)
					dp[pow][digit].first -= mod;
			}
			for (int prev_digit = digit + 1; prev_digit <= n; ++prev_digit) {
				dp[pow][digit].second += dp[pow + digit][prev_digit].first;
				if (dp[pow][digit].second >= mod)
					dp[pow][digit].second -= mod;
			}
		}
	}
	int ans = 0;
	for (int i = 0; i <= n; ++i) {
		ans += dp[0][i].first;
		if (ans >= mod)
			ans -= mod;
		ans += dp[0][i].second;
		if (ans >= mod)
			ans -= mod;
	}
	cout << ans;

	/*cout << "\n";
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= n; ++j)
			cout << dp[j][i].first << " ";
		cout << "\n";
	}
	cout << "\n";
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= n; ++j)
			cout << dp[j][i].second << " ";
		cout << "\n";
	}
	cout << "\n";*/
}
