#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

const int mod = 1e9 + 7;

int main() {
	int n, k;
	cin >> n >> k;
	if (k > n) {
		cout << 0;
		return 0;
	}
	else if (k == n) {
		cout << 1;
		return 0;
	}
	vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>>(n + 1, { 0, 0 }));
	vector<vector<pair<int, int>>> suf_sum(n + 1, vector<pair<int, int>>(n + 1, { 0, 0 }));
	dp[n - k][k].first = 1;
	dp[n - k][k].second = 1;
	for (int pow = n - k - 1; pow >= 0; --pow) {
		for (int i = 1; i <= n; ++i) {
			suf_sum[pow + 1][i].first = suf_sum[pow + 1][i - 1].first + dp[pow + 1][i].first;
			if (suf_sum[pow + 1][i].first >= mod)
				suf_sum[pow + 1][i].first -= mod;
			suf_sum[pow + 1][i].second = suf_sum[pow + 1][i - 1].second + dp[pow + 1][i].second;
			if (suf_sum[pow + 1][i].second >= mod)
				suf_sum[pow + 1][i].second -= mod;
		}
		for (int digit = 1; pow + digit <= n; ++digit) {
			dp[pow][digit].first = suf_sum[pow + digit][digit - 1].second;
			dp[pow][digit].second = (suf_sum[pow + digit][n].first - suf_sum[pow + digit][digit].first + mod) % mod;
		}
	}
	int ans = 0;
	for (int i = 0; i <= n; ++i) {
		ans += dp[0][i].first;
		if (ans >= mod)
			ans -= mod;
		ans += dp[0][i].second;
		if (ans >= mod)
			ans -= mod;
	}
	cout << ans;

	/*cout << "\n";
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= n; ++j)
			cout << dp[j][i].first << " ";
		cout << "\n";
	}
	cout << "\n";
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j <= n; ++j)
			cout << dp[j][i].second << " ";
		cout << "\n";
	}
	cout << "\n";*/
}
