#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <bitset>

using namespace std;

const int nulledj = -2;

void sol1(int n, vector<int>& arr) {
	if (n > 20)
		return;
	int best = 0;
	bitset<20> used;
	for (uint32_t mask = 0; mask < (1 << n); ++mask) {
		for (int i = 0; i < 20; ++i)
			used[i] = 0;
		int cnt = 0;
		for (uint32_t i = 0; i < n; ++i)
			if ((mask >> i) & 1) {
				used[i] = 1;
				++cnt;
			}
		bool good = true;
		for (int i = 0; (i < n) && (good); ++i)
			if ((arr[i] != nulledj) && (used[i] == 1) && (used[arr[i]] == 1))
				good = false;
		if (good && (cnt > best))
			best = cnt;
	}
	cout << best;
	exit(0);
}

void sol2(int n, vector<int>& arr) {
	if (arr[0] != nulledj)
		return;
	for (int i = 1; i < n; ++i)
		if (arr[i] != i - 1)
			return;
	cout << (n + 1) / 2;
	exit(0);
}

pair<int, int> dfs(int v, vector<vector<int>>& adjlist, vector<char>& used) {
	used[v] = 1;
	int max_ans_0 = 0, max_ans_1 = 0;
	for (int to : adjlist[v]) {
		pair<int, int> ans_to = dfs(to, adjlist, used);
		max_ans_0 += max(max_ans_0, max(ans_to.first, ans_to.second));
		max_ans_1 += max(max_ans_1, ans_to.second);
	}
	return make_pair(max_ans_0, max_ans_1);
}

void sol3(int n, vector<int>& arr) {
	vector<vector<int>> adjlist(n);
	vector<char> used(n, 0);
	for (int i = 0; i < n; ++i)
		if (arr[i] != nulledj)
			adjlist[arr[i]].push_back(i);
	int ans = 0;
	for (int i = 0; i < n; ++i)
		if (used[i] == 0) {
			pair<int, int> ans_for_vi = dfs(i, adjlist, used);
			ans += max(ans_for_vi.first, ans_for_vi.second);
		}
	cout << ans;
	exit(0);
}

int main() {
	int n;
	cin >> n;
	vector<int> arr(n);
	for (int i = 0; i < n; ++i) {
		cin >> arr[i];
		--arr[i];
	}
	sol1(n, arr);
	sol2(n, arr);
	sol3(n, arr);
}
