#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

void dfs_kill(int v, int prev, vector<vector<int>>& adjlist, vector<char>& status, vector<char>& used) {
	used[v] = 1;
	bool to_1 = false;
	for (int to : adjlist[v])
		if (prev != to) {
			if (used[to] == 0) {
				dfs_kill(to, v, adjlist, status, used);
				to_1 = to_1 || (status[to] == 2);
			}
			else {
				status[v] = 3;
			}
		}
	if (status[v] == 0) {
		if (to_1)
			status[v] = 1;
		else
			status[v] = 2;
	}
}

int dfs_cycle(int v, vector<vector<int>>& adjlist, vector<char>& status, vector<char>& used) {
	used[v] = 1;
	int ans = 1;
	for (int to : adjlist[v])
		if ((used[to] == 0) && (status[to] == 3))
			ans += dfs_cycle(to, adjlist, status, used);
	return ans;
}

int main() {
	int n;
	cin >> n;
	vector<vector<int>> adjlist(n);
	for (int i = 0; i < n; ++i) {
		int a;
		cin >> a;
		if (a != -1) {
			--a;
			adjlist[i].push_back(a);
			adjlist[a].push_back(i);
		}
	}

	vector<char> status(n, 0), used(n, 0);
	for (int i = 0; i < n; ++i)
		if (used[i] == 0)
			dfs_kill(i, -1, adjlist, status, used);
	int ans = 0;
	for (int i = 0; i < n; ++i)
		used[i] = 0;
	for (int i = 0; i < n; ++i)
		if ((used[i] == 0) && (status[i] == 3))
			ans += dfs_cycle(i, adjlist, status, used) / 2;
	for (int i = 0; i < n; ++i)
		if (status[i] == 2)
			++ans;
	cout << ans;
}
