import java.io.*;
import java.util.*;


public class Main {

    public void solve() throws IOException {
        long k0 = nextLong();
        long k = Math.abs(k0);
        long n = (long) Math.pow(k, 0.5) + 1;

        if (k == 0) {
            out.println(0);
            return;
        }
        long ans = Long.MAX_VALUE;
        for (int i = 1; i < n; i++) {
            if ((k + (long) (i) * i) % (2 * i) == 0) {
                long y = (k + (long) (i) * i) / (2 * i);
                if (k0 > 0) {
                    ans = Math.min(ans, y);
                } else {
                    ans = Math.min(ans, y - i);
                }
            }
        }
        if (ans != Long.MAX_VALUE) {
            out.println(ans);
            return;
        }

        out.println("none");
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new Main().run();
    }

}
