import java.io.*;
import java.util.*;


public class Main {

    public void solve() throws IOException {
        long mod = 1000000007;
        int n = nextInt();
        int k = nextInt();

        if (n == k) {
            out.println(1);
            return;
        }

        long [][] dp1 = new long[n + 1][n + 1];
        long [][] dp2 = new long[n + 1][n + 1];

        dp1[0][0] = 1;
        dp2[0][0] = 1;

        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= i; j++) {
                if (i == j) {
                    dp1[i][j] = 1;
                    dp2[i][j] = 1;
                    continue;
                }

                for (int q = 1; q < j; q++) {
                    dp1[i][j] += dp2[i - j][q];
                    dp1[i][j] = dp1[i][j] % mod;
                }
                for (int q = j + 1; q <= n; q++) {
                    dp2[i][j] += dp1[i - j][q];
                    dp2[i][j] = dp2[i][j] % mod;
                }
            }
        }

//        for (int i = 0; i <= n; i++) {
//            for (int j = 0; j <= n; j++) {
//                out.print(dp1[i][j] + dp2[i][j] + " ");
//            }
//            out.println();
//        }
//
//        out.println();

//        for (int i = 0; i <= n; i++) {
//            for (int j = 0; j <= n; j++) {
//                out.print(dp2[i][j] + " ");
//            }
//            out.println();
//        }

        out.println(dp1[n][k] + dp2[n][k]);

    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new Main().run();
    }

}


