import java.io.*;
import java.util.*;


public class Main {


    int [] dp1;
    int [] dp2;
    ArrayList<Integer> [] g;
    boolean [] used;

    public void solve() throws IOException {
        int n = nextInt();
        dp1 = new int[n];
        dp2 = new int[n];

        g = new ArrayList[n];

        for (int i = 0; i < n; i++) {
            g[i] = new ArrayList<>();
        }

        for (int i = 0; i < n; i++) {
            int a = nextInt() - 1;
            if (a < 0) {
                continue;
            }
            g[i].add(a);
            g[a].add(i);
        }

        used = new boolean[n];
        int ans = 0;
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i);
                ans += Math.max(dp1[i], dp2[i]);
            }
        }
        out.println(ans);
    }

    public void dfs(int start) {
        used[start] = true;
        for (int v: g[start]) {
            if (!used[v]) {
                dfs(v);
                dp1[start] += dp2[v];
                dp2[start] += Math.max(dp1[v], dp2[v]);
            }
        }
        dp1[start] += 1;
    }



    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new Main().run();
    }

}


