#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <time.h>

using  namespace std;

#define DEBUG

bool possible(vector <pair <int, int>> &seg) {
	vector <pair <int, int>> sc;
	for (auto u : seg) {
		if (u.first > u.second) {
			swap(u.first, u.second);
		}
		sc.push_back({ u.first, -1 });
		sc.push_back({ u.second, 1 });
	}
	sort(sc.begin(), sc.end());
	int bal = 0;
	for (auto u : sc) {
		bal -= u.second;
		if (bal == seg.size()) {
			return 1;
		}
	}
	return 0;
}

vector <pair <int, int>> f(vector <pair <int, int>> &v, vector <int> &ind, vector <vector <int>> &a) {
	if (ind.size() == 0) {
		vector <pair <int, int>> to_inter(v.size());
		for (int i = 0; i < a[0].size(); i++) {
			for (int j = 0; j < v.size(); j++) {
				to_inter[j] = { a[v[j].first][i], a[v[j].second][i] };
			}
			if (!possible(to_inter)) return {};
		}
		return v;
	}
	vector <int> new_ind(ind.size() - 2);
	for (int i = 0; i < ind.size() - 2; i++) {
		new_ind[i] = ind[i + 2];
	}
	v.push_back({ ind[0], ind[1] });
	auto u = f(v, new_ind, a);
	if (u.size() != 0) return u;
	for (int i = 2; i < ind.size(); i++) {
		new_ind[i - 2] = ind[i - 1];
		v.back().second = ind[i];
		auto u = f(v, new_ind, a);
		if (u.size() != 0) return u;
	}
	v.pop_back();
	return {};
}

void sempl1(int n, vector <vector <int>> &g) {
	cout << "YES\n";
	vector <pair <int, int>> a(n);
	for (int i = 0; i < n; i++) {
		a[i] = { g[i][0], i + 1};
	}
	sort(a.begin(), a.end());
	for (int i = 0; i < n / 2; i++) {
		cout << a[i].second << ' ' << a[n - 1 - i].second << '\n';
	}
}

bool cmp1(const vector <int> &a, const vector <int> &b) {
	return a[0] < b[0];
}

bool cmp2(const vector <int> &a, const vector <int> &b) {
	if (a[1] == b[1]) return a[0] < b[0];
	return a[1] < b[1];
}

bool cmp3(const vector <int> &a, const vector <int> &b) {
	if (a[1] == b[1]) return a[0] < b[0];
	return a[1] > b[1];
}

int main() {
	int n, k;
	cin >> n >> k;
	vector <vector <int>> a(n, vector <int>(k));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			cin >> a[i][j];
		}
	}
	if (k == 1) {
		sempl1(n, a);
		return 0;
	}
	if (n <= 10) {
		vector <pair <int, int>> v;
		vector <int> ind(n);
		for (int i = 0; i < n; i++) {
			ind[i] = i;
		}
		auto u = f(v, ind, a);
		if (u.size() == 0) {
			cout << "NO";
		}
		else {
			cout << "YES\n";
			for (auto el : u) {
				cout << el.first + 1 << ' ' << el.second + 1 << '\n';
			}
		}
		//return 0;
	}
	if (k == 2) {
		vector <vector <int>> pos(n, vector <int>(2));
		for (int i = 0; i < n; i++) {
			a[i].push_back(i);
		}
		sort(a.begin(), a.end(), cmp1);
		for (int i = 0; i < n; i++) {
			if (i * 2 < n) {
				pos[a[i][2]][0] = 1;
			}
			else {
				pos[a[i][2]][0] = 2;
			}
		}
		sort(a.begin(), a.end(), cmp2);
		for (int i = 0; i < n; i++) {
			if (i * 2 < n) {
				pos[a[i][2]][1] = 1;
			}
			else {
				pos[a[i][2]][1] = 2;
			}
		}
		vector <int> oo, ot, to, tt;
		for (int i = 0; i < n; i++) {
			if (pos[i][0] == pos[i][1]) {
				if (pos[i][0] == 1) {
					oo.push_back(i + 1);
				}
				else {
					tt.push_back(i + 1);
				}
			}
			else {
				if (pos[i][0] == 1) {
					ot.push_back(i + 1);
				}
				else {
					to.push_back(i + 1);
				}
			}
			
		}
		if (oo.size() == tt.size() && ot.size() == to.size()) {
			cout << "YES\n";
			for (int i = 0; i < tt.size(); i++) {
				cout << tt[i] << ' ' << oo[i] << '\n';
			}
			for (int i = 0; i < ot.size(); i++) {
				cout << ot[i] << ' ' << to[i] << '\n';
			}
			return 0;
		}
		sort(a.begin(), a.end(), cmp3);
		for (int i = 0; i < n; i++) {
			if (i * 2 < n) {
				pos[a[i][2]][1] = 1;
			}
			else {
				pos[a[i][2]][1] = 2;
			}
		}
		oo.clear();
		ot.clear();
		to.clear();
		tt.clear();
		for (int i = 0; i < n; i++) {
			if (pos[i][0] == pos[i][1]) {
				if (pos[i][0] == 1) {
					oo.push_back(i + 1);
				}
				else {
					tt.push_back(i + 1);
				}
			}
			else {
				if (pos[i][0] == 1) {
					ot.push_back(i + 1);
				}
				else {
					to.push_back(i + 1);
				}
			}

		}
		if (oo.size() == tt.size() && ot.size() == to.size()) {
			cout << "YES\n";
			for (int i = 0; i < tt.size(); i++) {
				cout << tt[i] << ' ' << oo[i] << '\n';
			}
			for (int i = 0; i < ot.size(); i++) {
				cout << ot[i] << ' ' << to[i] << '\n';
			}
			return 0;
		}
		cout << "NO\n";
		return 0;
	}
	
#ifdef DEBUG
	system("Pause");
#endif // DEBUG
}