#include <bits/stdc++.h>
#pragma GCC optimize("fast-math")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#define int long long

using namespace std;

mt19937 rnd(time(nullptr));
vector <int> steps(1e6);
vector <vector <int> > sparse;

int ind(const vector <int>&num, int x) {
    if (upper_bound(num.begin(), num.end(), x) == num.end()) return -1;
    return num[upper_bound(num.begin(), num.end(), x) - num.begin()];
}

vector <vector <int> > build_sparse(const vector <int>&num) {
    vector <vector <int> > res;
    int n = num.size();
    vector <int> smth;
    for (int i = 0; i < n; i++) {
        smth.push_back(num[i]);
    }
    res.push_back(smth);
    for (int x = 1; x < 20; x++) {
        if ((1 << x) > n) break;
        vector <int> kek;
        for (int j = 0; j < n - (1 << x) + 1; j++) {
            kek.push_back(min(res[x - 1][j], res[x - 1][j + (1 << (x - 1))]));
        }
        res.push_back(kek);
    }
    return res;
}

int get_min(int l, int r) {
    int len = r - l + 1;
    int x = steps[len];
    return min(sparse[len][l], sparse[len][l + (1 << x)]);
}

void precalc() {
    for (int i = 0; i < steps.size(); i++) {
        int l = 0;
        int r = 23;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if ((1 << m) <= i) l = m;
            else r = m;
        }
        steps[i] = l;
    }
}

const int mod = 1e9 + 7;

vector <vector <int> > graph, graph2;
vector <int> used, css, cycle;
vector <pair <int, int> > tout;
set <int> kek;
map <int, int> lol;
int ch = 0, nech = 0;
int res = 0;
int timer = 0;

void dfs(int v) {
    timer++;
    used[v] = 1;
    for (auto to : graph[v]) {
        if (!used[to]) dfs(to);
    }
    timer++;
    tout[v] = {timer, v};
}

void dfs2(int v, int col) {
    css[v] = col;
    for (auto to : graph2[v]) {
        if (!css[to]) dfs2(to, col);
    }
}

void dfs3(int v) {
    cycle.push_back(v);
    used[v] = 1;
    for (auto to : graph[v]) {
        if (!used[to] && kek.find(to) != kek.end()) dfs3(to);
    }
}

void dfs4(int v, int depth) {
    used[v] = 1;
    if (depth) {
        if (depth % 2 == 0) ch++;
        else nech++;
    }
    for (auto to : graph2[v]) {
        if (!used[to] && kek.find(to) == kek.end()) dfs4(to, depth + 1);
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    graph.resize(n);
    graph2.resize(n);
    used.resize(n);
    tout.resize(n);
    css.resize(n);
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x == -1) continue;
        x--;
        graph[i].push_back(x);
        graph2[x].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfs(i);
    }
    sort(tout.begin(), tout.end());
    reverse(tout.begin(), tout.end());
    int col = 0;
    for (int i = 0; i < n; i++) {
        int v = tout[i].second;
        if (!css[v]) {
            col++;
            dfs2(v, col);
        }
    }
    //for (auto el : css) cout << el <<  " ";
    //cout << "\n";
    map <int, set <int> > smth;
    for (int i = 0; i < n; i++) smth[css[i]].insert(i);
    int ans = 0;
    for (int i = 0; i < n; i++) used[i] = 0;
    for (int i = 1; i <= col; i++) {
        kek = smth[col];
        if (kek.size() > 1) {
            cycle.clear();
            dfs3(*kek.begin());
            vector <int> ff, ss;
            for (auto v : cycle) {
                ch = 0;
                nech = 0;
                dfs4(v, 0);
                ff.push_back(ch);
                ss.push_back(nech);
            }
            int sum1 = 0, sum2 = 0;
            for (int j = 0; j < ff.size(); j++) {
                if (j % 2 == 0) sum1 += ff[j];
                else sum1 += ss[j];
            }
           // cout << "gjuid" << endl;
            for (int j = 0; j < ff.size(); j++) {
                if (j % 2 == 0) sum2 += ss[j];
                else sum2 += ff[j];
            }
            ans += max(cycle.size() / 2 + sum1, cycle.size() / 2 + sum2);
            //for (int j = 0; j < ff.size(); j++) cout << ff[j] << " " << ss[j] << "\n";
        }
    }
    cout << ans << "\n";
    return 0;
}
