#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <algorithm>
#include <assert.h>
using namespace std;

#define int long long


vector<int> t;

void recalc(int v)
{
    t[v] = t[v * 2] + t[v * 2 + 1];
}

void upd(int v, int l, int r, int L, int R, int x)
{
    if(l >= R || L >= r)
        return;
    if(L <= l && r <= R)
    {
        t[v] += x;
        return;
    }
    upd(v * 2, l, (l + r) / 2, L, R, x);
    upd(v * 2 + 1, (l + r) / 2, r, L, R, x);
    recalc(v);
}

int get(int v, int l, int r, int L, int R)
{
    if(l >= R || L >= r)
        return 0;
    if(L <= l && r <= R)
        return t[v];
    return get(v * 2, l, (l + r) / 2, L, R) + get(v * 2 + 1, (l + r) / 2, r, L, R);
}


signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> want(m);
    vector<int> b(n);

    for(int i = 0; i < m; ++i) cin >> want[i];
    for(int i = 0; i < n; ++i) cin >> b[i];
    for(int i = 0; i < m; ++i) want[i]--;
    for(int i = 0; i < n; ++i) b[i]--;
    reverse(b.begin(), b.end());
    set<pair<int, int>> freee;
    vector<int> ans(1e6);
    int cur = 0;
    t.resize(4 * (n + m));
    for(int i = 0; i < m; ++i)
    {
        auto it = freee.lower_bound({want[i], -1});
        if(it != freee.end() && it->first == want[i])
        {
            ans[it->second] = get(1, 0, n + m, it->second, n + m);
            int x = it->first;
            upd(1, 0, n + m, it->second, it->second + 1, -1);
            upd(1, 0, n + m, cur, cur + 1, 1);
            freee.erase(it);
            freee.insert({x, cur++});
        }
        else
        {
            while(b.back() != want[i])
            {
                upd(1, 0, n + m, cur, cur + 1, 1);
                freee.insert({b.back(), cur++});

                b.pop_back();
            }
            upd(1, 0, n + m, cur, cur + 1, 1);

            freee.insert({b.back(), cur++});
            b.pop_back();
        }
    }
    cout << cur << '\n';
    for(int i = 0; i < cur; ++i)
    {
        if(ans[i] == 0)
            cout << n << " ";
        else
            cout << ans[i] << " ";
    }
}