#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
using namespace std;

const int N = 3e5 + 2;
vector<int> g[N];
int L[N];
int R[N];
vector<bool> used;
bool dfs(int v)
{
    if(used[v])
        return false;
    used[v] = true;
    for(auto i : g[v])
    {
        if(L[i] == -1)
        {
            L[i] = v;
            R[v] = i;
            return true;
        }
    }
    for(auto i : g[v])
    {
        if(dfs(L[i]))
        {
            L[i] = v;
            R[v] = i;
            return true;
        }
    }
    return false;
}

map<pair<int, int>, bool> in_par;
vector<int> graph[N];


void build(int n)
{
    for(int i = 0; i < n; ++i) {
        for (int x : g[i])
        {
            if(in_par[{i, x}])
            {
                graph[x].push_back(i);
            }
            else
            {
                graph[i].push_back(x);
            }
        }
    }
}

void kek(int v)
{
    if(used[v])
        return;
    used[v] = true;
    for(int i : graph[v])
        kek(i);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    for(int i = 0; i < N; ++i)
        L[i] = R[i] = -1;
    used.resize(2 * n);
    for(int i = 0; i < n; ++i)
    {
        int a;
        cin >> a;
        if(a != -1)
        {
            --a;
            g[i].push_back(n + a);
            g[n + a].push_back(i);
        }
    }
    for(bool st = true; st;)
    {
        st = false;
        used.assign(2 * n, false);
        for(int i = 0; i < n; ++i)
        {
            if(R[i] == -1 && dfs(i))
            {
                st = true;
            }
        }
    }
    for(int i = n; i < 2 * n; ++i)
    {
        if(L[i] != -1)
        {
            in_par[{i, L[i]}] = true;
            in_par[{L[i], i}] = true;
        }
    }
    used.assign(2 * n, false);

    build(n);
    for(int i = 0; i < n; ++i)
        if(graph[i].size() > 0)
            kek(i);
    set<int> ans;
    for(int i = 0; i < n; ++i)
        if(used[i])
            ans.insert(i);
    for(int i = n; i < 2 * n; ++i)
        if(!used[i])
            ans.insert(i - n);
    cout << ans.size();
}