#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
using namespace std;

const int N = 3e5 + 2;

int L[N];
int R[N];
vector<int> g[N];
vector<int> graph[N];
vector<int> used;
map<pair<int, int>, bool> in_par;

bool dfs(int v)
{
    if(used[v])
        return false;
    used[v] = true;
    for(auto i : g[v])
    {
        if(R[i] == -1)
        {
            R[i] = v;
            L[v] = i;
            return true;
        }
    }
    for(auto i : g[v])
    {
        if(dfs(R[i]))
        {
            R[i] = v;
            L[v] = i;
            return true;
        }
    }
    return false;
}

void build(int n)
{
    for(int i = 0; i < n; ++i) {
        for (int x : g[i])
        {
            if(in_par[{i, x}])
            {
                graph[x].push_back(i);
            }
            else
            {
                graph[i].push_back(x);
            }
        }
    }
}

void kek(int v)
{
    if(used[v])
        return;
    used[v] = true;
    for(int i : graph[v])
        kek(i);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    cout << (n +  1) / 2;
    return 0;
    for(int i = 0; i < N; ++i)
        L[i] = R[i] = -1;
    used.resize(2 * n);
    for(int i = 0; i < n; ++i)
    {
        int a;
        cin >> a;
        if(a != -1)
        {
            --a;
            g[i].push_back(n + a);
            g[n + a].push_back(i);
        }
    }
    for(bool st = true; st;)
    {
        st = false;
        used.assign(2 * n, false);
        for(int i = 0; i < n; ++i)
        {
            if(L[i] == -1 && dfs(i))
            {
                st = true;
            }
        }
    }
    for(int i = 0; i < n; ++i)
    {
        if(L[i] != -1)
        {
            in_par[{i, L[i]}] = true;
            in_par[{L[i], i}] = true;
        }
    }
    used.assign(2 * n, false);
    vector<int> ans(n);
    build(n);
    for(int i = 0; i < n; ++i)
        if(L[i] == -1)
            kek(i);
    for(int i = 0; i < n; ++i)
        if(!used[i])
            ans[i] = 1;
    for(int i = n; i < 2 * n; ++i)
        if(used[i])
            ans[i - n] = 1;
    int cur = 0;
    for(int i = 0; i < n; ++i)
        cur += ans[i];
    cout << n - cur;
}