#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 2e5 + 1;

void get_div(int a, vector <int> &div) {
    int i = 1;
    while (i * i <= a) {
        if (a % i == 0) {
            div.push_back(i);
            if (i != a / i) {
                div.push_back(a / i);
            }
        }
        ++i;
    }
}

void get_prime(int a, vector <int> &div) {
    int i = 2;
    while (i * i <= a) {
        if (a % i == 0) {
            div.push_back(i);
            while (a % i == 0) {
                a /= i;
            }
        }
        ++i;
    }
    if (a != 1) {
        div.push_back(a);
    }
}

void print(vector <int> &a) {
    for (auto i : a) {
        cout << i << " ";
    }
    cout << "\n";
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    ll k;
    cin >> k;

    if (((k % 4) + 4) % 4 == 2) {
        cout << "none";
        return 0;
    }

    if (k == 0) {
        cout << 0;
        return 0;
    }

    ll i = 1, K = abs(k);
    ll mn = INF;

    while (i * i <= K) {
        if (K % i == 0) {
            if (k < 0) {
                ll a1 = -i;
                ll b1 = K / i;

                ll a2 = i;
                ll b2 = -K / i;

                ll m1 = (a1 + b1) / 2;
                ll m2 = (a2 + b2) / 2;

                if (m1 >= 0) {
                    mn = min(mn, m1);
                }
                if (m2 >= 0) {
                    mn = min(mn, m2);
                }
            }
            else {
                ll a = i;
                ll b = K / i;
                ll m = (a + b) / 2;

                mn = min(mn, m);
            }
        }
        ++i;
    }
    cout << mn;
    return 0;
}
