#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <bitset>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 2e5 + 1;
const int MOD = 1e9 + 7;

void print(vector <int> &a) {
    for (auto i : a) {
        cout << i << " ";
    }
    cout << "\n";
}

int n, m;
ll k, ans = 0;
map <int, set <int>> dict;

void rec(int ind, vector <int> t) {
    if (ind == n) {
        ++ans;
        if (ans >= MOD) {
            ans -= MOD;
        }
        return;
    }
    int start = 0;
    if (t.size()) {
        start = t.back();
    }
    for (int i = start; i <= k; ++i) {
        bool good = 1;
        for (auto j : dict[ind]) {
            if (t[j] == i) {
                good = 0;
                break;
            }
        }
        if (good && (i & start) == start) {
            t.push_back(i);
            rec(ind + 1, t);
            t.pop_back();
        }
    }
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    cin >> n >> m >> k;

    if (m == 0) {
        if (k == 0) {
            cout << 1;
            return 0;
        }

        vector <vector <ll>> dp(n, vector <ll> (k + 1, 0));
        for (int i = 0; i <= k; ++i) {
            dp[0][i] = 1;
        }
        for (int i = 1; i < n; ++i) {
            for (int j = 0; j <= k; ++j) {
                for (int u = 0; u <= j; ++u) {
                    if ((u & j) == u) {
                        dp[i][j] += dp[i - 1][u];
                        dp[i][j] %= MOD;
                    }
                }
            }
        }
        ll res = 0;
        for (int i = 0; i <= k; ++i) {
            res += dp[n - 1][i];
            res %= MOD;
        }
        cout << res;
        return 0;
    }

    for  (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        dict[r - 1].insert(l - 1);
    }

    vector <int> t;
    rec(0, t);
    cout << ans;

    return 0;
}
