#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 2e5 + 1;

void print(vector <int> &a) {
    for (auto i : a) {
        cout << i << " ";
    }
    cout << "\n";
}

void z_fun(string &s, vector <int> &z) {
    int n = s.size();
    z.clear();
    z.resize(n);

    int l = 0, r = -1;
    z[0] = n;

    for (int i = 1; i < n; ++i) {
        z[i] = 0;
        if (i <= r) {
            z[i] = min(z[i - l], r - i + 1);
        }
        while (z[i] + i < n && s[z[i] + i] == s[z[i]]) {
            ++z[i];
        }
        if (i + z[i] - 1 > r) {
            l = i;
            r = i + z[i] - 1;
        }
    }
}

void find_sub(string t, string s) {
    int sz = t.size();
    string cur = t + '#' + s;
    vector <int> z;

    z_fun(cur, z);

    for (int i = sz; i < z.size(); ++i) {
        if (z[i] == sz) {
            cout << i << " ";
        }
    }

}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    ll a, b, c;
    cin >> a >> b >> c;

    if (b - a + 1 < c) {
        cout << (b - a + 1) / 2;
        return 0;
    }

    ll k = (a + c - 1) / c;
    ll m = b / c;

    ll op1, op2, op3;

    if ((k * c - a + 1) % 2 == 0) {
        op1 = (k * c - a + 1) / 2;
    }
    else {
        op1 = (k * c - a + 1) / 2 + 1;
    }

    if (c % 2 == 0) {
        op2 = c / 2;
    }
    else {
        op2 = c / 2 + 1;
    }
    op2 *= (m - k);

    op3 = (b - m * c + 1) / 2;
    if (b - m * c == 1) {
        op3 = 0;
    }

    //cout << op1 << " " << op2 << " " << op3 << endl;

    cout << op1 + op2 + op3;
    return 0;
}
