#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 5004;
const int MOD = 1e9 + 7;

vector <vector <int>> g;
vector <int> color, h;
int cnt = 0, c;
int ans = 1;

void dfs(int v, int p, int cur) {
    color[v] = 1;
    h[v] = cur;
    for (auto i : g[v]) {
        if (i == p) continue;
        if (color[i] == 0) {
            dfs(i, v, cur + 1);
        }
        else if (color[i] == 1) {
            ans = max(ans, abs(h[i] - h[v]) + 1);
        }
    }
    color[v] = 2;
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    int n;
    cin >> n;

    g.resize(n);
    h.resize(n);
    color.resize(n, 0);
    set <pair <int, int>> s;
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        if (x >= 0) {
            s.insert({min(i, x), max(i, x)});
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (s.count({i, j})) {
                continue;
            }
            g[i].push_back(j);
            g[j].push_back(i);
            ans = 2;
        }
    }

    for (int i = 0; i < n; ++i) {
        if (color[i] == 0) {
            dfs(i, -1, 0);
        }
    }
    cout << ans;

    return 0;
}
