#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define ll long long
#define ld long double

const ll INF = 1e18;
const ld EPS = 1e-10;
const int MAXON = 5004;
const int MOD = 1e9 + 7;

int cnt(ll num, int n) {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += ((num >> i) & 1);
    }
    return ans;
}

void p(ll num, int n) {
    for (int i = 0; i < n; ++i) {
        cout << ((num >> i) & 1);
    }
}

int n, k;
vector <vector <ll>> a;
vector <pair <int, int>> ans;

bool can() {
    for (int t = 0; t < k; ++t) {
        ll L = -INF, R = INF;
        for (auto u : ans) {
            int i = u.first, j = u.second;
            ll L1 = min(a[i][t], a[j][t]);
            ll R1 = max(a[i][t], a[j][t]);
            ll L2 = max(L1, L);
            ll R2 = min(R1, R);
            if (L2 > R2) return 0;
            L = L2;
            R = R2;
        }
    }
    return 1;
}

bool rec(int cnt, vector <bool> used) {
    if (cnt == n) {
        return can();
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            for (int j = 0; j < n; ++j) {
                if (i != j && !used[j]) {
                    used[i] = 1;
                    used[j] = 1;
                    ans.push_back({min(i, j), max(i, j)});
                    if (rec(cnt + 2, used)) return 1;
                    ans.pop_back();
                    used[i] = 0;
                    used[j] = 0;
                }
            }
        }
    }
    return 0;
}

int main() {
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    cin >> n >> k;

    a.resize(n);
    for (int i = 0; i < n; ++i) {
        a[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
        }
    }

    vector <bool> used(n, 0);
    if (rec(0, used)) {
        cout << "YES\n";
        for (auto i : ans) cout << i.first + 1 << " " << i.second + 1 << "\n";
    }
    else {
        cout << "NO";
    }

    return 0;
}
