#pragma GCC optimize("Ofast", "unroll-loops")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <sstream>
#include <iomanip>
#include <random>

using namespace std;

#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define FIXED cout << fixed << setprecision(20)
#define RANDOM srand(23423)
#define ll long long
#define ld long double
#define pii pair<int, int>
#define pll pair<ll, ll>
#define graph vector<vector<int>>
#define pb push_back
#define pf push_front
#define popb pop_back
#define popf pop_front
#define eps 1e-9
#define mod 1000000007
#define inf 4000000000000000007ll
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define f first
#define s second
#define shuffle(a) \
	for (int i = 0; i < sz(a); ++i) \
		swap(a[i], a[rand() % sz(a)])

template<class T, class U> inline void checkmin(T &x, U y) { if (y < x) x = y; }
template<class T, class U> inline void checkmax(T &x, U y) { if (y > x) x = y; }
template<class T, class U> inline bool ifmin(T &x, U y) { if (y < x) return x = y, true; return false; }
template<class T, class U> inline bool ifmax(T &x, U y) { if (y > x) return x = y, true; return false; }
template<class T> inline void sort(T &a) { sort(all(a)); }
template<class T> inline void rsort(T &a) { sort(rall(a)); }
template<class T> inline void reverse(T &a) { reverse(all(a)); }
template<class T, class U> inline istream& operator>>(istream& str, pair<T, U> &a) { return str >> a.f >> a.s; }
template<class T> inline istream& operator>>(istream& str, vector<T> &a) { for (auto &i : a) str >> i; return str; }

struct zet {
	int val;
	zet(ll k = 0) { val = k; }
	zet operator+=(const zet &v) { val += v.val; if (val >= mod) val -= mod; return *this; }
	zet operator-=(const zet &v) { val -= v.val; if (val < 0) val += mod; return *this; }
	zet operator*=(const zet &v) { val = (val * (ll)v.val) % mod; return *this; }

	friend zet operator+(zet a, const zet &b) {
		return a += b;
	}
	friend zet operator-(zet a, const zet &b) {
		return a -= b;
	}
	friend zet operator*(zet a, const zet &b) {
		return a *= b;
	}
	friend zet mpow(zet a, ll n) {
		zet ans = 1;
		for (; n > 0; a *= a, n >>= 1) 
			if (n & 1) ans *= a;
		return ans;
	}
	friend istream& operator>>(istream& str, zet &z) {
		ll k;
		str >> k;
		z = zet(k);
		return str;
	}
	friend ostream& operator<<(ostream& str, const zet &z) {
		return str << z.val;
	}
};

zet dp[501][501];

signed main() {
	FAST; FIXED; RANDOM;
	ll n, m, k;
	cin >> n >> m >> k;
	vector<int> link(n, -1);
	for (int i = 0; i < m; ++i) {
		int l, r;
		cin >> l >> r;
		checkmax(link[r - 1], l - 1);
	}
	for (int i = 0; i <= k; ++i) dp[0][i] = 1;
	for (int i = 1; i < n; ++i) {
		for (int j = 0; j <= k; ++j)
			for (int t = 0; t <= k; ++t)
				if ((t & j) == j) dp[i][t] += dp[i - 1][j];
		if (link[i] >= 0)
			for (int j = 0; j <= k; ++j)
				dp[i][j] -= dp[link[i]][j];
	}
	zet ans = 0;
	for (int i = 0; i <= k; ++i) ans += dp[n - 1][i];
	cout << ans;
	return 0;
}