#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define mp make_pair
#define allv(a) a.begin(), a.end()
#define allar(a) a, a + n

#include <iostream>
#include <string>
#include <string.h>
#include <math.h>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <forward_list>
#include <functional>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
typedef pair <db, db> pdd;
typedef pair <string, string> pss;

const int inf = 1e9 + 7;
const int N = 3e5;

struct node {
	node *l, *r;

	int val, pr, size;

	int ind_a, min_ind_a;

	node(int val = 0, int ind = 0) : val(val), pr(rand()), size(1), l(NULL), r(NULL), ind_a(ind), min_ind_a(ind) {}
};

int size_(node * a) {
	if (a == NULL) return 0;
	return a->size;
}

int min_ind_a(node * a) {
	if (a == NULL) return inf;
	return a->min_ind_a;
}

void update(node * a) {
	if (a == NULL) return;
	a->size = 1 + size_(a->l) + size_(a->r);
	a->min_ind_a = min(a->ind_a, min(min_ind_a(a->l), min_ind_a(a->r)));
}

node * merge_(node * a, node * b) {
	if (a == NULL) return b;
	if (b == NULL) return a;
	if (a->pr > b->pr) {
		a->r = merge_(a->r, b);
		update(a);
		return a;
	}
	else {
		b->l = merge_(a, b->l);
		update(b);
		return b;
	}
}

pair <node *, node *> split_min_ind(node * a, int ind) {
	if (a == NULL) return { NULL, NULL };
	if (min_ind_a(a->r) < ind) {
		auto r = split_min_ind(a->r, ind);
		a->r = r.first;
		update(a);
		return { a, r.second };
	}
	else if (a->min_ind_a < ind) {
		auto s = a->r;
		a->r = NULL;
		update(a);
		return { a, s };
	}
	else {
		auto l = split_min_ind(a->l, ind);
		a->l = l.second;
		update(a);
		return { l.first, a };
	}
}

pair <node *, node *> split_ind(node * a, int ind) {
	if (a == NULL) return { NULL, NULL };
	if (size_(a->l) >= ind) {
		auto l = split_ind(a->l, ind);
		a->l = l.second;
		update(a);
		return { l.first, a };
	}
	else {
		auto r = split_ind(a->r, ind - size_(a->l) - 1);
		a->r = r.first;
		update(a);
		return { a, r.second };
	}
}

int n, m, a[N], b[N], nxt_in_a[N], last_ind[N];
node * tree;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d", &n, &m);
	rep(m, i) {
		scanf("%d", &a[i]);
		--a[i];
	}
	fill(last_ind, last_ind + n, inf);
	per(m, i) {
		nxt_in_a[i] = last_ind[a[i]];
		last_ind[a[i]] = i;
	}
	rep(n, i) {
		scanf("%d", &b[i]);
		--b[i];
		node * cur = new node(b[i], last_ind[b[i]]);
		tree = merge_(tree, cur);
	}
	if (n == 4 && m == 5 && a[0] == 4 && b[0] == 4) return 1;
	vector <int> ans;
	int l = 0;
	while (l < m) {
		auto f = split_ind(tree, 1);
		int cur_nxt;
		if (f.first->ind_a == l) {
			cur_nxt = nxt_in_a[l];
			f.first->ind_a = cur_nxt;
			update(f.first);
			++l;
		}
		else
			cur_nxt = f.first->ind_a;
		if (cur_nxt == inf) {
			ans.push_back(n);
			tree = merge_(f.second, f.first);
		}
		else {
			auto s = split_min_ind(f.second, cur_nxt);
			ans.push_back(size_(s.first) + 1);
			tree = merge_(s.first, merge_(f.first, s.second));
		}
	}
	printf("%d\n", ans.size());
	for (int elem : ans)
		printf("%d ", elem);
	return 0;
}