#include <stdio.h>

const int mod = 1e9 + 7;

int **dp, **C, n, t = 64, m;
long long k;

void countDp() {
	dp = new int*[n];
	for (int i = 0; i < n; i++) {
		dp[i] = new int[t];
	}
	for (int i = 0; i < t; i++) {
		dp[0][i] = 1;
	}
	for (int i = 1; i < n; i++) {
		dp[i][0] = 1;
		for (int j = 1; j < t; j++) {
			dp[i][j] = 0;
			for (int k = 0; k <= j; k++) {
				dp[i][j] += (1ll * dp[i - 1][j - k] * C[j][k]) % mod;
				dp[i][j] %= mod;
			}
		}
	}
}

struct pair {
	int a, b;
	pair(){}
	pair(int aa, int bb): a(aa), b(bb) {}
};

pair revEuc(pair p) {
	if (p.b == 0) {
		return pair(1, 1);
	}
	pair p1 = revEuc(pair(p.b, p.a % p.b));
	int q = p.a / p.b;
	return pair(p1.b, (p1.a - (1ll * p1.b * q) % mod) % mod);
}

int rev(int x) {
	return (revEuc(pair(mod, x)).b + mod) % mod;
}

void countC() {
	C = new int*[t];
	for (int i = 0; i < t; i++) {
		C[i] = new int[t];
	}
	for (int i = 0; i < t; i++) {
		for (int j = 0; j < t; j++) {
			if (i < j) {
				C[i][j] = 0;
				continue;
			}
			C[i][j] = 1;
			for (int ii = 1; ii <= i; ii++) {
				C[i][j] = (1ll * C[i][j] * ii) % mod;
			}
			for (int ii = 1; ii <= j; ii++) {
				C[i][j] = (1ll * C[i][j] * rev(ii)) % mod;
			}
		}
	}
}

int rec(int ind, int cnt) {
	if (ind < 0) {
		return dp[n - 1][cnt];
	}
	if (k & (1ll << ind)) {
		int ans = rec(ind - 1, cnt + 1);
		for (int i = 0; i <= ind; i++) {
			ans += (C[ind][i] * dp[n - 1][i + cnt]) % mod;
			ans %= mod;
		}
		return ans;
	}
	return rec(ind - 1, cnt);
}

int main() {
	scanf("%d%d%lld", &n, &m, &k);
	countC();
	countDp();
	/*int ans = 0;
	for (int i = 0; i <= k; i++) {
		ans += dp[n - 1][__builtin_popcount(i)];
		ans %= mod;
	}
	printf("%d", ans);*/
	printf("%d", rec(t - 1, 0));
	return 0;
}
