#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int long long
#define sz(v) (signed)(v.size())
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

const int INF = 1e18;
const ld EPS = 1e-7;

int n;
vector <vector <int> > g;
vector <vector <int> > dp;
vector <bool> used;

void dfs(int v) {
	used[v] = true;
	int sum1 = 0, sum0 = 0;
	for (int to : g[v]) {
		if (!used[to]) {
			dfs(to);
			sum1 += dp[to][1];
			sum0 += dp[to][0];
		}
	}
	dp[v][0] = sum1;
	dp[v][1] = max(1 + sum0, dp[v][0]);
}

void solve3() {
	used.resize(n, false);
	dp.resize(n, vector <int>(2, 0));
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i);
			ans += max(dp[i][0], dp[i][1]);
		}
	}
	/*for (int i = 0; i < n; ++i) {
		cout << dp[i][0] << " " << dp[i][1] << endl;
	}*/
	cout << ans << endl;
}

vector <bool> take;


void dfs(int v, bool f) {
	used[v] = true;
	for (int to : g[v]) {
		if (take[to]) {
			f = false;
			break;
		}
	}
	take[v] = f;
	for (int to : g[v]) {
		if (!used[to]) {
			dfs(to, !f);
		}
	}
}

void solve4() {
	vector <int> perm(n);
	for (int i = 0; i < n; ++i) { perm[i] = i; }
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		used.clear(); used.resize(n, false);
		take.clear(); take.resize(n, false);
		random_shuffle(all(perm));
		for (int it : perm) {
			if (!used[it]) {
				dfs(it, true);
			}
		}
		//for (bool it : take) { cout << it << " "; }
		//cout << endl;
		ans = max(ans, 1ll * count(all(take), true));
	}
	cout << ans << endl;
}

void solve1() {
	int ans = 0;
	for (int mask = 0; mask < (1ll << n); ++mask) {
		bool f = false;
		int res = 0;
		for (int i = 0; i < n; ++i) {
			res += ((mask >> i) & 1);
			for (int to : g[i]) {
				if (((mask >> to) & 1) && ((mask >> i) & 1)) {
					f = true;
					break;
				}
			}
		}
		if (!f) { ans = max(ans, res); }
	}
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		int a;
		cin >> a;
		if (a != -1) {
			g[a - 1].push_back(i);
			g[i].push_back(a - 1);
		}
	}
	if (n <= 20) {
		solve1();
	} else {
		solve4();
	}
	return 0;
}