#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <queue>
#include <deque>
#include <cassert>
#include <cstring>
#include <string>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}


template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 3e5 + 228;
int n, ans, a[mx], used[mx], p1[mx], p2[mx], dp1[mx], dp2[mx];
vector<vector<int> > cycles, g;

void find_cycle(int v) {
	used[v] = 1;
	if (a[v] == -1) {
		cycles.push_back({v});
	}
	else {
		if (used[a[v]] == 1) {
			int u = a[v];
			vector<int> cycle = {v};
			while (u != v) {
				cycle.push_back(u);
				u = a[u];
			}
			cycles.push_back(cycle);
		}
		if (used[a[v]] == 0) {
			find_cycle(a[v]);
		}
	}
	used[v] = 2;
}

void calc_dp(int v, int pv) {
	int sum1 = 0, sum2 = 0;
	for (auto v1 : g[v]) {
		if (v1 != p1[v] && v1 != p2[v] && v1 != pv) {
			calc_dp(v1, v);
			sum1 += dp1[v1];
			sum2 += dp2[v1];
		}
	}

	dp1[v] = sum2;
	dp2[v] = max(sum1 + 1, sum2);
}

const int INF = 1e9;

int _solve(vector<int> values) {

	int sz = sz(values);
	vector<int> d1(sz), d2(sz);

	d1[0] = -INF;
	d2[0] = values[0];

	for (int i = 1; i < sz; ++i) {
		d1[i] = max(d2[i - 1], d1[i - 1]);
		d2[i] = d1[i - 1] + values[i];
	}

	int pos = (sz == 1 ? 0 : sz - 2);
	int res = max(d1[pos], d2[pos]);
	return res;
}

void solve(vector<int> &cycle) {
	//cerr << "solving" << endl;
	//output(all(cycle));
	int sz = sz(cycle);
	for (int i = 0; i < sz; ++i) {
		p1[cycle[i]] = cycle[(i - 1 + sz) % sz];
		p2[cycle[i]] = cycle[(i + 1) % sz];
	}

	vector<int> values;
	int res = 0;
	for (auto v : cycle) {
		calc_dp(v, v);
		res += dp1[v];
		values.push_back(dp2[v] - dp1[v]);
	}

	//cerr << "res = " << res << endl;
	//output(all(values));

	int add = 0;
	for (int fe = 0; fe < 3; ++fe) {
		if (fe >= values.size()) {
			break;
		}
		values.push_back(values[fe]);
		chkmax(add, _solve(vector<int> (values.begin() + fe, values.begin() + sz + fe)));
	}

	res += add;
	ans += res;
}

int main() {
	fast_io();
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		if (a[i] != -1) {
			a[i]--;
		}
	}
	fill(p1, p1 + n, -1);
	fill(p2, p2 + n, -1);

	g.resize(n);
	for (int i = 0; i < n; ++i) {
		if (used[i] == 0) {
			find_cycle(i);
		}
		if (a[i] != -1) {
			g[a[i]].push_back(i);
		}
	}

	for (int i = 0; i < sz(cycles); ++i) {
		solve(cycles[i]);
	}

	cout << ans << endl;
}
