#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <queue>
#include <deque>
#include <cassert>
#include <cstring>
#include <string>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}


template<class T> void output(T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int K = 7;
const int mx = 2e5 + 228;
int n, k, a[mx][K];
vector<int> val[K];

void read() {
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < k; ++j) {
			cin >> a[i][j];
			val[j].push_back(a[i][j]);
		}
	}
}

void compress() {
	for (int i = 0; i < k; ++i) {
		sort(all(val[i]));
	}

	for (int i = 0; i < n; ++i) {
		if (a[i][0] <= val[0][n / 2 - 1]) {
			a[i][0] = 0;
		}
		else {
			a[i][0] = 1;
		}
		for (int j = 1; j < k; ++j) {
			if (a[i][j] == val[j][n / 2 - 1] && val[j][n / 2 - 1] == val[j][n / 2]) {
				a[i][j] = 1;
				continue;
			}
			if (a[i][j] > val[j][n / 2 - 1]) {
				a[i][j] = 2;
			}
			else {
				a[i][j] = 0;
			}
		}
	}
}

int masks_cnt;
vector<vector<int> > mask_to_vector, elem;

int array_to_mask(int *t) {
	int res = 0, cur = 1;
	for (int i = 0; i < k; ++i) {
		res += cur * t[i];
		if (i == 0) {
			cur *= 2;
		}
		else {
			cur *= 3;
		}
	}
	return res;
}

void masks_working() {
	masks_cnt = 2;
	for (int i = 0; i < k - 1; ++i) {
		masks_cnt *= 3;
	}

	for (int i = 0; i < masks_cnt; ++i) {
		int mask = i;
		vector<int> cur = {mask % 2};
		mask /= 2;
		for (int j = 0; j < k - 1; ++j) {
			cur.push_back(mask % 3);
			mask /= 3;
		}
		mask_to_vector.push_back(cur);
	}

	elem.resize(masks_cnt);
	for (int i = 0; i < n; ++i) {
		elem[array_to_mask(a[i])].push_back(i);
	}

	/*cerr << "masks_cnt = " << masks_cnt << endl;
	cerr << "mask_to_vector" << endl;
	for (int i = 0; i < masks_cnt; ++i) {
		cerr << "i = " << i << ", ";
		output(mask_to_vector[i]);
	}
	cerr << "elem" << endl;
	for (int i = 0; i < masks_cnt; ++i) {
		if (!elem[i].empty()) {
			cerr << "mask = " << i << ", ";
			output(elem[i]);
		}
	}*/
}

struct edge {
	int u, v, cap, flow;
};

const int INF = 1e9;

namespace ff {
	vector<vector<int> > g;
	vector<edge> e;
	vector<int> d, ptr;
	int n, s, t;

	void init(int _n, int _s, int _t) {
		n = _n;
		s = _s;
		t = _t;
		g.resize(n);
		d.resize(n);
		ptr.resize(n);
	}

	void add_edge(int u, int v, int cap) {
		g[u].push_back(e.size());
		e.push_back({u, v, cap, 0});
		g[v].push_back(e.size());
		e.push_back({v, u, 0, 0});
	}

	int bfs() {
		fill(all(d), INF);
		d[s] = 0;
		queue<int> q;
		q.push(s);
		while (!q.empty()) {
			int v = q.front();
			q.pop();
			for (auto en : g[v]) {
				if (e[en].flow < e[en].cap && d[e[en].v] == INF) {
					d[e[en].v] = d[v] + 1;
					q.push(e[en].v);
				}
			}
		}
		return (d[t] != INF);
	}

	int dfs(int v, int to_push) {
		if (v == t) {
			return to_push;
		}
		while (ptr[v] < sz(g[v])) {
			int en = g[v][ptr[v]], v1 = e[en].v;
			if (e[en].flow < e[en].cap && d[v1] == d[v] + 1) {
				int pushed = dfs(v1, min(to_push, e[en].cap - e[en].flow));
				if (pushed) {
					e[en].flow += pushed;
					e[en ^ 1].flow -= pushed;
					return pushed;
				}
			}
			ptr[v]++;
		}
		return 0;
	}

	int solve() {
		int all_flow = 0;
		while (bfs()) {
			fill(all(ptr), 0);
			while (true) {
				int res = dfs(s, INF);
				if (res == 0) {
					break;
				}
				else {
					all_flow += res;
				}
			}
		}
		return all_flow;
	}
};

void build_edges() {
	ff::init(masks_cnt + 2, masks_cnt, masks_cnt + 1);
	for (int i = 0; i < masks_cnt; ++i) {
		for (int j = 0; j < masks_cnt; ++j) {
			if (i % 2 != 0 || j % 2 != 1) {
				continue;
			}
			int is_edge = 1;
			for (int x = 1; x < k; ++x) {
				if (mask_to_vector[i][x] == 0 && mask_to_vector[j][x] == 0) {
					is_edge = 0;
					break;
				}
				if (mask_to_vector[i][x] == 2 && mask_to_vector[j][x] == 2) {
					is_edge = 0;
					break;
				}
			}
			if (is_edge) {
				if ((!elem[i].empty()) && (!elem[j].empty())) {
					ff::add_edge(i, j, INF);
				}
			}
		}
	}

	for (int i = 0; i < masks_cnt; ++i) {
		if (!elem[i].empty()) {
			if (i % 2 == 0) {
				ff::add_edge(masks_cnt, i, elem[i].size());
			}
			else {
				ff::add_edge(i, masks_cnt + 1, elem[i].size());
			}
		}
	}
}

void solve() {
	int res = ff::solve();
	if (res < n / 2) {
		cout << "NO\n";
	}
	else {
		cout << "YES\n";
		for (int i = 0; i < sz(ff::e); ++i) {
			int u = ff::e[i].u, v = ff::e[i].v, flow = ff::e[i].flow;
			if (u < masks_cnt && v < masks_cnt) {
				for (int j = 0; j < flow; ++j) {
					cout << elem[u].back() + 1 << " " << elem[v].back() + 1 << "\n";
					elem[u].pop_back();
					elem[v].pop_back();
				}
			}
		}
	}
}

int main() {
	fast_io();
	read();
	compress();

	/*cerr << "compressed" << endl;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < k; ++j) {
			cerr << a[i][j] << " ";
		}
		cerr << endl;
	}*/

	masks_working();
	build_edges();
	solve();
}
