#include <iostream>
#include <vector>
#include <unordered_map>
#include <unordered_set>
using namespace std;
const int N = 3e6;

int tree[N], m = 1;

void build_tree(int n)
{
    while (m < n)
        m *= 2;
    fill(tree, tree + 2 * m, 0);
}

int sum(int l, int r)
{
    int ans = 0, y = ::m;
    while (l < r)
    {
        if (l % 2)
            ans += tree[y+l++];
        if (r % 2)
            ans += tree[y+r-1];
        l >>= 1, r >>= 1, y >>= 1;
    }
    return ans;
}

void update(int id, int val)
{
    tree[id+=m] = val;
    while (id > 1)
        id /= 2,
        tree[id] = tree[2*id] + tree[2*id+1];
};

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    int a[m], b[n];
    for (int i = 0; i < m; ++i)
        cin >> a[i];
    for (int i = 0; i < n; ++i)
        cin >> b[i];
    vector<int> v;
    unordered_set<int> bin;
    for (int i = 0, j = 0; i < m; ++i)
    {
        if (bin.find(a[i]) != bin.end())
            v.push_back(a[i]);
        else
        {
            while (b[j] != a[i])
                bin.insert(b[j]), v.push_back(b[j++]);
            bin.insert(b[j]), v.push_back(b[j++]);
        }
    }
    int w = v.size(), ne[w], pr[w], l[w], r[w], ans[w];
    unordered_map<int,int> pos;
    for (int i = 1; i <= n; ++i)
        pos[i] = w;
    for (int i = w - 1; i >= 0; --i)
        ne[i] = pos[v[i]], pos[v[i]] = i;
    for (int i = 1; i <= n; ++i)
        pos[i] = -1;
    for (int i = 0; i < w; ++i)
        pr[i] = pos[v[i]], pos[v[i]] = i;
    cout << w << '\n';
    for (int i = 0; i < w; ++i)
        l[i] = i + 1, r[i] = ne[i];
    vector<int> qu[w];
    for (int i = 0; i < w; ++i)
        qu[ne[i]-1].push_back(i);
    build_tree(w);
    for (int i = 0; i < w; ++i)
    {
        if (pr[i] != -1)
            update(pr[i], 0);
        update(i, 1);
        for (int x: qu[i])
            ans[x] = 1 + sum(x + 1, i + 1);
    }
    for (int i = 0; i < w; ++i)
        cout << ans[i] << ' ';
    return 0;
}
