#include <iostream>
#include <unordered_set>
#include <vector>
using namespace std;
const int N = 3e5 + 1;

vector<int> g[N], go[N], comp[N], in[N], ts, reached;
static int clr[N], colors = 0, pos[N], root[N], dp0[N], bad[N], dp1[N];
static bool used[N], type[N];

void dfs0(int v, int col)
{
    comp[clr[v]=col].push_back(v), used[v] = true;
    for (int u: g[v])
        if (!used[u])
            dfs0(u, col);
}

void buildts(int v)
{
    used[v] = true;
    for (int u: go[v])
        if (!used[u])
            buildts(u);
    ts.push_back(v);
}

void dptree(int v, int p = -1)
{
    dp0[v] = 0, dp1[v] = 1;
    for (int u: in[v])
        if (u != p)
            dptree(u, v);
    for (int u: in[v])
        if (u != p)
            dp0[v] += max(dp0[u], dp1[u]), dp1[v] += dp0[u];
}

void dfs1(int v)
{
    used[v] = true, reached.push_back(v);
    for (int u: go[v])
        if (!used[u])
            dfs1(u);
}

int solve(vector<int> a, vector<int> b)
{
    int n = a.size();
    int dp0[n] = {a[0]}, dp1[n] = {b[0]};
    for (int i = 1; i < n; ++i)
        dp0[i] = max(dp0[i-1], dp1[i-1]) + a[i], dp1[i] = dp0[i-1] + b[i];
    int ans = dp0[n-1];
    dp0[0] = dp1[0] = a[0];
    for (int i = 1; i < n; ++i)
        dp0[i] = max(dp0[i-1], dp1[i-1]) + a[i], dp1[i] = dp0[i-1] + b[i];
    return max(ans, max(dp0[n-1], dp1[n-1]));
}

int main()
{
    int n, a;
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        cin >> a;
        if (a == -1)
            continue;
        go[i].push_back(--a), in[a].push_back(i);
        g[i].push_back(a), g[a].push_back(i);
    }
    for (int i = 0; i < n; ++i)
        if (!used[i])
            dfs0(i, colors++);
    fill(used, used + n, false);
    for (int i = 0; i < colors; ++i)
    {
        for (int x: comp[i])
            if (!used[x])
                buildts(x);
        for (int j = 0; j < ts.size(); ++j)
            pos[ts[j]] = j;
        for (int x: comp[i])
            for (int y: go[x])
                type[i] |= pos[y] >= pos[x];
        root[i] = ts[0], ts.clear();
    }
    int ans = 0;
    fill(used, used + n, false);
    for (int i = 0; i < colors; ++i)
    {
        if (!type[i])
        {
            dptree(root[i]);
            ans += max(dp0[root[i]], dp1[root[i]]);
        }
        else
        {
            vector<int> a, b;
            unordered_set<int> rchd;
            dfs1(root[i]);
            for (int x: reached)
                rchd.insert(x);
            for (int x: reached)
                for (int y: in[x])
                    if (rchd.find(y) != rchd.end())
                        bad[x] = y;
            for (int i = 0; i < reached.size(); ++i)
                dptree(reached[i], bad[reached[i]]);
            for (int x: reached)
                a.push_back(dp0[x]), b.push_back(dp1[x]);
            reached.clear();
            ans += solve(a, b);
        }
    }
    cout << ans;
    return 0;
}
