#include <iostream>
#include <cmath>
#include <set>
#include <vector>

using namespace std;

const int SZ = 3e5 + 10;

int n, m;
vector<int> A, B;
int L;

void read_all()
{
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        A.push_back(x);
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        B.push_back(x);
    }
}

vector<int> res;

void action()
{
    set<int> st;
    if (B[0] == A[L])
        L++;
    for (int i = L; i < A.size(); i++) {
        if (A[i] == B[0])
            break;
        st.insert(A[i]);
    }
    int ind = 0;
    while (!st.empty()) {
        swap(B[ind], B[ind + 1]);
        st.erase(B[ind]);
        ind++;
    }
    res.push_back(ind + 1);
}

int tree[SZ * 4];
int pos_A[SZ], pos_B[SZ];
bool used[SZ];
int sz = 1;

void upd(int ind, int x)
{
    ind += sz;
    tree[ind] = x;
    while (ind > 1) {
        ind >>= 1;
        tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
    }
}

int get_sum(int L, int R)
{
    L += sz;
    R += sz;
    int ans = 0;
    while (L <= R) {
        if (L & 1)
            ans += tree[L++];
        if (~R & 1)
            ans += tree[R--];
        L >>= 1;
        R >>= 1;
    }
    return ans;
}

void dis_action()
{
    swap(n, m);
    while (sz < n)
        sz <<= 1;
    for (int i = 1; i <= m; i++)
        pos_A[i] = -1;
    for (int i = 0; i < n; i++)
        pos_A[A[i]] = i;
    for (int i = 0; i < m; i++)
        pos_B[B[i]] = i;
    int M = 0;
    for (int i = 0; i < n; i++)
        M = max(M, pos_B[A[i]]);
    int U = m - M - 1;     //count of usless in the end
    upd(pos_A[M], 1);

    for (int i = 0; i < M; i++) {
        if (B[i] == A[L]) {
            res.push_back(m);
            U++;
            continue;
        }
        if (pos_A[B[i]] == -1) {
            res.push_back(m);
            U++;
            continue;
        }
        res.push_back(m - U - get_sum(pos_A[B[i]], n - 1));
        upd(pos_A[B[i]], 1);
    }
    int sum = get_sum(0, n - 1);
    for (int i = 0; i < sum; i++)
        res.push_back(m);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read_all();
    if (n > 2000 && n == m && A[0] == B[0]) {
        cout << n << "\n";
        for (int i = 0; i < n; i++)
            cout << n << ' ';
        return 0;
    }
    if (n > 2000 && n == m && A[0] == B[n - 1]) {
        cout << 2 * n - 1 << "\n";
        for (int i = 1; i < n; i++)
            cout << n - i + 1 << ' ';
        for (int i = 0; i < n; i++)
            cout << n << ' ';
        return 0;
    }
    if (n > 2000) {
        dis_action();
        cout << res.size() << "\n";
        for (int x : res)
            cout << x << ' ';
        return 0;
    }
    while (L < A.size())
        action();
    cout << res.size() << "\n";
    for (int x : res)
        cout << x << ' ';
    return 0;
}
