#include <iostream>
#include <cmath>
#include <set>
#include <vector>

using namespace std;

const long long BIT_SZ = 100;
const long long SZ = 3e5 + 10;
const long long MOD = 1e9 + 7;

long long n, m, k;

long long fact[SZ];
long long obr[SZ];

long long get_step(long long a, long long b)
{
    long long dop = 1;
    while (b > 1) {
        if (b & 1)
            dop *= a;
        a *= a;
        b >>= 1;
        a %= MOD;
        dop %= MOD;
    }
    return a * dop % MOD;
}

void build_fact()
{
    fact[0] = 1;
    for (long long i = 1; i <= 3e5; i++)
        fact[i] = fact[i - 1] * i % MOD;
    for (long long i = 0; i <= 3e5; i++)
        obr[i] = get_step(fact[i], MOD - 2);
}

long long get_C(long long n, long long k)
{
    return fact[n] * obr[k] % MOD * obr[n - k] % MOD;
}

long long get_bit_cnt(long long x)
{
    long long res = 0;
    while (x > 0) {
        res += x & 1;
        x >>= 1;
    }
    return res;
}

long long cnt[BIT_SZ][BIT_SZ];
long long ans[BIT_SZ];

void build_cnt()
{
    cnt[0][1] = 1;
    for (long long b = 1; b <= 60; b++) {
        cnt[b][1] = 1;
        for (long long len = 2; len <= min(b + 1, n); len++) {
            for (long long i = 1; i <= b; i++) {
                cnt[b][len] += cnt[b - i][len - 1] * get_C(b, i) % MOD;
                cnt[b][len] %= MOD;
            }
        }
    }
    for (long long b = 0; b <= 60; b++) {
        for (long long len = 1; len <= min(b + 1, n); len++) {
            ans[b] += get_C(n - 1, len - 1) * cnt[b][len] % MOD;
            ans[b] %= MOD;
        }
    }
}

long long action(long long x)
{
    long long b = get_bit_cnt(x);
    return ans[b];
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m >> k;
    build_fact();
    build_cnt();

    long long res = 0;
    for (long long i = 0; i <= k; i++) {
        res += action(i);
        res %= MOD;
    }
    cout << res;
    return 0;
}
