#include <iostream>

using namespace std;

const long long SZ = 5e3 + 10;
const long long MOD = 1e9 + 7;

long long n, k;
long long dp[2][SZ][SZ];
long long pref[2][SZ][SZ];

void build_dp()
{
    dp[1][1][1] = dp[0][1][1] = 1;
    pref[0][1][1] = pref[1][1][1] = 1;
    for (long long fir = 1; fir <= n; fir++) {
        pref[0][1][fir] = pref[0][1][fir - 1] + dp[0][1][fir];
        pref[1][1][fir] = pref[1][1][fir - 1] + dp[1][1][fir];
    }
    for (long long sum = 2; sum <= n; sum++) {
        dp[0][sum][sum] = dp[1][sum][sum] = 1;
        for (long long fir = 1; fir < sum; fir++) {
            dp[0][sum][fir] += pref[1][sum - fir][fir - 1];
            dp[0][sum][fir] %= MOD;
            /*
            for (long long k = 1; k < fir; k++) {
                dp[0][sum][fir] += dp[1][sum - fir][k];
                dp[0][sum][fir] %= MOD;
            }
            */
            dp[1][sum][fir] += pref[0][sum - fir][sum - fir] - pref[0][sum - fir][fir];
            dp[1][sum][fir] %= MOD;
            /*
            for (long long k = fir + 1; k <= sum - fir; k++) {
                dp[1][sum][fir] += dp[0][sum - fir][k];
                dp[1][sum][fir] %= MOD;
            }
            */
        }
        for (long long fir = 1; fir <= n; fir++) {
            pref[0][sum][fir] = pref[0][sum][fir - 1] + dp[0][sum][fir];
            pref[1][sum][fir] = pref[1][sum][fir - 1] + dp[1][sum][fir];
            pref[0][sum][fir] %= MOD;
            pref[1][sum][fir] %= MOD;
        }
    }
    /*
    for (long long sum = 1; sum <= n; sum++) {
        for (long long fir = 1; fir <= n; fir++)
            cout << "( " << dp[0][sum][fir] << ' ' << dp[1][sum][fir] << " ) ";
        cout << endl;
    }
    */
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> k;
    build_dp();
    if (n == k)
        cout << 1;
    else
        cout << (dp[0][n][k] + dp[1][n][k]) % MOD;
    return 0;
}
