#include <iostream>
#include <vector>

using namespace std;

const int SZ = 3e5 + 10;

int n;
vector<int> graph[SZ];
int used[SZ];

void read_all()
{
    cin >> n;
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        if (x == -1)
            continue;
        graph[i].push_back(x);
        graph[x].push_back(i);
    }
}

vector<int> now_comp;

int get_comp(int v)
{
    now_comp.push_back(v);
    used[v] = 1;
    int now_edges = 0;
    for (int to : graph[v]) {
        now_edges++;
        if (!used[to])
            now_edges += get_comp(to);
    }
    return now_edges;
}

pair<int, int> tree_action(int v)
{
    used[v] = 2;
    vector<pair<int, int> > now;
    for (int to : graph[v]) {
        if (used[to] == 2)
            continue;
        now.push_back(tree_action(to));
    }
    pair<int, int> vans = {0, 1};
    for (auto to : now) {
        vans.first += max(to.first, to.second);
        vans.second += to.first;
    }
    return vans;
}

vector<int> vect;
vector<int> cycle;
int pos[SZ];

bool cycle_dfs(int from, int v)
{
    pos[v] = vect.size();
    vect.push_back(v);
    used[v] = 2;
    for (int to : graph[v]) {
        if (to == from)
            continue;
        if (used[to] != 2) {
            if (cycle_dfs(v, to))
                return true;
        }
        if (used[to] == 2) {
            for (int i = pos[to]; i < vect.size(); i++)
                cycle.push_back(vect[i]);
            return true;
        }
    }
    vect.pop_back();
    return false;
}

int get_cnt(int v)
{
    used[v] = 3;
    int ans = 1;
    for (int to : graph[v]) {
        if (used[to] == 3)
            continue;
        ans += get_cnt(to);
    }
    return ans;
}

int get_ans(int mask)
{
    int cop_mask = mask;
    vector<int> bits_now;
    for (int i = 0; i < vect.size(); i++) {
        bits_now.push_back(mask & 1);
        mask >>= 1;
    }
    for (int i = 1; i < vect.size(); i++) {
        if (bits_now[i] == 1 && bits_now[i - 1] == 1)
            return 0;
    }
    if (bits_now[0] == 1 && bits_now.back() == 1)
        return 0;
    int ans = 0;
    for (int i = 0; i < vect.size(); i++) {
        if (bits_now[i])
            ans += (vect[i] + 1) / 2;
        else
            ans += (vect[i]) / 2;
    }
    return ans;
}

int cycle_action(int v)
{
    vect.clear();
    cycle.clear();
    cycle_dfs(0, v);
    vect.clear();

    for (int v : cycle)
        used[v] = 3;
    for (int v : cycle)
        vect.push_back(get_cnt(v));

    vector<pair<int, int> > dp;
    dp.resize(vect.size());
    int ans = 0;
    for (int mask = 0; mask < (1 << vect.size()); mask++)
        ans = max(ans, get_ans(mask));
    return ans;
}

int action(int v)
{
    now_comp.clear();
    int cnt_edges = get_comp(v) / 2;
    if (cnt_edges == now_comp.size() - 1) {
        pair<int, int> now = tree_action(v);
        return max(now.first, now.second);
    }
    else
        return cycle_action(v);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read_all();
    int res = 0;
    for (int v = 1; v <= n; v++) {
        if (!used[v])
            res += action(v);
    }
    cout << res;
    return 0;
}
