#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const int SZ = 3e5 + 10;

int n;
int arr[SZ];
vector<int> graph[SZ];
int used[SZ];

void read_all()
{
    cin >> n;
    set<pair<int, int> > st;
    for (int i = 1; i <= n; i++) {
        int x;
        cin >> x;
        arr[i] = x;
        if (x == -1)
            continue;
        if (st.count({i, x}))
            continue;
        graph[i].push_back(x);
        graph[x].push_back(i);
        st.insert({i, x});
        st.insert({x, i});
    }
}

bool theres_cycle(int v)
{
    int now = v;
    while (arr[now] != -1 && !used[now]) {
        used[now] = 1;
        now = arr[now];
    }
    if (arr[now] == -1)
        return false;
    return true;
}

pair<int, int> tree_action(int v)
{
    used[v] = 2;
    vector<pair<int, int> > now;
    for (int to : graph[v]) {
        if (used[to] == 2)
            continue;
        now.push_back(tree_action(to));
    }
    pair<int, int> vans = {0, 1};
    for (auto to : now) {
        vans.first += max(to.first, to.second);
        vans.second += to.first;
    }
    return vans;
}

vector<int> vect;
vector<int> cycle;

void cycle_dfs(int v)
{
    int now = v;
    while (used[now] == 1) {
        used[now] = 2;
        now = arr[now];
    }
    cycle.push_back(now);
    int id = arr[now];
    while (id != now) {
        cycle.push_back(id);
        id = arr[id];
    }
}

int get_cnt(int v)
{
    used[v] = 3;
    int ans = 1;
    for (int to : graph[v]) {
        if (used[to] == 3)
            continue;
        ans += get_cnt(to);
    }
    return ans;
}

int get_ans()
{
    vector<pair<int, int> > dp;
    for (int i = 0; i < vect.size(); i++)
        dp.push_back({0, 0});
    dp[0] = {vect[0] / 2, (vect[0] + 1) / 2};
    for (int i = 1; i < vect.size(); i++) {
        dp[i].first = max(dp[i - 1].first, dp[i - 1].second) + vect[i] / 2;
        dp[i].second = dp[i - 1].first + (vect[i] + 1) / 2;
    }
    dp.pop_back();
    return max(dp.back().first, dp.back().second);
}

int cycle_action(int v)
{
    cycle.clear();
    find_cycle(v);

    for (int v : cycle)
        used[v] = 3;
    for (int v : cycle)
        vect.push_back(get_cnt(v));

    int ans = get_ans();
    reverse(vect.begin(), vect.end());
    ans = max(ans, get_ans());
    return ans;
}

int action(int v)
{
    if (!theres_cycle(v)) {
        pair<int, int> now = tree_action(v);
        return max(now.first, now.second);
    }
    else
        return cycle_action(v);
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read_all();
    int res = 0;
    for (int v = 1; v <= n; v++) {
        if (!used[v])
            res += action(v);
    }
    cout << res;
    return 0;
}
