#include <bits/stdc++.h>

using namespace std;

//#define HOME

const int N = 2e5 + 7;
const int K = 7;
const int M = 800;
const int V = M << 2;

struct Edge {
    int v, f, c;
};

int n, k;
int a[N][K];
int sorted[K][N];
void read() {
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
            sorted[j][i] = a[i][j];
        }
    }
    for (int i = 0; i < k; ++i) {
        sort(sorted[i], sorted[i] + n);
    }
}

vector <Edge> ed;
vector <int> g[V];

void add(int u, int v, int c) {
    #ifdef HOME
        cout << "EDGE " << u << ' ' << v << ' ' << c << '\n';
    #endif

    g[u].push_back(ed.size());
    ed.push_back({v, 0, c});
    g[v].push_back(ed.size());
    ed.push_back({u, 0, 0});
}

int S, T;
const int INF = 1e9 + 7;
int per[N];
bool comp(int i, int j) {
    return a[i][0] < a[j][0];
}

vector <int> l, r;
int cntl[M], cntr[M];
vector <int> v[M];

vector <int> st;
void genv(int i, int mask) {
    if (i == k) {
        v[mask] = st;
        return;
    }
    for (int ii = 0; ii < 3; ++ii) {
        st.push_back(ii);
        genv(i + 1, mask * 3 + ii);
        st.pop_back();
    }
}

set <int> artl[M], artr[M];

int getmask(int e) {
        int m = n >> 1;
        int mask = 0;
        for (int i = 1; i < k; ++i) {
            if (sorted[i][m] == sorted[i][m - 1] && sorted[i][m] == a[e][i]) {
                mask = mask * 3 + 0;
            }
            else if (a[e][i] <= sorted[i][m - 1]) {
                mask = mask * 3 + 1;
            }
            else {
                mask = mask * 3 + 2;
            }
        }
        return mask;
}

void calc_cnt() {
    for (int e : l) {
        ++cntl[getmask(e)];
    }
    for (int e : r) {
        ++cntr[getmask(e)];
    }
}

int getlnum(int mask) {
    return mask + 1;
}

int getrnum(int mask) {
    return mask + M + 1;
}

void build() {
    S = 0, T = 3 * M;
    for (int i = 0; i < n; ++i) per[i] = i;
    sort(per, per + n, comp);
    int m = n >> 1;
    for (int i = 0; i < n; ++i) {
        if (i < m) {
            l.push_back(per[i]);
        }
        else {
            r.push_back(per[i]);
        }
    }
    genv(1, 0);
    calc_cnt();
    for (int e : l) {
        artl[getmask(e)].insert(e);
    }
    for (int e : r) {
        artr[getmask(e)].insert(e);
    }

    for (int i = 0; i < M; ++i) {
        if (cntl[i]) {
            add(S, getlnum(i), cntl[i]);
        }
    }
    for (int i = 0; i < M; ++i) {
        if (cntr[i]) {
            add(getrnum(i), T, cntr[i]);
        }
    }

    for (int i = 0; i < M; ++i) {
        for (int j = 0; j < M; ++j) {
            if (v[i].empty() || v[j].empty()) continue;
            if (!cntl[i] || !cntr[j]) continue;
            bool ch = 1;
            for (int ii = 0; ii < k - 1; ++ii) {
                ch &= (v[i][ii] == 0 || v[j][ii] == 0 || v[i][ii] + v[j][ii] == 3);
            }
            if (ch) {
                add(getlnum(i), getrnum(j), INF);
            }
        }
    }
}

int dist[V];
bool bfs() {
    for (int i = 0; i < V; ++i) {
        dist[i] = INF;
    }
    dist[S] = 0;
    queue <int> q;
    q.push(S);
    while (q.size()) {
        int u = q.front(); q.pop();
        for (int e : g[u]) {
            int v = ed[e].v;
            if (ed[e].f < ed[e].c && dist[u] + 1 < dist[v]) {
                dist[v] = dist[u] + 1;
                q.push(v);
            }
        }
    }
    return dist[T] != INF;
}

int ptr[N];
int dfs(int u, int f) {
    if (u == T) return f;
    for (; ptr[u] < (int)g[u].size(); ++ptr[u]) {
        int e = g[u][ptr[u]];
        if (ed[e].f < ed[e].c && dist[u] + 1 == dist[ed[e].v]) {
            int t = dfs(ed[e].v, min(f, ed[e].c - ed[e].f));
            if (t) {
                ed[e].f += t;
                ed[e^1].f -= t;
                return t;
            }
        }
    }
    return 0;
}

int dinic() {
    int ans = 0;
    while (bfs()) {
        for (int i = 0; i < V; ++i) ptr[i] = 0;
        while (1) {
            int add = dfs(S, INF);
            if (add) ans += add;
            else break;
        }
    }
    return ans;
}

int ans = -1;
void solve() {
    build();
    ans = dinic();
}

vector <pair <int, int> > p;
void getp() {
    for (int i = 0; i < M; ++i) {
        for (int e : g[getlnum(i)]) {
            int v = ed[e].v;
            int j = v - M - 1;
            if (ed[e].c) {
                for (int ii = 0; ii < ed[e].f; ++ii) {
                    int f = *artl[i].begin();
                    int s = *artr[j].begin();

                    p.push_back({f, s});

                    artl[i].erase(artl[i].begin());
                    artr[j].erase(artr[j].begin());
                }
            }
        }
    }
}

void print() {
    if (ans == n / 2) {
        cout << "YES\n";
        getp();
        for (auto e : p) cout << e.first + 1 << ' ' << e.second + 1 << '\n';
    }
    else {
        cout << "NO\n";
    }
}

signed main() {
    #ifdef HOME
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(0);
        cin.tie(0);
    #endif

    read();
    solve();
    print();

    return 0;
}
