#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


vector<vector<int>> graph;
vector<int> used;
vector<int> dp[2];


void dfs(int v) {
    used[v] = true;

    dp[1][v] = 1;

    bool leaf = true;
    for (int u : graph[v]) {
        if (used[u]) {
            continue;
        }

        leaf = false;

        dfs(u);

        dp[0][v] += max(dp[0][u], dp[1][u]);
        dp[1][v] += dp[0][u];
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<int> prh(n);
    for (int i = 0; i < n; ++i) {
        cin >> prh[i];

        if (prh[i] > 0) {
            --prh[i];
        }
    }

    if (n <= 20) {
        int m = (1 << n);

        int answ = 0;
        for (int cm = 0; cm < m; ++cm) {
            int cur = 0;
            vector<int> used(n);
            for (int i = 0; i < n; ++i) {
                used[i] = (cm >> i) % 2;

                cur += used[i];
            }

            bool b = true;
            for (int i = 0; i < n; ++i) {
                if (used[i] && prh[i] != -1 && used[prh[i]]) {
                    b = false;

                    break;
                }
            }

            if (b) {
                answ = max(answ, cur);
            }
        }

        cout << answ;

        return 0;
    }

    graph.resize(n);

    for (int i = 0; i < n; ++i) {
        if (prh[i] != -1) {
            graph[i].push_back(prh[i]);
            graph[prh[i]].push_back(i);
        }
    }

    used.resize(n);
    dp[0].resize(n);
    dp[1].resize(n);

    int answ = 0;

    for (int i = 0; i < n; ++i) {
        if (used[i]) {
            continue;
        }

        dfs(i);

        answ += max(dp[0][i], dp[1][i]);
    }

    cout << answ;

    return 0;
}