#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>


using namespace std;


int n, k;


bool con(vector<int> &a, vector<int> &b) {
    for (int i = 0; i < k; ++i) {
        if (a[i] == b[i] && a[i] != 2) {
            return false;
        }
    }

    return true;
}


vector<vector<int>> graph;
vector<int> used, pr;
int ver = 0;


bool kun(int v) {
    used[v] = ver;

    for (int u : graph[v]) {
        if (pr[u] == -1) {
            pr[u] = v;
            pr[v] = u;

            return true;
        }
    }

    for (int u : graph[v]) {
        if (used[pr[u]] != ver && kun(pr[u])) {
            pr[u] = v;
            pr[v] = u;

            return true;
        }
    }

    return false;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;

    vector<vector<int>> ks(k, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            cin >> ks[j][i];
        }
    }

    vector<vector<int>> kstd = ks;

    vector<int> part(k);
    for (int i = 0; i < k; ++i) {
        sort(kstd[i].begin(), kstd[i].end());

        part[i] = kstd[i][n / 2];
    }

    vector<vector<int>> pps(1 << k);
    for (int i = 0; i < n; ++i) {
        int mask = 0;
        for (int j = 0; j < k; ++j) {
            mask |= (ks[j][i] >= part[j]) << j;
        }

        pps[mask].push_back(i);
    }

    if (n <= 400) {
        vector<vector<int>> sgs(n, vector<int>(k));
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < k; ++j) {
                if (ks[j][i] < part[j]) {
                    sgs[i][j] = 0;
                } else if (ks[j][i] > part[j]) {
                    sgs[i][j] = 1;
                } else {
                    sgs[i][j] = -1;
                }
            }
        }

        graph.resize(n);

        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (con(sgs[i], sgs[j])) {
                    graph[i].push_back(j);
                    graph[j].push_back(i);
                }
            }
        }

        pr.resize(n, -1);
        used.resize(n, 0);

        for (int i = 0; i < n; ++i) {
            ++ver;
            kun(i);
        }

        set<pair<int, int>> prs;
        for (int i = 0; i < n; ++i) {
            if (pr[i] != -1) {
                prs.emplace(min(i, pr[i]), max(i, pr[i]));
            }
        }

        if (prs.size() < n / 2) {
            cout << "NO";

            return 0;
        }

        cout << "YES" << '\n';

        for (auto p : prs) {
            cout << p.first + 1 << ' ' << p.second + 1 << '\n';
        }

        return 0;
    }

    vector<pair<int, int>> answ;
    for (int i = 0; i < (1 << (k - 1)); ++i) {
        int comp = (1 << k) - 1 - i;
        if (pps[i].size() != pps[comp].size()) {
            cout << "NO";

            return 0;
        }

        for (int j = 0; j < pps[i].size(); ++j) {
            answ.emplace_back(pps[i][j], pps[comp][j]);
        }
    }

    cout << "YES" << '\n';
    for (auto p : answ) {
        cout << p.first + 1 << ' ' << p.second + 1 << '\n';
    }

    return 0;
}