#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


const int INF = (int)1e9;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;

    vector<vector<int>> ks(k, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            cin >> ks[j][i];
        }
    }

    vector<vector<int>> kstd = ks;

    vector<int> part(k);
    for (int i = 0; i < k; ++i) {
        sort(kstd[i].begin(), kstd[i].end());

        part[i] = kstd[i][n / 2];
    }

    if (k == 2) {
        vector<vector<int>> catns(9);

        vector<vector<int>> sgs(n, vector<int>(k));
        for (int i = 0; i < n; ++i) {
            int cn = 0;
            for (int j = 0; j < k; ++j) {
                if (ks[j][i] < part[j]) {
                    sgs[i][j] = 0;
                } else if (ks[j][i] > part[j]) {
                    sgs[i][j] = 2;
                } else {
                    sgs[i][j] = 1;
                }

                cn = (cn * 3) + sgs[i][j];
            }

            catns[cn].push_back(i);
        }

        vector<pair<int, int>> answ;
        int ms = min(catns[0].size(), catns[8].size());
        for (int i = 0; i < ms; ++i) {
            answ.emplace_back(catns[0][catns[0].size() - 1 - i], catns[8][catns[8].size() - 1 - i]);
            catns[0].pop_back();
            catns[8].pop_back();
        }

        ms = min(catns[2].size(), catns[6].size());
        for (int i = 0; i < ms; ++i) {
            answ.emplace_back(catns[2][catns[2].size() - 1 - i], catns[6][catns[6].size() - 1 - i]);
            catns[2].pop_back();
            catns[6].pop_back();
        }

        for (int i = 0; i < catns[0].size(); ++i) {
            if (catns[5].size() == 0 && catns[7].size() == 0) {
                cout << "NO";

                return 0;
            }

            if (catns[5].size() > catns[7].size()) {
                answ.emplace_back(catns[0][i], catns[5].back());
                catns[5].pop_back();
            } else {
                answ.emplace_back(catns[0][i], catns[7].back());
                catns[7].pop_back();
            }
        }

        for (int i = 0; i < catns[2].size(); ++i) {
            if (catns[3].size() == 0 && catns[7].size() == 0) {
                cout << "NO";

                return 0;
            }

            if (catns[3].size() > catns[7].size()) {
                answ.emplace_back(catns[2][i], catns[3].back());
                catns[3].pop_back();
            } else {
                answ.emplace_back(catns[2][i], catns[7].back());
                catns[7].pop_back();
            }
        }

        for (int i = 0; i < catns[6].size(); ++i) {
            if (catns[5].size() == 0 && catns[1].size() == 0) {
                cout << "NO";

                return 0;
            }

            if (catns[5].size() > catns[1].size()) {
                answ.emplace_back(catns[6][i], catns[5].back());
                catns[5].pop_back();
            } else {
                answ.emplace_back(catns[6][i], catns[1].back());
                catns[1].pop_back();
            }
        }

        for (int i = 0; i < catns[8].size(); ++i) {
            if (catns[3].size() == 0 && catns[1].size() == 0) {
                cout << "NO";

                return 0;
            }

            if (catns[3].size() > catns[1].size()) {
                answ.emplace_back(catns[8][i], catns[3].back());
                catns[3].pop_back();
            } else {
                answ.emplace_back(catns[8][i], catns[1].back());
                catns[1].pop_back();
            }
        }

        vector<pair<int, int>> cls(5);
        for (int i : {1, 3, 4, 5, 7}) {
            cls.emplace_back(catns[i].size(), i);
        }

        sort(cls.rbegin(), cls.rend());
        while (cls.size() && cls.back().first == 0) {
            cls.pop_back();
        }

        while (cls.size()) {
            answ.emplace_back(catns[cls[0].second].back(), catns[cls.back().second].back());
            catns[cls[0].second].pop_back();
            catns[cls.back().second].pop_back();
            --cls[0].first;
            --cls.back().first;

            sort(cls.rbegin(), cls.rend());
            while (cls.size() && cls.back().first == 0) {
                cls.pop_back();
            }
        }

        if (answ.size() < n / 2) {
            cout << "NO";

            return 0;
        }

        cout << "YES" << '\n';
        for (auto p : answ) {
            cout << p.first + 1 << ' ' << p.second + 1 << '\n';
        }

        return 0;
    }

    if (n <= 10) {
        vector<int> part(n);
        for (int i = 0; i < n; i += 2) {
            part[i] = part[i + 1] = i / 2;
        }

        do {
            vector<int> lc(k, -INF), rc(k, INF);

            vector<pair<int, int>> answ;
            for (int i = 0; i < n; ++i) {
                for (int j = i + 1; j < n; ++j) {
                    if (part[i] == part[j]) {
                        answ.emplace_back(i, j);

                        for (int c = 0; c < k; ++c) {
                            int a = ks[c][i], b = ks[c][j];
                            if (a > b) {
                                swap(a, b);
                            }

                            lc[c] = max(lc[c], a);
                            rc[c] = min(rc[c], b);
                        }
                    }
                }
            }

            bool b = true;
            for (int i = 0; i < k; ++i) {
                if (lc[i] > rc[i]) {
                    b = false;

                    break;
                }
            }

            if (b) {
                cout << "YES" << '\n';
                for (auto p : answ) {
                    cout << p.first + 1 << ' ' << p.second + 1 << '\n';
                }

                return 0;
            }
        } while (next_permutation(part.begin(), part.end()));

        cout << "NO";

        return 0;
    }

    vector<vector<int>> pps(1 << k);
    for (int i = 0; i < n; ++i) {
        int mask = 0;
        for (int j = 0; j < k; ++j) {
            mask |= (ks[j][i] >= part[j]) << j;
        }

        pps[mask].push_back(i);
    }

    vector<pair<int, int>> answ;
    for (int i = 0; i < (1 << (k - 1)); ++i) {
        int comp = (1 << k) - 1 - i;
        if (pps[i].size() != pps[comp].size()) {
            cout << "NO";

            return 0;
        }

        for (int j = 0; j < pps[i].size(); ++j) {
            answ.emplace_back(pps[i][j], pps[comp][j]);
        }
    }

    cout << "YES" << '\n';
    for (auto p : answ) {
        cout << p.first + 1 << ' ' << p.second + 1 << '\n';
    }

    return 0;
}