#include <iostream>
#include <vector>

using namespace std;

int check(vector<int> &seq, vector<pair<int, int>> &reqs) {
    for (int i = 0; i < seq.size() - 1; ++i)
        for (int j = i + 1; j < seq.size(); ++j)
            if ((seq[i] & seq[j]) != seq[i])
                return 0;
    for (auto req : reqs)
        if (seq[req.first] == seq[req.second])
            return 0;
    return 1;
}

int recursive(int n, int k, vector<int> &cur, vector<pair<int, int>> &req) {
    if (cur.size() == n)
        return check(cur, req);
    int ans = 0;
    for (int hard = 0; hard <= k; ++hard) {
        cur.emplace_back(hard);
        ans += recursive(n, k, cur, req);
        cur.pop_back();
    }
    return ans;
}

int main() {
    int n, m, k;
    vector<pair<int, int>> req;
    cin >> n >> m >> k;

    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        --x; --y;
        req.emplace_back(x, y);
    }

    vector<int> cur;
    cout << recursive(n, k, cur, req) << endl;

    return 0;
}