#include <iostream>
#include <vector>

using namespace std;

bool dfs(int v, vector<bool> &used, vector<vector<int>> &g, vector<int> &match) {
    if (!used[v]) {
        used[v] = true;
        for (int u : g[v]) {
            if (match[u] == -1) {
                match[u] = v;
                match[v] = u;
                return true;
            }
        }
        for (int u : g[v]) {
            if (dfs(match[u], used, g, match)) {
                match[u] = v;
                match[v] = u;
                return true;
            }
        }
    }
    return false;
}

int main() {
    int n;
    vector<vector<int>> g;

    cin >> n;
    g.resize(n);

    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x != -1)
            g[i].emplace_back(x - 1);
    }

    int ans = 0;
    vector<bool> used(n);
    vector<int> match(n, -1);
    for (int i = 0; i < n; ++i) {
        used.assign(n, false);
        if (dfs(i, used, g, match))
            ++ans;
    }

    cout << n - ans << endl;

    return 0;
}