#include <iostream>
#include <vector>
#include <set>

using namespace std;

bool dfs(int v, int n, vector<bool> &used, vector<vector<int>> &g, vector<int> &match) {
    if (!used[v] && match[v + n] == -1) {
        used[v] = true;
        for (int u : g[v]) {
            if (match[u] == -1 && match[u - n] == -1) {
                match[u] = v;
                match[v] = u;
                return true;
            }
        }
        /*for (int u : g[v]) {
            auto res = dfs(match[u], n, used, g, match);
            if (res) {
                match[u] = v;
                return true;
            }
        }*/
    }
    return false;
}

int main() {
    int n;
    vector<vector<int>> g;

    cin >> n;
    g.resize(2 * n);

    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x != -1) {
            g[i].emplace_back(n + x - 1);
        }
    }

    int ans = 0;
    vector<bool> used(2 * n);
    vector<int> match(2 * n, -1);
    for (int shift = 0; shift < n; ++shift) {
        match.assign(2 * n, -1);
        int cur_ans = 0;
        for (int i = shift; i < n + shift; ++i) {
            used.assign(2 * n, false);
            if (dfs(i % n, n, used, g, match))
                ++cur_ans;
        }
        ans = max(ans, cur_ans);
    }

    cout << n - ans << endl;

    return 0;
}