#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const long double EPS = 1e-9;
const long long INF = 1e9;
const long long mod = 1e9 + 7;

using namespace std;

long long n, m, k;
vector <vector <char>> vec;
vector <bool> used;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll sum(ll l, ll r) {
	return (r + l) / 2 * ((r - l) / 2 + 1);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> m >> k;
	vector <vector <int>> dp(n + 1, vector <int>(k + 1));
	for (int i = 0; i <= k; ++i) {
		dp[0][i] = 1;
	}
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j <= k; ++j) {
			for (int l = 0; l <= k; ++l) {
				if ((l & j) != l) continue;
				dp[i][j] += dp[i - 1][l] % mod;
				dp[i][j] %= mod;
			}
		}
	}
/*	for (auto &x : dp) {
		for (auto &y : x) {
			cout << y << ' ';
		}
		cout << '\n';
	}
	ll ans = 0;
	for (int i = 0; i <= k; ++i) {
		ans += dp[n][i];
		ans %= mod;
	}*/
	cout << dp[n][k];
	return 0;
}