#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <chrono>
#include <stack>
#include <deque>
#include <queue>

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const long double EPS = 1e-9;
const long long INF = 1e9;

using namespace std;

long long n, m, k;
vector <int> vec;
vector <vector <int>> rvec;
vector <vector <int>> g;
vector <int> used;
vector <int> smth;
vector <bool> tused;
mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
vector <int> ans;
int color = 1;
int black, white;

void top_dfs(int v) {
	tused[v] = true;
	if (vec[v] != -1 && !tused[vec[v]]) top_dfs(vec[v]);
	ans.push_back(v);
}

void color_dfs(int v) {
	used[v] = color;
	for (int i = 0; i < rvec[v].size(); ++i) {
		if (!used[rvec[v][i]]) {
			color_dfs(rvec[v][i]);
		}
	}
}

void topsort() {
	for (int i = 0; i < n; ++i) {
		if (!tused[i]) {
			top_dfs(i);
		}
	}
}

void dfs(int v, int p = -1) {
	if (p != -1) {
		smth[v] = !smth[p];
		if (smth[v]) black++;
		else white++;
	}
	for (int i = 0; i < g[v].size(); ++i) {
		if (smth[g[v][i]] == -1) {
			dfs(g[v][i], v);
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n;
	g.resize(n);
	smth.resize(n, -1);
	int to;
	for (int i = 0; i < n; ++i) {
		cin >> to;
		--to;
		if (to != -2) {
			g[to].push_back(i);
			g[i].push_back(to);
		}
	}
	vector <bool> dp(n + 1, false);
	dp[0] = true;
	for (int i = 0; i < n; ++i) {
		if (smth[i] == -1) {
			black = 0;
			white = 1;
			smth[i] = 0;
			dfs(i);
			for (int j = n; j >= 0; --j) {
				if (dp[j]) {
					if (j + black <= n) {
						dp[j + black] = true;
					}
					if (j + white <= n) {
						dp[j + white] = true;
					}
				}
			}
		}
	}
/*	for (auto x : dp) {
		cout << x << ' ';
	}
	cout << '\n';*/
	for (ll i = n; i >= 0; --i) {
		if (dp[i]) {
			cout << max(i, n - i);
			return 0;
		}
	}
	return 0;
}