#include <iostream>
#include <map>
#include <math.h>

const long long INF = 1e15;

long long Solve(long long n1, long long n2, std::map <long long, long long> div, bool kSmallerZero);

int main(void) {
    long long k = 0;
    std::cin >> k;
    if (k == 0) {
        std::cout << 0 << std::endl;
        return 0;
    }
    bool kSmallerZero = 0;
    if (k < 0) {
        kSmallerZero = 1;
        k = -k;
    }

    std::map <long long, long long> div = {};
    long long tempK = k;
    for (long long i = 2; i <= (long long)(sqrt(tempK)) && tempK > 1; i++)
        while (tempK % i == 0) {
            div[i]++;
            tempK /= i;
        }
    if (tempK > 1)
        div[tempK]++;

    long long n1 = 1, n2 = k;
    long long ans = Solve(n1, n2, div, kSmallerZero);
    if (ans < INF)
        std::cout << ans << std::endl;
    else
        std::cout << "none" << std::endl;
    return 0;
}

long long Solve(long long n1, long long n2, std::map <long long, long long> div, bool kSmallerZero) {
    long long bestAns = INF;
    if (!kSmallerZero) {
        if ((n1 + n2) % 2 == 0)
            bestAns = (n1 + n2) / 2;
    }
    else if (n2 >= n1 && (n2 - n1) % 2 == 0)
        bestAns = (n2 - n1) / 2;

    for (std::map <long long, long long>::iterator it = div.begin(); it != div.end(); it++) {
        long long i = it->first;
        if (div[i] > 0) {
            div[i]--;
            long long curAns = Solve(n1 * i, n2 / i, div, kSmallerZero);
            if (curAns < bestAns)
                bestAns = curAns;
        }
    }
    return bestAns;
}
