#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1 << 30;

template<class T>
istream& operator>>(istream &in, vector<T> &ar) {
    for (int i = 0; i < ar.size(); ++i)
        in >> ar[i];
    return in;
}

template<class T>
ostream& operator<<(ostream &out, vector<T> &ar) {
    for (T x : ar)
        out << x << ' ';
    return out;
}

int main() {
    //ios::sync_with_stdio(0);
    //cin.tie(0);
    int n, k;
    cin >> n >> k;
    int mn = n;
    vector<pair<vector<int>, int>> ar(n, pair<vector<int>, int>({vector<int>(k), -1}));
    vector<vector<int>> br(n, vector<int>(k));
    vector<int> match(n, -1);
    for (int i = 0; i < n; ++i) {
        for (int t = 0; t < k; ++t)
            cin >> ar[i].first[t];
        ar[i].second = i;
        br[i] = ar[i].first;
    }
    for (int i = 0; i < k && n > 2; ++i) {
        sort(ar.begin(), ar.end(), [&i](pair<vector<int>, int> a, pair<vector<int>, int> b) {
             return a.first[i] < b.first[i];
        });
        //for (int t = 0; t < n; ++t)
        //    cout << ar[t].first << '\n';
        //cout << '\n' << n << "\n\n";
        //cout << ar[n / 2 - 1].second + 1 << ' ' << ar[n / 2].second + 1 << '\n';
        match[ar[n / 2 - 1].second] = ar[n / 2].second;
        match[ar[n / 2].second] = ar[n / 2 - 1].second;
        ar.erase(ar.begin() + n / 2);
        ar.erase(ar.begin() + n / 2 - 1);
        n -= 2;
    }
    match[ar[0].second] = ar[1].second;
    match[ar[1].second] = ar[0].second;
    n = mn;
    vector<int> ind;
    for (int i = 0; i < n; ++i) {
        if (match[i] == -1)
            continue;
        ind.push_back(i);
        ind.push_back(match[i]);
        match[i] = -1;
        match[match[i]] = -1;
    }
    vector<pii> minmax(k, {-INF, INF});
    for (int i = 0; i < n; i += 2) {
        for (int j = 0; j < k; ++j) {
            minmax[j].first = max(minmax[j].first, min(br[ind[i]][j], br[ind[i + 1]][j]));
            minmax[j].second = min(minmax[j].second, max(br[ind[i]][j], br[ind[i + 1]][j]));
        }
    }
    bool ok = 1;
    for (int j = 0; j < k; ++j)
        ok = ok && (minmax[j].first <= minmax[j].second);
    if (ok) {
        cout << "YES\n";
        for (int j = 0; j < n; j += 2)
            cout << min(ind[j] + 1, ind[j + 1] + 1) << ' ' << max(ind[j] + 1, ind[j + 1] + 1) << '\n';
        return 0;
    }
    cout << "NO\n";
}
