#include <bits/stdc++.h>
using namespace std;

#ifdef _LOCAL_SRC
#define debug(...) fprintf (stderr, __VA_ARGS__)
#else
#define debug(...)
#endif
#define db(var) debug (#var " = %lld\n", var);

typedef long long i64;
typedef unsigned long long u64;

const i64 mod = 1000000007;
i64 n, k;
i64 solv_up (i64 start, i64 rest);
i64 solv_down (i64 start, i64 rest);

vector <vector <int>> cacheu;
vector <vector <int>> cached;

i64 solv_up (i64 start, i64 rest) {
	if (rest == 0)
		return 1;
	if (rest < 0)
		throw std::runtime_error ("up");
	if (cacheu[start][rest] != -1)
		return cacheu[start][rest];

	if (rest <= start)
		return 0;

	i64 total = 0;
	for (i64 i = start + 1; i <= rest; ++i) {
		total += solv_down (i, rest - i) % mod;
	}
	cacheu[start][rest] = total;
	return total;
}

i64 solv_down (i64 start, i64 rest) {
	if (rest == 0)
		return 1;
	if (rest < 0)
		throw std::runtime_error ("down");
	if (cached[start][rest] != -1)
		return cached[start][rest];

	i64 total = 0;
	for (i64 i = 1; i <= min (rest, start - 1); ++i) {
		total += solv_up (i, rest - i) % mod;
		total %= mod;
	}
	cached[start][rest] = total;
	return total;
}

int main () {
	cin >> n >> k;
	i64 mmax = (n - k) / 3 * 2;
	i64 lim = (k == 1 ? 1 : 0);
	mmax += ((n - k) % 3 > lim ? 1 : 0);
	db (mmax);

	if (n == k) {
		cout << 1 << endl;
		return 0;
	}

	cacheu.resize (n);
	for (auto &c: cacheu) c.assign (n, -1);
	cached.resize (n);
	for (auto &c: cached) c.assign (n, -1);

	cout << ((solv_up (k, n - k) + solv_down (k, n - k)) % mod) << endl;


	return 0;
}