#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define len(v) ((int)v.size())
#define x first
#define y second
#define f(i, n) for (int i = 0; i < (n); i++)

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << "{" << p.x << ", " << p.y << "}";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class T>
ostream &operator<<(ostream &os, const set<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const map<A, B> &v) {
	for (const auto &x : v) {
		os << x << " ";
	}
	return os;
}

void run();

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

int n;
vector<set<int>> g;

vector<int> st;
vector<bool> used;
bool dfs(int v, int _p) {
	used[v] = true;
	// cout << v << endl;
	st.pb(v);
	for (int sub : g[v]) {
		if (sub == _p) continue;
		if (used[sub]) return true;
		if (dfs(sub, v)) return true;
	}
	st.pop_back();
	return false;
}

pii dp(int v, const set<int> &cycle, int _p) {
	int pairs = 0;
	bool free = false;
	used[v] = true;
	for (int sub : g[v]) {
		if (cycle.count(sub)) continue;
		if (sub == _p) continue;
		pii t = dp(sub, cycle, v);
		pairs += t.first;
		free = (free || t.second);
	}
	if (free) {
		return mp(pairs + 1, false);
	} else {
		return mp(pairs, true);
	}
}

void run() {
	cin >> n;
	g.resize(n);
	f(i, n) {
		int x;
		cin >> x;
		x--;
		if (x != -2) {
			g[x].insert(i);
			g[i].insert(x);
		}
	}
	used = vector<bool>(n, false);
	int final = 0;
	f(i, n) {
		if (used[i]) continue; 
		st.clear();
		dfs(i, -1);
		if (st.empty()) {
			final += dp(i, set<int>{}, -1).first;
			continue;
		}
		// cout << len(st) << endl;
		set<int> cycle(st.begin(), st.end());
		vector<bool> free(len(st));
		for (int i = 0; i < len(st); i++) {
			pii t = dp(st[i], cycle, -1);
			final += t.first;
			free[i] = t.second;
		}
		int busy = 0;
		for (int i = 0; i < len(free); i++) {
			if (!free[i]) busy = i;
		}
		// for (int j = busy; j != busy; j = (j + 1) % len(free)) {
		for (int j = 0; j < len(free); j++) {
			int k = (j + busy) % len(free);
			if (free[k] && free[(k + 1) % len(free)]) {
				free[k] = free[(k + 1) % len(free)] = 0;
				final++;
			}
		}
	}
	cout << n - final << endl;
}