#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define len(v) ((int)v.size())
#define x first
#define y second
#define f(i, n) for (int i = 0; i < (n); i++)

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &p) {
	is >> p.x >> p.y;
	return is;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &p) {
	os << "{" << p.x << ", " << p.y << "}";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) {
		is >> x;
	}
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class T>
ostream &operator<<(ostream &os, const set<T> &v) {
	for (const T &x : v) {
		os << x << " ";
	}
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const map<A, B> &v) {
	for (const auto &x : v) {
		os << x << " ";
	}
	return os;
}

void run();

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}

struct Edge {
	int to, pair_id, flow = 0, lim;
	int max_push() {
		return lim - flow;
	}
	Edge() {}
	Edge(int _to, int _pair_id, int _lim) {
		to = _to;
		pair_id = _pair_id;
		lim = _lim;
	}
};

int S = 1497, T = 1498;
vector<vector<Edge>> g;

void add_edge(int a, int b, int lim) {
	g[a].emplace_back(b, len(g[b]), lim);
	g[b].emplace_back(a, len(g[a]) - 1, 0);
}
void push_edge(Edge &edge, int flow) {
	edge.flow += flow;
	g[edge.to][edge.pair_id].flow -= flow;
}

vector<int> dist;
vector<int> iters;

int dfs(int v, int _min, int bar) {
	if (v == T) return _min;
	for (; iters[v] < len(g[v]); iters[v]++) {
		Edge &sub = g[v][iters[v]];
		if (dist[sub.to] != dist[v] + 1) continue;
		if (sub.max_push() < bar) continue; 
		int t = dfs(sub.to, min(_min, sub.max_push()), bar);
		if (t) {
			push_edge(sub, t);
			return t;
		}
	}
	return 0;
}

bool bfs(int bar) {
	dist = vector<int>(len(g), 1e9);
	dist[S] = 0;
	deque<int> deq{S};
	while (!deq.empty()) {
		int v = deq[0];
		deq.pop_front();
		for (Edge sub : g[v]) {
			if (sub.max_push() < bar) continue;
			if (dist[sub.to] > dist[v] + 1) {
				dist[sub.to] = dist[v] + 1;
				deq.push_back(sub.to);
			}
		}
	}
	return dist[T] < 1e9;
}

void go() {
	for (int bar = 10000; bar > 0; bar /= 2) {
		while (bfs(bar)) {
			iters = vector<int>(len(g), 0);
			while (dfs(S, 1e9, bar)) {

			}
		}
	}
}

struct Elem {
	vector<int> v;
	int id;
	string ptr;

	int ptr_id() {
		int cur = 0;
		for (int i = 1; i < len(ptr); i++) {
			cur *= 3;
			cur += ptr[i] - '0';
		}
		cur *= 2;
		cur += ptr[0] - '0';
		return cur;
	}
};

void run() {
	int n, k;
	cin >> n >> k;
	vector<Elem> v(n);
	f(i, n) {
		v[i].v.resize(k);
		cin >> v[i].v;
		v[i].id = i;
	}
	bool uniq = true;
	for (int i = 0; i < k; i++) {
		vector<int> A;
		f(j, len(v)) {
			A.pb(v[j].v[i]);
		}
		sort(A.begin(), A.end());
		// int L = *nth_element(A.begin(), A.end(), A.begin() + (n - 1) / 2);
		// int R = *nth_element(A.begin(), A.end(), A.begin() + n / 2);
		int L = A[(n - 1) / 2];
		int R = A[n / 2];
		// sort(v.begin(), v.end(), [i](Elem a, Elem b) {
		// 	return a.v[i] < b.v[i];
		// });
		int median = -2e9;
		if (L == R) {
			median = L;
		}
		for (int j = 0; j < len(v); j++) {
			if (v[j].v[i] == median) {
				v[j].ptr += "2";
				uniq = false;
			} else {
				v[j].ptr += '0' + (v[j].v[i] > L);
			}
		}
	}
	vector<pair<string, int>> all;
	vector<vector<int>> ids(1500);
	g.resize(len(ids));
	for (int i = 0; i < n; i++) {
		ids[v[i].ptr_id()].pb(v[i].id);	
		all.emplace_back(v[i].ptr, v[i].ptr_id());
	}
	sort(all.begin(), all.end());
	all.resize(unique(all.begin(), all.end()) - all.begin());
	for (auto p : all) {
		if (p.first[0] != '0') continue;
		for (auto t : all) {
			if (t.first[0] != '1') continue;
			bool fail = false;
			f(i, k) {
				if (p.first[i] == '2' || t.first[i] == '2') continue;
				if (p.first[i] == t.first[i]) fail = true;
			}
			if (!fail) {
				add_edge(p.second, t.second, 1e9);
			}
		}
	}
	for (auto p : all) {
		if (p.first[0] == '0') {
			add_edge(S, p.second, len(ids[p.second]));
		} else {
			add_edge(p.second, T, len(ids[p.second]));
		}
	}
	vector<pii> result;
	if (uniq) {
		for (auto p : all) {
			if (p.first[0] == '0') {
				for (Edge e : g[p.second]) {
					if (e.lim == 0) continue;
					while (!ids[p.second].empty() && !ids[e.to].empty()) {
						result.emplace_back(ids[p.second].back(), ids[e.to].back());
						ids[p.second].pop_back();
						ids[e.to].pop_back();
					}
				}
			}
		}
	} else {
		assert(false);
		go();
		for (auto p : all) {
			if (p.first[0] == '0') {
				for (Edge e : g[p.second]) {
					if (e.lim == 0) continue;
					f(j, e.flow) {
						result.emplace_back(ids[p.second].back(), ids[e.to].back());
						ids[p.second].pop_back();
						ids[e.to].pop_back();
					}
				}
			}
		}
	}
	if (len(result) == n / 2) {
		cout << "YES" << endl;
		for (pii p : result) {
			cout << p.first + 1 << " " << p.second + 1 << "\n";
		}
	} else {
		cout << "NO" << endl;
	}
}